﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Gestor_de_informacion
{
    class Funciones
    {
        private BBDDBMDataContext bbdd = new BBDDBMDataContext();

        /// <summary>
        /// Hacemos una consulta SQL para ver los pacientes
        /// </summary>
        /// <returns>ListaPacientes</returns>
        public List<PacientesBM> CargarCbPacientes()
        {
            
            List<PacientesBM> ListaPacientes = new List<PacientesBM>();
            try
            {
                var resultado = (from consulta in bbdd.PacientesBMs
                                 join consulta_2 in bbdd.TerapiaBMs on consulta.IdPaciente equals consulta_2.IdPaciente
                                 orderby consulta_2.IdPaciente
                                 select consulta).ToList().Distinct();

                ListaPacientes = resultado.ToList();

                return ListaPacientes;
            }
            catch (Exception ex)
            {
                return ListaPacientes;
            }
        }
        /// <summary>
        /// Hacemos una consulta SQL para ver el tipo de terapia
        /// </summary>
        /// <returns>ListaTipoTerapia</returns>
        public List<TerapiaBM> CargarCbTipoTerapia()
        {
            List<TerapiaBM> ListaTipoTerapia = new List<TerapiaBM>();
            try
            {
                var resultado = (from consulta in bbdd.TerapiaBMs
                                 orderby consulta.TipoTerapia
                                 select consulta).Distinct();

                ListaTipoTerapia = resultado.ToList();

                return ListaTipoTerapia;
            }
            catch (Exception ex)
            {
                return ListaTipoTerapia;
            }
        }

        /// <summary>
        /// Recibiendo la identidad del paciente y el Tipo de terapia hacemos una consulta SQL para obtener las terapias
        /// </summary>
        /// <param name="idPaciente"></param>
        /// <param name="TerapiaTipo"></param>
        /// <returns>ListaTerapia</returns>
        /// 
        public List<TerapiaBM> CargarCbTerapias(string idPaciente, string TerapiaTipo)
        {
            List<TerapiaBM> ListaTerapia = new List<TerapiaBM>();
            try
            {

                var resultado = (from consulta in bbdd.TerapiaBMs
                                 where consulta.IdPaciente == int.Parse(idPaciente) && consulta.TipoTerapia == int.Parse(TerapiaTipo)
                                 orderby consulta.IdTerapia
                                 select  consulta ).Distinct();


                ListaTerapia = resultado.ToList();

                return ListaTerapia;
            }
            catch (Exception ex)
            {
                return ListaTerapia;
            }
        }

        public List<TerapiaBM> CargarCbTerapiasInforme(string idPaciente)
        {
            List<TerapiaBM> ListaTerapiaInforme = new List<TerapiaBM>();
            try
            {

                var resultado = (from consulta in bbdd.TerapiaBMs
                                 where consulta.IdPaciente == int.Parse(idPaciente)
                                 orderby consulta.IdTerapia
                                 select consulta).Distinct();


                ListaTerapiaInforme = resultado.ToList();

                return ListaTerapiaInforme;
            }
            catch (Exception ex)
            {
                return ListaTerapiaInforme;
            }
        }




    }
}
