﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Gestor_de_informacion
{
    /// <summary>
    /// Lógica de interacción para MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        string directorioImagenes = System.AppDomain.CurrentDomain.BaseDirectory + "R\\"; //nos dice la url donde guardar las imagenes
        public RScriptRunner objetoR = new RScriptRunner();     //Lo empleamos para comunicarnos con los scripts de R
        private string rutaR = "C:\\Program Files\\R\\R-3.1.2\\bin\\Rscript.exe";   //Ruta para usar Rscript.exe que nos permite ejecutar los scripts

        public MainWindow()
        {
            InitializeComponent();
        }

        private void B_Analizar_Terapia(object sender, RoutedEventArgs e)
        {
            //Llamamos a la ventana Analizar Terapia
            W_AnalizarTerapia V_Terapia = new W_AnalizarTerapia();
            V_Terapia.Owner = this;
            V_Terapia.ShowDialog();
        }

        private void B_Compararterapias(object sender, RoutedEventArgs e)
        {
            //Llamamos a la ventana Analizar Terapia
            W_CompararTerapias V_ComparaTerapias = new W_CompararTerapias();
            V_ComparaTerapias.Owner = this;
            V_ComparaTerapias.ShowDialog();
        }

        private void B_Evolucion(object sender, RoutedEventArgs e)
        {
            //Llamamos a la ventana Analizar Terapia
            W_Evolucion V_Evolucion = new W_Evolucion();
            V_Evolucion.Owner = this;
            V_Evolucion.ShowDialog();
        }

        private void B_CompararEvoluciones(object sender, RoutedEventArgs e)
        {
            //Llamamos a la ventana Comparar evolucion
            W_CompararEvolucion V_ComparaEvolucion = new W_CompararEvolucion();
            V_ComparaEvolucion.Owner = this;
            V_ComparaEvolucion.ShowDialog();
        }

        private void B_Imprimir(object sender, RoutedEventArgs e)
        {
            //Llamamos a la ventana Imprimir Informe
            MessageBox.Show("El informe sólo imprimirá los datos actualizados, si hay nuevos datos se recomienda actualizar antes de imprimir el informe");
            W_ImprimirInforme V_Imprimir = new W_ImprimirInforme();
            V_Imprimir.Owner = this;
            V_Imprimir.ShowDialog();
        }

        public void B_Actualizar(object sender, RoutedEventArgs e)
        {
            //Llamamos al Script e R de Actualizar
            string directorioScriptR = directorioImagenes + "Actualizacion.R";
            string parametros = directorioImagenes;
            string resultado = objetoR.RunFromCmd(directorioScriptR, rutaR, parametros);

        }

        private void B_Salir(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            RScriptRunner R = new RScriptRunner();

            string directorioScriptR = directorioImagenes + "Comprobar_Actualizacion.R";
            string parametros = directorioImagenes;
            string resultado = objetoR.RunFromCmd(directorioScriptR, rutaR, parametros);
            int Resutado_final;
            string[] Quitar_Espacios = resultado.Split(null);

            Resutado_final = int.Parse(Quitar_Espacios[1]);

            if (Resutado_final > 50 & Resutado_final < 101)
            {

                MessageBoxResult result = MessageBox.Show("Se tienen más de 50 terapias sin actualizar sería conveniente actualizar.¿Desea actualizar?", "Actualización del programa", MessageBoxButton.YesNo);
                switch (result)
               {
                    case MessageBoxResult.Yes:
             directorioScriptR = directorioImagenes + "Actualizacion.R";
             parametros = directorioImagenes;
             resultado = objetoR.RunFromCmd(directorioScriptR, rutaR, parametros);
                        break;
                    case MessageBoxResult.No:
                        break;
      
                }
 
            }
            if (Resutado_final > 100 & Resutado_final < 251)
            {
                MessageBoxResult result = MessageBox.Show("Se tienen más de 100 terapias sin actualizar los informes que puedas imprimir estarán desactualizados y las evoluciones de pacientes tardaran más tiempo de lo normal en realizarse.Se recomienda actualizar.", "Actualización del programa", MessageBoxButton.YesNo);
                switch (result)
                {
                    case MessageBoxResult.Yes:
                        directorioScriptR = directorioImagenes + "Actualizacion.R";
                        parametros = directorioImagenes;
                        resultado = objetoR.RunFromCmd(directorioScriptR, rutaR, parametros);
                        break;
                    case MessageBoxResult.No:
                        break;

                }
 
            }
            if (Resutado_final > 251)
            {
                MessageBoxResult result = MessageBox.Show("Se tienen demasiadas terapias sin actualizar los informes que puedas imprimir estarán muy desactualizados y las evoluciones de pacientes tardaran mucho más tiempo de lo normal en realizarse. Se recomienda actualizar imediatamente.", "Actualización del programa", MessageBoxButton.YesNo);
                switch (result)
                {
                    case MessageBoxResult.Yes:
                        directorioScriptR = directorioImagenes + "Actualizacion.R";
                        parametros = directorioImagenes;
                        resultado = objetoR.RunFromCmd(directorioScriptR, rutaR, parametros);
                        break;
                    case MessageBoxResult.No:
                        break;

                }
 
            } 
       }
        

    } 
}
