﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Interop;
using System.Net.Cache;

namespace Gestor_de_informacion
{
    /// <summary>
    /// En esta ventana vamos a analizar gráficamente los resultados que obtenemos en una sola terapia, nos muestra como es la trayectoria
    /// que se ha realizado durante la terapia asi como nos permite analizar varios de sus valores como son fuerza, aceleracion y velocidad
    /// tanto en x como en y, también se nos permite seleccionar que terapia queremos ver en funcion del paciente y tipo de terapia que escojamos y
    /// además nos permite seleccionar que gráfica en funcion de la terapia para analizar mejor los datos, además cuenta con la posibilidad de imprimir
    /// lo que estamos viendo.
    /// </summary>
    public partial class W_AnalizarTerapia : Window
    {
        //Llamamos a funciones
        Funciones f = new Funciones();
   
        string directorioImagenes = System.AppDomain.CurrentDomain.BaseDirectory + "R\\"; //nos dice la url donde guardar las imagenes
        string idPaciente;      
        string TerapiaTipo;     
        string Terapia;
        string rutaanalisis;
        int tiempo1;
        int tiempo2;
        public RScriptRunner objetoR = new RScriptRunner();     //Lo empleamos para comunicarnos con los scripts de R
        private string rutaR = "C:\\Program Files\\R\\R-3.1.2\\bin\\Rscript.exe";   //Ruta para usar Rscript.exe que nos permite ejecutar los scripts

        public W_AnalizarTerapia()
        {
            InitializeComponent();

        }

        private void B_Volver(object sender, RoutedEventArgs e)
        {
            //Boton para cerrar esta pantalla
            this.Close();
        }

        private void B_Analizar(object sender, RoutedEventArgs e)
        {
                if (string.IsNullOrWhiteSpace(this.TB_Tiempo1.Text))
            {
                tiempo1 = 0;
            }
            else {
                tiempo1 = int.Parse(TB_Tiempo1.Text);
            }
                if (string.IsNullOrWhiteSpace(this.TB_Tiempo2.Text))
                {
                    tiempo2 = 0;
                }
                else
                {
                    tiempo2 = int.Parse(TB_Tiempo2.Text);
                }
            if (CB_Paciente.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione un paciente.");
            }
            else if (CBTipoTerapia.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione un tipo de terapia.");
            }
            else if (CB_Terapia.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione una terapia.");
            }
            else if (CB_Graficas.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione una gráfica.");
            }

            if (RB_Tiempo.IsChecked == false & RB_Valor.IsChecked == false) 
           {
               MessageBox.Show("Por favor seleccione tiempo o valor.");

           }

            if (RB_Tiempo.IsChecked   == true) 
            {
                if (tiempo1 > tiempo2)
                {
                    MessageBox.Show("El tiempo inicial no puede ser mayor que el final.");
                }
                else if (tiempo1 == tiempo2)
                {
                    MessageBox.Show("El tiempo inicial y final tienen que ser distintos.");
                }
                else if (tiempo2>305)
                {
                    MessageBox.Show("El tiempo debe de ser inferior a 5 minutos (300 segundos).");
                }

                else {
                    //Llamamos a R introducimos los parámetros que necesitamos
                    RScriptRunner R = new RScriptRunner(); 
                    string directorioScriptR = directorioImagenes + "Trayectoria.R";
                    string parametros = System.AppDomain.CurrentDomain.BaseDirectory + " " + Terapia + " " + 0;
                    string result = objetoR.RunFromCmd(directorioScriptR, rutaR, parametros);
                    //Llamaos a Cargar Gráfica para que nos ponga la grafica que se ha imprimido en la inamgen
                    CargarGrafica1(directorioImagenes + "Terapia" + Terapia + ".png");

                    switch (CB_Graficas.SelectedIndex)
                    {
                            //Segun el tipo de gráfica que seleccionemos llama a R y carga la imagen para tiempo
                        case 0:
                            
                            RScriptRunner R0 = new RScriptRunner();
                            string directorioScriptR0 = directorioImagenes + "Velocidadx.R";
                            string parametros0 = System.AppDomain.CurrentDomain.BaseDirectory + " " + tiempo1 + " " + tiempo2 + " " + Terapia + " " + 0;
                            string result0 = objetoR.RunFromCmd(directorioScriptR0, rutaR, parametros0);   
                            CargarGrafica2(directorioImagenes + "VelocidadxTerapia" + Terapia + ".png");
                           
                            
                            break;
                        case 1:
                            RScriptRunner R1 = new RScriptRunner();
                            string directorioScriptR1 = directorioImagenes + "Aceleracionx.R";
                            string parametros1 = System.AppDomain.CurrentDomain.BaseDirectory + " " + tiempo1 + " " + tiempo2 + " " + Terapia + " " + 0;
                            string result1 = objetoR.RunFromCmd(directorioScriptR1, rutaR, parametros1);   
                            CargarGrafica2(directorioImagenes + "AceleracionxTerapia" + Terapia + ".png");                          
                            break;
                        case 2:
                            RScriptRunner R2 = new RScriptRunner();
                            string directorioScriptR2 = directorioImagenes + "Fuerzasx.R";
                            string parametros2 = System.AppDomain.CurrentDomain.BaseDirectory + " " + tiempo1 + " " + tiempo2 + " " + Terapia + " " + 0;
                            string result2 = objetoR.RunFromCmd(directorioScriptR2, rutaR, parametros2);   
                            CargarGrafica2(directorioImagenes + "FuerzasxTerapia" + Terapia + ".png");
                            break;
                        case 3:
                            RScriptRunner R3 = new RScriptRunner();
                            string directorioScriptR3 = directorioImagenes + "Velocidady.R";
                            string parametros3 = System.AppDomain.CurrentDomain.BaseDirectory + " " + tiempo1 + " " + tiempo2 + " " + Terapia + " " + 0;
                            string result3 = objetoR.RunFromCmd(directorioScriptR3, rutaR, parametros3);   
                            CargarGrafica2(directorioImagenes + "VelocidadyTerapia" + Terapia + ".png");
                            break;
                        case 4:
                            RScriptRunner R4 = new RScriptRunner();
                            string directorioScriptR4 = directorioImagenes + "Aceleraciony.R";
                            string parametros4 = System.AppDomain.CurrentDomain.BaseDirectory + " " + tiempo1 + " " + tiempo2 + " " + Terapia + " " + 0;
                            string result4 = objetoR.RunFromCmd(directorioScriptR4, rutaR, parametros4);   
                            CargarGrafica2(directorioImagenes + "AceleracionyTerapia" + Terapia + ".png");
                            break;
                        case 5:
                            RScriptRunner R5 = new RScriptRunner();
                            string directorioScriptR5 = directorioImagenes + "Fuerzasy.R";
                            string parametros5 = System.AppDomain.CurrentDomain.BaseDirectory + " " + tiempo1 + " " + tiempo2 + " " + Terapia + " " + 0;
                            string result5 = objetoR.RunFromCmd(directorioScriptR5, rutaR, parametros5);   
                            CargarGrafica2(directorioImagenes + "FuerzasyTerapia" + Terapia + ".png");
                            break;

                    }
                
                
               }

            } 

           if(RB_Valor.IsChecked ==  true)
           {

               if ((CBTipoTerapia.SelectedIndex < 1))
               {
                   MessageBox.Show("No se pueden analizar por valor terapias de tipo 1.");
               }
               else if (CB_Valor.SelectedIndex < 0)
               {
                   MessageBox.Show("Por favor, seleccione una medida.");
               }

               else
               {
                   //Llamamos a R introducimos los parámetros que necesitamos
                   RScriptRunner R = new RScriptRunner();
                   string directorioScriptR = directorioImagenes + "Trayectoria.R";
                   string parametros = System.AppDomain.CurrentDomain.BaseDirectory + " " + Terapia + " " + 0;
                   string result = objetoR.RunFromCmd(directorioScriptR, rutaR, parametros);
                   //Llamaos a Cargar Gráfica para que nos ponga la grafica que se ha imprimido en la imagen
                   CargarGrafica1( directorioImagenes + "Terapia" + Terapia + ".png");
                   //introducimos que valores se han seleccionado
                   int maxima;
                   int minima;
                   int media;
                   if (CB_Valor.SelectedIndex < 1)
                   {
                       maxima = 1;
                       minima = 0;
                       media = 0;

                   }
                   else if (CB_Valor.SelectedIndex > 1)
                   {
                       maxima = 0;
                       minima = 1;
                       media = 0;

                   }
                   else 
                   {
                       maxima = 0;
                       minima = 0;
                       media = 1;

                   }

                   switch (CB_Graficas.SelectedIndex)
                   {
                       //Segun el tipo de gráfica que seleccionemos llama a R y carga la imagen para valor
                       case 0:
                           RScriptRunner R0 = new RScriptRunner();
                           string directorioScriptR0 = directorioImagenes + "Velocidadvx.R";
                           string parametros0 = System.AppDomain.CurrentDomain.BaseDirectory + " " + maxima + " " + minima + " " + media+" "+ Terapia + " " + 0;
                           string result0 = objetoR.RunFromCmd(directorioScriptR0, rutaR, parametros0);
                           CargarGrafica2(directorioImagenes + "VelocidadvxTerapia" + Terapia + ".png");
                           break;
                       case 1:
                           RScriptRunner R1 = new RScriptRunner();
                           string directorioScriptR1 = directorioImagenes + "Aceleracionvx.R";
                           string parametros1 = System.AppDomain.CurrentDomain.BaseDirectory + " " + maxima + " " + minima + " " + media + " " + Terapia + " " + 0;
                           string result1 = objetoR.RunFromCmd(directorioScriptR1, rutaR, parametros1);
                           CargarGrafica2(directorioImagenes + "AceleracionvxTerapia" + Terapia + ".png");
                           break;
                       case 2:
                           RScriptRunner R2 = new RScriptRunner();
                           string directorioScriptR2 = directorioImagenes + "Fuerzasvx.R";
                           string parametros2 = System.AppDomain.CurrentDomain.BaseDirectory + " " + maxima + " " + minima + " " + media + " " + Terapia + " " + 0;
                           string result2 = objetoR.RunFromCmd(directorioScriptR2, rutaR, parametros2);
                           CargarGrafica2(directorioImagenes + "FuerzasvxTerapia" + Terapia + ".png");
                           break;
                       case 3:
                           RScriptRunner R3 = new RScriptRunner();
                           string directorioScriptR3 = directorioImagenes + "Velocidadvy.R";
                           string parametros3 = System.AppDomain.CurrentDomain.BaseDirectory + " " + maxima + " " + minima + " " + media + " " + Terapia + " " + 0;
                           string result3 = objetoR.RunFromCmd(directorioScriptR3, rutaR, parametros3);
                           CargarGrafica2( directorioImagenes + "VelocidadvyTerapia" + Terapia + ".png");
                           break;
                       case 4:
                           RScriptRunner R4 = new RScriptRunner();
                           string directorioScriptR4 = directorioImagenes + "Aceleracionvy.R";
                           string parametros4 = System.AppDomain.CurrentDomain.BaseDirectory + " " + maxima + " " + minima + " " + media + " " + Terapia + " " + 0;
                           string result4 = objetoR.RunFromCmd(directorioScriptR4, rutaR, parametros4);
                           CargarGrafica2(directorioImagenes + "AceleracionvyTerapia" + Terapia + ".png");
                           break;
                       case 5:
                           RScriptRunner R5 = new RScriptRunner();
                           string directorioScriptR5 = directorioImagenes + "Fuerzasvy.R";
                           string parametros5 = System.AppDomain.CurrentDomain.BaseDirectory + " " + maxima + " " + minima + " " + media + " " + Terapia + " " + 0;
                           string result5 = objetoR.RunFromCmd(directorioScriptR5, rutaR, parametros5);
                           CargarGrafica2( directorioImagenes + "FuerzasvyTerapia" + Terapia + ".png");
                           break;

                   }




               }



           }


        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            List<PacientesBM> L_Pacientes = f.CargarCbPacientes();
     
            foreach (PacientesBM item in L_Pacientes)
            {
                
                CB_Paciente.Items.Add(item.IdPaciente);
            }
            //Nombramos los ComboBox
            CBTipoTerapia.Items.Add(1);
            CBTipoTerapia.Items.Add(2);
            CB_Graficas.Items.Add("Velocidad en el eje x");
            CB_Graficas.Items.Add("Aceleración en el eje x");
            CB_Graficas.Items.Add("Fuerza en el eje x");
            CB_Graficas.Items.Add("Velocidad en el eje y");
            CB_Graficas.Items.Add("Aceleración en el eje y");
            CB_Graficas.Items.Add("Fuerza en el eje y");
            CB_Valor.Items.Add("Máximo");
            CB_Valor.Items.Add("Media");
            CB_Valor.Items.Add("Mínimo");
        }

        private void CB_Paciente_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //Llamamos a funciones para obtener la identidad del paciente
            idPaciente = CB_Paciente.SelectedValue.ToString();

            List<TerapiaBM> L_Terapia = f.CargarCbTerapias(idPaciente, TerapiaTipo);
            CB_Terapia.Items.Clear();
            foreach (TerapiaBM item in L_Terapia)
            {
                CB_Terapia.Items.Add(item.IdTerapia);

            }
        }




        private void CBTipoTerapia_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //Llamamos a funciones para obtener el tipo de terapia
            //Guardamos el valor del tipo de terapia en Terapia Tipo
            TerapiaTipo = CBTipoTerapia.SelectedValue.ToString();
           
            List<TerapiaBM> L_Terapia = f.CargarCbTerapias(idPaciente, TerapiaTipo);
            CB_Terapia.Items.Clear();
            foreach (TerapiaBM item in L_Terapia)
            {
         
                CB_Terapia.Items.Add(item.IdTerapia);
            }
        }


        
        private void CB_Terapia_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //Guardamos el valor Terapia con el valor seleccionado
            if (CB_Terapia.SelectedIndex >= 0)
            {
                Terapia = CB_Terapia.SelectedValue.ToString();
            }
            
        
        }


        private void TB_Tiempo1_KeyDown(object sender, KeyEventArgs e)
        {
            //Solo permitimos numeros en el primer text box porque no permitimos el resto de teclas del teclado
            if (e.Key >= Key.D0 && e.Key <= Key.D9 || e.Key >= Key.NumPad0 && e.Key <= Key.NumPad9)
                e.Handled = false;
            else
                e.Handled = true;
        }

        private void TB_Tiempo2_KeyDown(object sender, KeyEventArgs e)
        {
            //Solo permitimos numeros en el segundo text box porque no permitimos el resto de teclas del teclado
            if (e.Key >= Key.D0 && e.Key <= Key.D9 || e.Key >= Key.NumPad0 && e.Key <= Key.NumPad9)
                e.Handled = false;
            else
                e.Handled = true;
        }


        private void CargarGrafica1(string rutaGrafica)
        {
            try
            {
                //Nos busca la imagen con el nombre de que le damos y la url que tenemos
                    ImageSource imgSource = new BitmapImage(new Uri(rutaGrafica));

                    Im_Trayectoria.Source = imgSource; 
                    

            }
            catch (Exception ex)
            {
                MessageBox.Show("Error debido a: " + ex.Message
                    + "\r\nError debido a: " + ex.Source
                    + "\r\nError debido a: " + ex.StackTrace
                    + "\r\nError debido a: " + ex.TargetSite);
            }
        }


        private void CargarGrafica2(string rutaGrafica)
        {
            rutaanalisis = rutaGrafica;
            try
           {
               if (System.IO.File.Exists(rutaGrafica) == true)
               {
                   //Nos busca la imagen con el nombre de que le damos y la url que tenemos y ademas en el caso de seleccionar otra gráfica o cambiar de tiempo a valor
                   // nos permite remplazar la grafica previa por una nueva
                   BitmapImage _image = new BitmapImage();
                   _image.BeginInit();
                   _image.CacheOption = BitmapCacheOption.None;
                   _image.UriCachePolicy = new RequestCachePolicy(RequestCacheLevel.BypassCache);
                   _image.CacheOption = BitmapCacheOption.OnLoad;
                   _image.CreateOptions = BitmapCreateOptions.IgnoreImageCache;
                   _image.UriSource = new Uri(rutaGrafica, UriKind.RelativeOrAbsolute);

                   _image.EndInit();
                   Im_analisis.Source = _image;
               }
               else
               {
                   MessageBox.Show("La trayectoria en esta terapia es demasiado corta como para poder calcular la traza realizada en una vuelta.");
                 
                   BitmapImage _image = new BitmapImage();
                   _image.BeginInit();
                   _image.CacheOption = BitmapCacheOption.None;
                   _image.UriCachePolicy = new RequestCachePolicy(RequestCacheLevel.BypassCache);
                   _image.CacheOption = BitmapCacheOption.OnLoad;
                   _image.CreateOptions = BitmapCreateOptions.IgnoreImageCache;
                   _image.UriSource = new Uri(directorioImagenes + "Defecto.png", UriKind.RelativeOrAbsolute);
                   _image.EndInit();
                   Im_analisis.Source = _image;
                   rutaanalisis = directorioImagenes + "Defecto.png";
               }

                }


            catch (Exception ex)
            {
                MessageBox.Show("Error debido a: " + ex.Message
                    + "\r\nError debido a: " + ex.Source
                    + "\r\nError debido a: " + ex.StackTrace
                    + "\r\nError debido a: " + ex.TargetSite);
            }
        }

        private void B_Imprimir_Click(object sender, RoutedEventArgs e)
        {
            //Condiciones para poder analizar
            if (CB_Paciente.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione un paciente");
            }
            else if (CBTipoTerapia.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione un tipo de terapia");
            }
            else if (CB_Terapia.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione una terapia");
            }


            if (RB_Tiempo.IsChecked == true)
            {
                if (tiempo1 > tiempo2)
                {
                    MessageBox.Show("El tiempo inicial no puede ser mayor que el final");
                }
                else if (tiempo1 == tiempo2)
                {
                    MessageBox.Show("El tiempo inicial y final tienen que ser distintos");
                }
                else if (tiempo2 > 305)
                {
                    MessageBox.Show("El tiempo debe de ser inferior a 5 minutos (300 segundos)");
                }

                else
                {
                    string parametros;
                                       
                        if(CB_Graficas.SelectedIndex<1){
                            parametros = 1 + " " + 0 + " " + directorioImagenes + " " + directorioImagenes + "Terapia" + Terapia + ".png" + " " + Terapia + " " + directorioImagenes + "VelocidadxTerapia" + Terapia + ".png";
                        }
                        else if (CB_Graficas.SelectedIndex==1){
                            parametros = 1 + " " + 0 + " " + directorioImagenes + " " + directorioImagenes + "Terapia" + Terapia + ".png" + " " + Terapia + " " + directorioImagenes + "AceleracionxTerapia" + Terapia + ".png";

                        }
                       else if (CB_Graficas.SelectedIndex==2){
                           parametros = 1 + " " + 0 + " " + directorioImagenes + " " + directorioImagenes + "Terapia" + Terapia + ".png" + " " + Terapia + " " + directorioImagenes + "FuerzasxTerapia" + Terapia + ".png";

                        }

                        else if (CB_Graficas.SelectedIndex==3){
                            parametros = 1 + " " + 0 + " " + directorioImagenes + " " + directorioImagenes + "Terapia" + Terapia + ".png" + " " + Terapia + " " + directorioImagenes + "VelocidadyTerapia" + Terapia + ".png";

                        }
                        else if (CB_Graficas.SelectedIndex==4){
                            parametros = 1 + " " + 0 + " " + directorioImagenes + " " + directorioImagenes + "Terapia" + Terapia + ".png" + " " + Terapia + " " + directorioImagenes + "AceleracionyTerapia" + Terapia + ".png";

                        }
                        else {
                            parametros = 1 + " " + 0 + " " + directorioImagenes + " " + directorioImagenes + "Terapia" + Terapia + ".png" + " " + Terapia + " " + directorioImagenes + "FuerzasyTerapia" + Terapia + ".png";

                        }

       
                    RScriptRunner R = new RScriptRunner();
                    string directorioScriptR = directorioImagenes + "Imprimir.R";
                    string result = objetoR.RunFromCmd(directorioScriptR, rutaR, parametros);

                }

            }

            if (RB_Valor.IsChecked == true)
            {

                if ((CBTipoTerapia.SelectedIndex < 1))
                {
                    MessageBox.Show("No se pueden analizar por valor terapias de tipo 1");
                }
                else if (CB_Valor.SelectedIndex < 0)
                {
                    MessageBox.Show("Por favor, seleccione una medida.");
                }

                else
                {
      
                    string parametros;

                    if (CB_Graficas.SelectedIndex < 1)
                    {
                        parametros = 1 + " " + 0 + " " + directorioImagenes +" "+ directorioImagenes + "Terapia" + Terapia + ".png" + " " + Terapia + " " + directorioImagenes + "VelocidadvxTerapia" + Terapia + ".png";
                    }
                    else if (CB_Graficas.SelectedIndex == 1)
                    {
                        parametros = 1 + " " + 0 + " " + directorioImagenes + " " + directorioImagenes + "Terapia" + Terapia + ".png" + " " + Terapia + " " + directorioImagenes + "AceleracionvxTerapia" + Terapia + ".png";

                    }
                    else if (CB_Graficas.SelectedIndex == 2)
                    {
                        parametros = 1 + " " + 0 + " " + directorioImagenes + " " + directorioImagenes + "Terapia" + Terapia + ".png" + " " + Terapia + " " + directorioImagenes + "FuerzasvxTerapia" + Terapia + ".png";

                    }

                    else if (CB_Graficas.SelectedIndex == 3)
                    {
                        parametros = 1 + " " + 0 + " " + directorioImagenes + " " + directorioImagenes + "Terapia" + Terapia + ".png" + " " + Terapia + " " + directorioImagenes + "VelocidadvyTerapia" + Terapia + ".png";

                    }
                    else if (CB_Graficas.SelectedIndex == 4)
                    {
                        parametros = 1 + " " + 0 + " " + directorioImagenes + " " + directorioImagenes + "Terapia" + Terapia + ".png" + " " + Terapia + " " + directorioImagenes + "AceleracionvyTerapia" + Terapia + ".png";

                    }
                    else
                    {
                        parametros = 1 + " " + 0 + " " + directorioImagenes +" "+ directorioImagenes + "Terapia" + Terapia + ".png" + " " + Terapia + " " + directorioImagenes + "FuerzasvyTerapia" + Terapia + ".png";

                    }


                    RScriptRunner R = new RScriptRunner();
                    string directorioScriptR = directorioImagenes + "Imprimir.R";
                    string result = objetoR.RunFromCmd(directorioScriptR, rutaR, parametros);


                }


            }

            if (RB_Tiempo.IsChecked == false & RB_Valor.IsChecked == false)
            {
                MessageBox.Show("Por favor seleccione tiempo o valor");
            }
            else if (CB_Paciente.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione un paciente");
            }
            else if (CBTipoTerapia.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione un tipo de terapia");
            }
            else if (CB_Terapia.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione una terapia");
            }
            else
            {

                System.Diagnostics.Process proc = new System.Diagnostics.Process();

                proc.StartInfo.FileName = directorioImagenes + " Analisis_Terapia_ " + Terapia + " .pdf";

                proc.Start();
                proc.Close();
            }
        }


       private void Im_Trayectoria_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
           W_Trayectoria V_Trayectoria = new W_Trayectoria(directorioImagenes + "Terapia" + Terapia + ".png");
           V_Trayectoria.Owner = this;
            V_Trayectoria.ShowDialog();
        }

       private void Im_analisis_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
       {
           W_Ampliaranalisis V_Ampliaranalisis = new W_Ampliaranalisis(rutaanalisis);
           V_Ampliaranalisis.Owner = this;
           V_Ampliaranalisis.ShowDialog();
       }





        
    }
}
