﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Interop;
using System.Net.Cache;

namespace Gestor_de_informacion
{
    /// <summary>
    /// Lógica de interacción para W_CompararEvolucion.xaml
    /// </summary>
    public partial class W_CompararEvolucion : Window
    {
        //Llamamos a funciones
        Funciones f = new Funciones();

        string directorioImagenes = System.AppDomain.CurrentDomain.BaseDirectory + "R\\"; //nos dice la url donde guardar las imagenes
        string idPaciente1;
        string TerapiaTipo1;
        string Terapiainicial1;
        string Terapiafinal1;
        string rutaanalisis1;
        string idPaciente2;
        string TerapiaTipo2;
        string Terapiainicial2;
        string Terapiafinal2;
        string rutaanalisis2;
        public RScriptRunner objetoR = new RScriptRunner();     //Lo empleamos para comunicarnos con los scripts de R
        private string rutaR = "C:\\Program Files\\R\\R-3.1.2\\bin\\Rscript.exe";   //Ruta para usar Rscript.exe que nos permite ejecutar los scripts

        public W_CompararEvolucion()
        {
            InitializeComponent();
        }




        private void Grid_Loaded(object sender, RoutedEventArgs e)
        {
            List<PacientesBM> L_Pacientes = f.CargarCbPacientes();

            foreach (PacientesBM item in L_Pacientes)
            {

                CB_Paciente1.Items.Add(item.IdPaciente);
                CB_Paciente2.Items.Add(item.IdPaciente);
            }
            //Nombramos los ComboBox
            CB_Terapiatipo1.Items.Add(1);
            CB_Terapiatipo1.Items.Add(2);
            CB_Grafica1.Items.Add("Error");
            CB_Grafica1.Items.Add("Evolución de la fuerza");
            CB_Grafica1.Items.Add("Facilidad de movimiento");
            CB_Grafica1.Items.Add("Marcador");
            CB_Grafica1.Items.Add("Media y desviación");
            CB_Grafica1.Items.Add("Número de temblores");
            CB_Grafica1.Items.Add("Simetria direccional magnitud y ángulo");
            CB_Grafica1.Items.Add("Simetria direccional xy");
            CB_Grafica1.Items.Add("Tiempo de reacción");


            //Nombramos los ComboBox
            CB_Terapiatipo2.Items.Add(1);
            CB_Terapiatipo2.Items.Add(2);
            CB_Grafica2.Items.Add("Error");
            CB_Grafica2.Items.Add("Evolución de la fuerza");
            CB_Grafica2.Items.Add("Facilidad de movimiento");
            CB_Grafica2.Items.Add("Marcador");
            CB_Grafica2.Items.Add("Media y desviación");
            CB_Grafica2.Items.Add("Número de temblores");
            CB_Grafica2.Items.Add("Simetria direccional magnitud y ángulo");
            CB_Grafica2.Items.Add("Simetria direccional xy");
            CB_Grafica2.Items.Add("Tiempo de reacción");
        }

        private void B_Volver_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void B_Analizar_Click(object sender, RoutedEventArgs e)
        {
            if (CB_Paciente1.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione un paciente en la Muestra 1.");
            }
            else if (CB_Terapiatipo1.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione un tipo de terapia en la Muestra 1.");
            }
            else if (CB_Terapiainicial1.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione una terapia en Terapia inicial en la Muestra 1.");
            }
            else if (CB_Terapiafinal1.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione una terapia en Terapia final en la Muestra 1.");
            }
            else if (CB_Grafica1.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione un tipo de gráfica en en la Muestra 1.");
            }
            else if (CB_Terapiainicial1.SelectedIndex > CB_Terapiafinal1.SelectedIndex)
            {
                MessageBox.Show("La terapia final no puede ser menor que la terapia inicial, por favor seleccione otro intervalo de terapias en la Muestra 1.");
            }
            else if (CB_Grafica1.SelectedIndex == 3 & CB_Terapiatipo1.SelectedIndex == 1)
            {
                MessageBox.Show("La gráfica Marcador, no puede ser válida para terapias de tipo 2, en la Muestra 1.");
            }
            else if (CB_Paciente2.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione un paciente en la Muestra 2.");
            }
            else if (CB_Terapiatipo2.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione un tipo de terapia en la Muestra 2.");
            }
            else if (CB_Terapiainicial2.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione una terapia en Terapia inicial en la Muestra 2.");
            }
            else if (CB_Terapiafinal2.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione una terapia en Terapia final en la Muestra 2.");
            }
            else if (CB_Grafica2.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione un tipo de gráfica en la Muestra 2.");
            }
            else if (CB_Terapiainicial2.SelectedIndex > CB_Terapiafinal2.SelectedIndex)
            {
                MessageBox.Show("La terapia final no puede ser menor que la terapia inicial, por favor seleccione otro intervalo de terapias en la Muestra 2.");
            }
            else if (CB_Grafica2.SelectedIndex == 3 & CB_Terapiatipo2.SelectedIndex == 1)
            {
                MessageBox.Show("La gráfica Marcador, no puede ser válida para terapias de tipo 2, en la Muestra 2.");
            }
            else
            {
                string parametros1 = System.AppDomain.CurrentDomain.BaseDirectory + " " + idPaciente1 + " " + TerapiaTipo1 + " " + Terapiainicial1 + " " + Terapiafinal1 + " " + 2;
                string parametros2 = System.AppDomain.CurrentDomain.BaseDirectory + " " + idPaciente2 + " " + TerapiaTipo2 + " " + Terapiainicial2 + " " + Terapiafinal2 + " " + 2;

                switch (CB_Grafica1.SelectedIndex)
                {
                    //Segun el tipo de gráfica que seleccionemos llama a R y carga la imagen para tiempo
                    case 0:

                        RScriptRunner R0 = new RScriptRunner();
                        string directorioScriptR0 = directorioImagenes + "Act_Error.R";
                        string result0 = objetoR.RunFromCmd(directorioScriptR0, rutaR, parametros1);
                        CargarGrafica1(directorioImagenes + "Error_cometido_P" + idPaciente1 + "Terapia" + TerapiaTipo1 + ".png");
                        break;
                    case 1:
                        RScriptRunner R1 = new RScriptRunner();
                        string directorioScriptR1 = directorioImagenes + "Act_Evolucion_Fuerzas.R";
                        string result1 = objetoR.RunFromCmd(directorioScriptR1, rutaR, parametros1);
                        CargarGrafica1(directorioImagenes + "Evolucion_Fuerzas_P" + idPaciente1 + "Terapia" + TerapiaTipo1 + ".png");
                        break;
                    case 2:
                        RScriptRunner R2 = new RScriptRunner();
                        string directorioScriptR2 = directorioImagenes + "Act_Facildad_de_movimiento.R";
                        string result2 = objetoR.RunFromCmd(directorioScriptR2, rutaR, parametros1);
                        CargarGrafica1(directorioImagenes + "Facilidad_movimiento_P" + idPaciente1 + "Terapia" + TerapiaTipo1 + ".png");
                        break;
                    case 3:
                        RScriptRunner R3 = new RScriptRunner();
                        string directorioScriptR3 = directorioImagenes + "Act_Marcador.R";
                        string result3 = objetoR.RunFromCmd(directorioScriptR3, rutaR, parametros1);
                        CargarGrafica1(directorioImagenes + "Marcador_P" + idPaciente1 + "Terapia" + TerapiaTipo1 + ".png");
                        break;
                    case 4:
                        RScriptRunner R4 = new RScriptRunner();
                        string directorioScriptR4 = directorioImagenes + "Act_mediaymoda.R";
                        string result4 = objetoR.RunFromCmd(directorioScriptR4, rutaR, parametros1);
                        CargarGrafica1(directorioImagenes + "Media_desviacion_P" + idPaciente1 + "Terapia" + TerapiaTipo1 + ".png");
                        break;
                    case 5:
                        RScriptRunner R5 = new RScriptRunner();
                        string directorioScriptR5 = directorioImagenes + "Act_Num_Temblores.R";
                        string result5 = objetoR.RunFromCmd(directorioScriptR5, rutaR, parametros1);
                        CargarGrafica1(directorioImagenes + "N_Temblores_P" + idPaciente1 + "Terapia" + TerapiaTipo1 + ".png");
                        break;
                    case 6:
                        RScriptRunner R6 = new RScriptRunner();
                        string directorioScriptR6 = directorioImagenes + "Act_Simetria_Direccional_vx_vy_m_a.R";
                        string result6 = objetoR.RunFromCmd(directorioScriptR6, rutaR, parametros1);
                        CargarGrafica1(directorioImagenes + "Sim_dir_vel_mag_ang_P" + idPaciente1 + "Terapia" + TerapiaTipo1 + ".png");
                        break;
                    case 7:
                        RScriptRunner R7 = new RScriptRunner();
                        string directorioScriptR7 = directorioImagenes + "Act_Simetria_direccional_xy.R";
                        string result7 = objetoR.RunFromCmd(directorioScriptR7, rutaR, parametros1);
                        CargarGrafica1(directorioImagenes + "Sim_dir_xy_P" + idPaciente1 + "Terapia" + TerapiaTipo1 + ".png");
                        break;
                    case 8:
                        RScriptRunner R8 = new RScriptRunner();
                        string directorioScriptR8 = directorioImagenes + "Act_Tiempo_de_Reaccion.R";
                        string result8 = objetoR.RunFromCmd(directorioScriptR8, rutaR, parametros1);
                        CargarGrafica1(directorioImagenes + "Tiempo_Reaccion_P" + idPaciente1 + "Terapia" + TerapiaTipo1 + ".png");
                        break;
                }

                switch (CB_Grafica2.SelectedIndex)
                {
                    //Segun el tipo de gráfica que seleccionemos llama a R y carga la imagen para tiempo
                    case 0:

                        RScriptRunner R0 = new RScriptRunner();
                        string directorioScriptR0 = directorioImagenes + "Act_Error.R";
                        string result0 = objetoR.RunFromCmd(directorioScriptR0, rutaR, parametros2);
                        CargarGrafica2(directorioImagenes + "Error_cometido_P" + idPaciente2 + "Terapia" + TerapiaTipo2 + ".png");
                        break;
                    case 1:
                        RScriptRunner R1 = new RScriptRunner();
                        string directorioScriptR1 = directorioImagenes + "Act_Evolucion_Fuerzas.R";
                        string result1 = objetoR.RunFromCmd(directorioScriptR1, rutaR, parametros2);
                        CargarGrafica2(directorioImagenes + "Evolucion_Fuerzas_P" + idPaciente2 + "Terapia" + TerapiaTipo2 + ".png");
                        break;
                    case 2:
                        RScriptRunner R2 = new RScriptRunner();
                        string directorioScriptR2 = directorioImagenes + "Act_Facildad_de_movimiento.R";
                        string result2 = objetoR.RunFromCmd(directorioScriptR2, rutaR, parametros2);
                        CargarGrafica2(directorioImagenes + "Facilidad_movimiento_P" + idPaciente2 + "Terapia" + TerapiaTipo2 + ".png");
                        break;
                    case 3:
                        RScriptRunner R3 = new RScriptRunner();
                        string directorioScriptR3 = directorioImagenes + "Act_Marcador.R";
                        string result3 = objetoR.RunFromCmd(directorioScriptR3, rutaR, parametros2);
                        CargarGrafica2(directorioImagenes + "Marcador_P" + idPaciente2 + "Terapia" + TerapiaTipo2 + ".png");
                        break;
                    case 4:
                        RScriptRunner R4 = new RScriptRunner();
                        string directorioScriptR4 = directorioImagenes + "Act_mediaymoda.R";
                        string result4 = objetoR.RunFromCmd(directorioScriptR4, rutaR, parametros2);
                        CargarGrafica2(directorioImagenes + "Media_desviacion_P" + idPaciente2 + "Terapia" + TerapiaTipo2 + ".png");
                        break;
                    case 5:
                        RScriptRunner R5 = new RScriptRunner();
                        string directorioScriptR5 = directorioImagenes + "Act_Num_Temblores.R";
                        string result5 = objetoR.RunFromCmd(directorioScriptR5, rutaR, parametros2);
                        CargarGrafica2(directorioImagenes + "N_Temblores_P" + idPaciente2 + "Terapia" + TerapiaTipo2 + ".png");
                        break;
                    case 6:
                        RScriptRunner R6 = new RScriptRunner();
                        string directorioScriptR6 = directorioImagenes + "Act_Simetria_Direccional_vx_vy_m_a.R";
                        string result6 = objetoR.RunFromCmd(directorioScriptR6, rutaR, parametros2);
                        CargarGrafica2(directorioImagenes + "Sim_dir_vel_mag_ang_P" + idPaciente2 + "Terapia" + TerapiaTipo2 + ".png");
                        break;
                    case 7:
                        RScriptRunner R7 = new RScriptRunner();
                        string directorioScriptR7 = directorioImagenes + "Act_Simetria_direccional_xy.R";
                        string result7 = objetoR.RunFromCmd(directorioScriptR7, rutaR, parametros2);
                        CargarGrafica2(directorioImagenes + "Sim_dir_xy_P" + idPaciente2 + "Terapia" + TerapiaTipo2 + ".png");
                        break;
                    case 8:
                        RScriptRunner R8 = new RScriptRunner();
                        string directorioScriptR8 = directorioImagenes + "Act_Tiempo_de_Reaccion.R";
                        string result8 = objetoR.RunFromCmd(directorioScriptR8, rutaR, parametros2);
                        CargarGrafica2(directorioImagenes + "Tiempo_Reaccion_P" + idPaciente2 + "Terapia" + TerapiaTipo2 + ".png");
                        break;
                }
                
                W_Graficas_Compara_Evolucion V_Graficas_ComparaEvolucion = new W_Graficas_Compara_Evolucion(rutaanalisis1, rutaanalisis2);
                V_Graficas_ComparaEvolucion.Owner = this;
                V_Graficas_ComparaEvolucion.ShowDialog();

            }
        }

        private void CB_Paciente1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //Llamamos a funciones para obtener la identidad del paciente
            idPaciente1 = CB_Paciente1.SelectedValue.ToString();

            List<TerapiaBM> L_Terapia = f.CargarCbTerapias(idPaciente1, TerapiaTipo1);
            CB_Terapiainicial1.Items.Clear();
            CB_Terapiafinal1.Items.Clear();
            foreach (TerapiaBM item in L_Terapia)
            {
                CB_Terapiainicial1.Items.Add(item.IdTerapia);
                CB_Terapiafinal1.Items.Add(item.IdTerapia);

            }
        }

        private void CB_Terapiatipo1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
                        //Llamamos a funciones para obtener el tipo de terapia
            //Guardamos el valor del tipo de terapia en Terapia Tipo
            TerapiaTipo1 = CB_Terapiatipo1.SelectedValue.ToString();

            List<TerapiaBM> L_Terapia = f.CargarCbTerapias(idPaciente1, TerapiaTipo1);
            CB_Terapiainicial1.Items.Clear();
            CB_Terapiafinal1.Items.Clear();
            foreach (TerapiaBM item in L_Terapia)
            {
                CB_Terapiainicial1.Items.Add(item.IdTerapia);
                CB_Terapiafinal1.Items.Add(item.IdTerapia);
            }
        }
        

        private void CB_Terapiainicial1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
                //Guardamos el valor Terapia con el valor seleccionado
            if (CB_Terapiainicial1.SelectedIndex >= 0)
            {
                Terapiainicial1 = CB_Terapiainicial1.SelectedValue.ToString();
            }

        }

        private void CB_Terapiafinal1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //Guardamos el valor Terapia con el valor seleccionado
            if (CB_Terapiafinal1.SelectedIndex >= 0)
            {
                Terapiafinal1 = CB_Terapiafinal1.SelectedValue.ToString();
            }

        }

        private void CB_Paciente2_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //Llamamos a funciones para obtener la identidad del paciente
            idPaciente2 = CB_Paciente2.SelectedValue.ToString();

            List<TerapiaBM> L_Terapia = f.CargarCbTerapias(idPaciente2, TerapiaTipo2);
            CB_Terapiainicial2.Items.Clear();
            CB_Terapiafinal2.Items.Clear();
            foreach (TerapiaBM item in L_Terapia)
            {
                CB_Terapiainicial2.Items.Add(item.IdTerapia);
                CB_Terapiafinal2.Items.Add(item.IdTerapia);
            }
        }

        private void CB_Terapiatipo2_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //Llamamos a funciones para obtener el tipo de terapia
            //Guardamos el valor del tipo de terapia en Terapia Tipo
            TerapiaTipo2 = CB_Terapiatipo2.SelectedValue.ToString();

            List<TerapiaBM> L_Terapia = f.CargarCbTerapias(idPaciente2, TerapiaTipo2);
            CB_Terapiainicial2.Items.Clear();
            CB_Terapiafinal2.Items.Clear();
            foreach (TerapiaBM item in L_Terapia)
            {
                CB_Terapiainicial2.Items.Add(item.IdTerapia);
                CB_Terapiafinal2.Items.Add(item.IdTerapia);
            }
        }

        private void CB_Terapiainicial2_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //Guardamos el valor Terapia con el valor seleccionado
            if (CB_Terapiainicial2.SelectedIndex >= 0)
            {
                Terapiainicial2 = CB_Terapiainicial2.SelectedValue.ToString();
            }

        }

        private void CB_Terapiafinal2_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (CB_Terapiafinal2.SelectedIndex >= 0)
            {
                Terapiafinal2 = CB_Terapiafinal2.SelectedValue.ToString();
            }

        }

         private void CargarGrafica1(string rutaGrafica)
        {
            rutaanalisis1 = rutaGrafica;
       
                }

         private void CargarGrafica2(string rutaGrafica)
         {
             rutaanalisis2 = rutaGrafica;

         } 

        }
    }

