﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Interop;
using System.Net.Cache;
//using System.Windows.Controls.DataVisualization.Toolkit;

namespace Gestor_de_informacion
{
    /// <summary>
    /// Lógica de interacción para W_Evolucion.xaml
    /// </summary>
    public partial class W_Evolucion : Window
    {
        //Llamamos a funciones
        Funciones f = new Funciones();

        string directorioImagenes = System.AppDomain.CurrentDomain.BaseDirectory + "R\\"; //nos dice la url donde guardar las imagenes
        string idPaciente;
        string TerapiaTipo;
        string Terapiainicial;
        string Terapiafinal;
        string rutaanalisis;
        int contador;
        public RScriptRunner objetoR = new RScriptRunner();     //Lo empleamos para comunicarnos con los scripts de R
        private string rutaR = "C:\\Program Files\\R\\R-3.1.2\\bin\\Rscript.exe";   //Ruta para usar Rscript.exe que nos permite ejecutar los scripts

        public W_Evolucion()
        {
            InitializeComponent();
             
        }


        private void B_Volver_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void B_Analizar_Click(object sender, RoutedEventArgs e)
        {
            if (CB_Paciente.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione un paciente.");
            }
            else if (CB_Terapiatipo.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione un tipo de terapia .");
            }
            else if (CB_Terapiainicial.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione una terapia en Terapia inicial");
            }
            else if (CB_Terapiafinal.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione una terapia en Terapia final");
            }
            else if (CB_Grafica.SelectedIndex < 0)
            {
                MessageBox.Show("Por favor ,seleccione un tipo de gráfica.");
            }
            else if (CB_Terapiainicial.SelectedIndex > CB_Terapiafinal.SelectedIndex)
            {
                MessageBox.Show("La terapia final no puede ser menor que la terapia inicial, por favor seleccione otro intervalo de terapias");
            }
            else if (CB_Grafica.SelectedIndex == 3 & CB_Terapiatipo.SelectedIndex == 1)
            {
                MessageBox.Show("La gráfica Marcador, no puede ser válida para terapias de tipo 2");
            }
            else
            {
                string parametros = System.AppDomain.CurrentDomain.BaseDirectory + " " + idPaciente + " " + TerapiaTipo + " " + Terapiainicial + " " + Terapiafinal + " " + 1;

                switch (CB_Grafica.SelectedIndex)
                {
                    //Segun el tipo de gráfica que seleccionemos llama a R y carga la imagen para tiempo
                    case 0:

                        RScriptRunner R0 = new RScriptRunner();
                        string directorioScriptR0 = directorioImagenes + "Act_Error.R";
                        string result0 = objetoR.RunFromCmd(directorioScriptR0, rutaR, parametros);
                        CargarGrafica(directorioImagenes + "Error_cometido_P"+ idPaciente + "Terapia"+TerapiaTipo + ".png");
                        break;
                    case 1:
                        RScriptRunner R1 = new RScriptRunner();
                        string directorioScriptR1 = directorioImagenes + "Act_Evolucion_Fuerzas.R";
                        string result1 = objetoR.RunFromCmd(directorioScriptR1, rutaR, parametros);
                        CargarGrafica(directorioImagenes + "Evolucion_Fuerzas_P" + idPaciente + "Terapia" + TerapiaTipo + ".png");
                        break;
                    case 2:
                        RScriptRunner R2 = new RScriptRunner();
                        string directorioScriptR2 = directorioImagenes + "Act_Facildad_de_movimiento.R";
                        string result2 = objetoR.RunFromCmd(directorioScriptR2, rutaR, parametros);
                        CargarGrafica(directorioImagenes + "Facilidad_movimiento_P" + idPaciente + "Terapia" + TerapiaTipo + ".png");
                        break;
                    case 3:
                        RScriptRunner R3 = new RScriptRunner();
                        string directorioScriptR3 = directorioImagenes + "Act_Marcador.R";
                        string result3 = objetoR.RunFromCmd(directorioScriptR3, rutaR, parametros);
                        CargarGrafica(directorioImagenes + "Marcador_P" + idPaciente + "Terapia" + TerapiaTipo + ".png");
                        break;
                    case 4:
                        RScriptRunner R4 = new RScriptRunner();
                        string directorioScriptR4 = directorioImagenes + "Act_mediaymoda.R";
                        string result4 = objetoR.RunFromCmd(directorioScriptR4, rutaR, parametros);
                        CargarGrafica(directorioImagenes + "Media_desviacion_P" + idPaciente + "Terapia" + TerapiaTipo + ".png");
                        break;
                    case 5:
                        RScriptRunner R5 = new RScriptRunner();
                        string directorioScriptR5 = directorioImagenes + "Act_Num_Temblores.R";
                        string result5 = objetoR.RunFromCmd(directorioScriptR5, rutaR, parametros);
                        CargarGrafica(directorioImagenes + "N_Temblores_P" + idPaciente + "Terapia" + TerapiaTipo + ".png");
                        break;
                    case 6:
                        RScriptRunner R6 = new RScriptRunner();
                        string directorioScriptR6 = directorioImagenes + "Act_Simetria_Direccional_vx_vy_m_a.R";
                        string result6 = objetoR.RunFromCmd(directorioScriptR6, rutaR, parametros);
                        CargarGrafica(directorioImagenes + "Sim_dir_vel_mag_ang_P" + idPaciente + "Terapia" + TerapiaTipo + ".png");
                        break;
                    case 7:
                        RScriptRunner R7 = new RScriptRunner();
                        string directorioScriptR7 = directorioImagenes + "Act_Simetria_direccional_xy.R";
                        string result7 = objetoR.RunFromCmd(directorioScriptR7, rutaR, parametros);
                        CargarGrafica(directorioImagenes + "Sim_dir_xy_P" + idPaciente + "Terapia" + TerapiaTipo + ".png");
                        break;
                    case 8:
                        RScriptRunner R8 = new RScriptRunner();
                        string directorioScriptR8 = directorioImagenes + "Act_Tiempo_de_Reaccion.R";
                        string result8 = objetoR.RunFromCmd(directorioScriptR8, rutaR, parametros);
                        CargarGrafica(directorioImagenes + "Tiempo_Reaccion_P" + idPaciente + "Terapia" + TerapiaTipo + ".png");
                        break;
                }
            }

        }
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            List<PacientesBM> L_Pacientes = f.CargarCbPacientes();

            foreach (PacientesBM item in L_Pacientes)
            {

                CB_Paciente.Items.Add(item.IdPaciente);
            }
            //Nombramos los ComboBox
            CB_Terapiatipo.Items.Add(1);
            CB_Terapiatipo.Items.Add(2);
            CB_Grafica.Items.Add("Error");
            CB_Grafica.Items.Add("Evolución de la fuerza");
            CB_Grafica.Items.Add("Facilidad de movimiento");
            CB_Grafica.Items.Add("Marcador");
            CB_Grafica.Items.Add("Media y desviación");
            CB_Grafica.Items.Add("Número de temblores");
            CB_Grafica.Items.Add("Simetria direccional magnitud y ángulo");
            CB_Grafica.Items.Add("Simetria direccional xy");
            CB_Grafica.Items.Add("Tiempo de reacción");
        }

        private void CB_Paciente_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //Llamamos a funciones para obtener la identidad del paciente
            idPaciente = CB_Paciente.SelectedValue.ToString();

            List<TerapiaBM> L_Terapia = f.CargarCbTerapias(idPaciente, TerapiaTipo);
            CB_Terapiainicial.Items.Clear();
            CB_Terapiafinal.Items.Clear();
            foreach (TerapiaBM item in L_Terapia)
            {
                CB_Terapiainicial.Items.Add(item.IdTerapia);
                CB_Terapiafinal.Items.Add(item.IdTerapia);

            }
        }

        private void CBTipoTerapia_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //Llamamos a funciones para obtener el tipo de terapia
            //Guardamos el valor del tipo de terapia en Terapia Tipo
            TerapiaTipo = CB_Terapiatipo.SelectedValue.ToString();

            List<TerapiaBM> L_Terapia = f.CargarCbTerapias(idPaciente, TerapiaTipo);
            CB_Terapiainicial.Items.Clear();
            CB_Terapiafinal.Items.Clear();
            foreach (TerapiaBM item in L_Terapia)
            {
                CB_Terapiainicial.Items.Add(item.IdTerapia);
                CB_Terapiafinal.Items.Add(item.IdTerapia);
            }
        }

        private void CB_Terapiainicial_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //Guardamos el valor Terapia con el valor seleccionado
            if (CB_Terapiainicial.SelectedIndex >= 0)
            {
                Terapiainicial = CB_Terapiainicial.SelectedValue.ToString();
            }


        }

        private void CB_Terapiafinal_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //Guardamos el valor Terapia con el valor seleccionado
            if (CB_Terapiafinal.SelectedIndex >= 0)
            {
                Terapiafinal = CB_Terapiafinal.SelectedValue.ToString();
            }


        }

        private void CargarGrafica(string rutaGrafica)
        {
            rutaanalisis = rutaGrafica;
            try
            {
                if (System.IO.File.Exists(rutaGrafica) == true)
                {
                    //Nos busca la imagen con el nombre de que le damos y la url que tenemos y ademas en el caso de seleccionar otra gráfica o cambiar de tiempo a valor
                    // nos permite remplazar la grafica previa por una nueva
                    BitmapImage _image = new BitmapImage();
                    _image.BeginInit();
                    _image.CacheOption = BitmapCacheOption.None;
                    _image.UriCachePolicy = new RequestCachePolicy(RequestCacheLevel.BypassCache);
                    _image.CacheOption = BitmapCacheOption.OnLoad;
                    _image.CreateOptions = BitmapCreateOptions.IgnoreImageCache;
                    _image.UriSource = new Uri(rutaGrafica, UriKind.RelativeOrAbsolute);

                    _image.EndInit();
                    Im_Evolucion.Source = _image;
                    contador = 1;
                }
                else
                {
                    MessageBox.Show("La trayectoria en esta terapia es demasiado corta como para poder calcular la traza realizada en una vuelta.");

                    BitmapImage _image = new BitmapImage();
                    _image.BeginInit();
                    _image.CacheOption = BitmapCacheOption.None;
                    _image.UriCachePolicy = new RequestCachePolicy(RequestCacheLevel.BypassCache);
                    _image.CacheOption = BitmapCacheOption.OnLoad;
                    _image.CreateOptions = BitmapCreateOptions.IgnoreImageCache;
                    _image.UriSource = new Uri(directorioImagenes + "Defecto.png", UriKind.RelativeOrAbsolute);
                    _image.EndInit();
                    Im_Evolucion.Source = _image;
                    rutaanalisis = directorioImagenes + "Defecto.png";
                    contador = 0;
                }

            }


            catch (Exception ex)
            {
                MessageBox.Show("Error debido a: " + ex.Message
                    + "\r\nError debido a: " + ex.Source
                    + "\r\nError debido a: " + ex.StackTrace
                    + "\r\nError debido a: " + ex.TargetSite);
            }
        }

        private void B_Imprimir_Click(object sender, RoutedEventArgs e)
        {
            if (contador == 0) {
                MessageBox.Show("Analice una evolución de terapia antes de imprimirla.");
            }
            else { 
            System.Diagnostics.Process proc = new System.Diagnostics.Process();
            proc.StartInfo.FileName = rutaanalisis;
            proc.Start();
            proc.Close();
        }
        }

        private void Im_Evolucion_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            Ampliar_Evolucion V_Ampliarevolucion = new Ampliar_Evolucion(rutaanalisis);
            V_Ampliarevolucion.Owner = this;
            V_Ampliarevolucion.ShowDialog();
            
        }
    }
}
