﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Interop;
using System.Net.Cache;

namespace Gestor_de_informacion
{
    /// <summary>
    /// Lógica de interacción para W_Graficas_ComparaTerapias.xaml
    /// </summary>
    public partial class W_Graficas_ComparaTerapias : Window
    {
         //string directorioImagenes = System.AppDomain.CurrentDomain.BaseDirectory + "R\\"; //nos dice la url donde guardar las imagenes
       
        string directorioImagenes = System.AppDomain.CurrentDomain.BaseDirectory + "R\\"; //nos dice la url donde guardar las imagenes
        string directorioTrayectoria1= System.AppDomain.CurrentDomain.BaseDirectory + "R\\Terapiamuestra1.png";
        string directorioTrayectoria2= System.AppDomain.CurrentDomain.BaseDirectory + "R\\Terapiamuestra2.png";
        string directorioMuestras1= System.AppDomain.CurrentDomain.BaseDirectory + "R\\Muestras1.png";
        string directorioMuestras2= System.AppDomain.CurrentDomain.BaseDirectory + "R\\Muestras2.png";
        public RScriptRunner objetoR = new RScriptRunner();     //Lo empleamos para comunicarnos con los scripts de R
        private string rutaR = "C:\\Program Files\\R\\R-3.1.2\\bin\\Rscript.exe";   //Ruta para usar Rscript.exe que nos permite ejecutar los scripts

        public W_Graficas_ComparaTerapias()
        {
            InitializeComponent();

        }

        private void CargarGrafica(string rutaGrafica, Image recuadro)
        {
            try
            {

                //Nos busca la imagen con el nombre de que le damos y la url que tenemos y ademas en el caso de seleccionar otra gráfica o cambiar de tiempo a valor
                // nos permite remplazar la grafica previa por una nueva
                BitmapImage _image = new BitmapImage();
                _image.BeginInit();
                _image.CacheOption = BitmapCacheOption.None;
                _image.UriCachePolicy = new RequestCachePolicy(RequestCacheLevel.BypassCache);
                _image.CacheOption = BitmapCacheOption.OnLoad;
                _image.CreateOptions = BitmapCreateOptions.IgnoreImageCache;
                _image.UriSource = new Uri(rutaGrafica, UriKind.RelativeOrAbsolute);
                _image.EndInit();
                recuadro.Source = _image;

            }

            catch (Exception ex)
            {
                MessageBox.Show("Error debido a: " + ex.Message
                    + "\r\nError debido a: " + ex.Source
                    + "\r\nError debido a: " + ex.StackTrace
                    + "\r\nError debido a: " + ex.TargetSite);
            }
        }
        private void Click_B_Volver(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
                    CargarGrafica(directorioTrayectoria1, Im_Trayectoria1);
                    CargarGrafica(directorioTrayectoria2, Im_Trayectoria2);
                    CargarGrafica(directorioMuestras1, Im_muestra1);
                    CargarGrafica(directorioMuestras2, Im_Muestra2);
        }
        //imprimimos
        private void B_Imprimir_Click(object sender, RoutedEventArgs e)
        {
            RScriptRunner R1 = new RScriptRunner();
            string directorioScriptR1 = directorioImagenes + "Imprimir.R";
            string parametros1 = 0 + " " + 1 + " " + directorioImagenes + " " + directorioTrayectoria1 + " " + "25" + " " + directorioMuestras1 + " " + directorioTrayectoria2 + " " + directorioMuestras2;
            string result1 = objetoR.RunFromCmd(directorioScriptR1, rutaR, parametros1);

           System.Diagnostics.Process proc = new System.Diagnostics.Process();

           proc.StartInfo.FileName = directorioImagenes + " Analisis_Terapias.pdf";

         proc.Start();
           proc.Close();
        }

        private void Im_Trayectoria1_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            W_Trayectoria V_Trayectoria = new W_Trayectoria(directorioTrayectoria1);
            V_Trayectoria.Owner = this;
            V_Trayectoria.ShowDialog();
        }

        private void Im_Trayectoria2_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            W_Trayectoria V_Trayectoria = new W_Trayectoria(directorioTrayectoria2);
            V_Trayectoria.Owner = this;
            V_Trayectoria.ShowDialog();
        }

        private void Im_muestra1_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            W_CompararAnalisis V_Analisis = new W_CompararAnalisis(directorioMuestras1);
            V_Analisis.Owner = this;
            V_Analisis.ShowDialog();
        }

        private void Im_Muestra2_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            W_CompararAnalisis V_Analisis = new W_CompararAnalisis(directorioMuestras1);
            V_Analisis.Owner = this;
            V_Analisis.ShowDialog();
        }


    }
}
