﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Gestor_de_informacion
{
    /// <summary>
    /// Lógica de interacción para W_ImprimirInforme.xaml
    /// </summary>
    public partial class W_ImprimirInforme : Window
    {
        Funciones f = new Funciones();
        string directorioImagenes = System.AppDomain.CurrentDomain.BaseDirectory + "R\\"; //nos dice la url donde guardar las imagenes
        string idPaciente;
        string Terapia_inicial;
        string Terapia_final;
        public RScriptRunner objetoR = new RScriptRunner();     //Lo empleamos para comunicarnos con los scripts de R
        private string rutaR = "C:\\Program Files\\R\\R-3.1.2\\bin\\Rscript.exe";   //Ruta para usar Rscript.exe que nos permite ejecutar los scripts

        public W_ImprimirInforme()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            List<PacientesBM> L_Pacientes = f.CargarCbPacientes();

            foreach (PacientesBM item in L_Pacientes)
            {

                CB_Paciente.Items.Add(item.IdPaciente);
            }
        }


        private void B_Volver_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void CB_Paciente_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            //Llamamos a funciones para obtener la identidad del paciente
            CB_Terapia_inicial.Items.Clear();
            CB_Terapia_final.Items.Clear();
            idPaciente = CB_Paciente.SelectedValue.ToString();

           List<TerapiaBM> L_Terapia = f.CargarCbTerapiasInforme(idPaciente);

           foreach (TerapiaBM item in L_Terapia)
            {
                CB_Terapia_inicial.Items.Add(item.IdTerapia);
                CB_Terapia_final.Items.Add(item.IdTerapia);

            }
        }

        private void CB_Terapia_inicial_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (CB_Terapia_inicial.SelectedIndex >= 0)
            {
                Terapia_inicial = CB_Terapia_inicial.SelectedValue.ToString();
            }
            
            
        }

        private void CB_Terapia_final_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (CB_Terapia_final.SelectedIndex >= 0)
            {
                Terapia_final = CB_Terapia_final.SelectedValue.ToString();
            }
            
            
        }

        private void B_Generar_informe_Click(object sender, RoutedEventArgs e)
        {
            if (ChB_Terapia1.IsChecked == false && ChB_Terapia2.IsChecked == false)
            {
                MessageBox.Show("Seleccione al menos un tipo de terapia");
            }
            else if (CB_Paciente.SelectedIndex < 0) {
                MessageBox.Show("Seleccione un Paciente");
            }
            else if (CB_Terapia_inicial.SelectedIndex < 0)
            {
                MessageBox.Show("Seleccione una terapia inicial");
            }
            else if (CB_Terapia_final.SelectedIndex < 0)
            {
                MessageBox.Show("Seleccione una terapia final");
            }
            else if (int.Parse(Terapia_inicial) > int.Parse(Terapia_final))
            {
                MessageBox.Show("La terapia inicial no puede ser mayor a la terapia final");
            }
            else if (int.Parse(Terapia_inicial) == int.Parse(Terapia_final))
            {
                MessageBox.Show("La terapia inicial y la terapia final no pueden ser iguales");
            }
            else if (ChB_Fuerza.IsChecked == false && ChB_Error.IsChecked == false && ChB_Facilidad.IsChecked == false && ChB_Marcador.IsChecked == false && ChB_media.IsChecked == false && ChB_Simetria2.IsChecked == false && ChB_Simetriaxy.IsChecked == false && ChB_Temblores.IsChecked == false && ChB_Tiempo_Reaccion.IsChecked == false)
            {
                MessageBox.Show("Seleccione al menos un tipo de gráfica");
            }
            else
            {
                int Paciente = CB_Paciente.SelectedIndex+1;
                int Terapia1=0;
                int Terapia2=0;
                int Marcador=0;              
                int Error=0;
                int media=0;
                int Facilidad=0;
                int tiempo_reaccion=0;
                int Temblores=0;
                int simetriaxy=0;
                int simetria2=0;           
                int Fuerza=0;
               
                if (ChB_Terapia1.IsChecked == true)
                {
                    Terapia1 = 1;
                }

                if (ChB_Terapia2.IsChecked == true)
                {
                    Terapia2 = 1;
                }

                if (ChB_Marcador.IsChecked == true)
                {
                    Marcador = 1;
                }

                if (ChB_Error.IsChecked == true)
                {
                    Error = 1;
                }

                if (ChB_media.IsChecked == true)
                {
                    media = 1;
                }

                if (ChB_Facilidad.IsChecked == true)
                {
                    Facilidad = 1;
                }

                if (ChB_Tiempo_Reaccion.IsChecked == true)
                {    
                    tiempo_reaccion = 1;
                }

                if (ChB_Temblores.IsChecked == true)
                {
                    Temblores = 1;
                }

                if (ChB_Simetriaxy.IsChecked == true)
                {
                    simetriaxy = 1;
                }

                if (ChB_Simetria2.IsChecked == true)
                {
                    simetria2 = 1;
                }

                if (ChB_Fuerza.IsChecked == true)
                {
                    Fuerza = 1;
                }
                
                RScriptRunner R0 = new RScriptRunner();
                string directorioScriptR0 = directorioImagenes + "Informe.R";
                string parametros0 = directorioImagenes + " " + int.Parse(Terapia_final) + " " + int.Parse(Terapia_inicial) + " " + Paciente + " " + Terapia1 + " " + Terapia2 + " " + Marcador + " " + Error + " " + media + " " + Facilidad + " " + tiempo_reaccion + " " + Temblores + " " + simetriaxy + " " + simetria2 + " "+ Fuerza;
                string result0 = objetoR.RunFromCmd(directorioScriptR0, rutaR, parametros0);
                
                
                System.Diagnostics.Process proc = new System.Diagnostics.Process();
                proc.StartInfo.FileName = directorioImagenes + " Informe_paciente_ " + Paciente + " .pdf";

                proc.Start();
                proc.Close();

            }
        }




    }
}
