########################################################################################################################################################################################################
###Autor: Miguel Zatarain
###Fecha: 27/04/2015
###Aceleracion en el eje x
###Script que va a calcular la aceleracion  en el eje x durante una terapia
############################################################################################################################
args <- commandArgs(TRUE)
require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")
require(FKF) #Para filtrar la aceleracin

amedx<-as.numeric(args[4])
amaxx<-as.numeric(args[2])
aminx<-as.numeric(args[3])
n<-as.numeric(args[5])

b<-paste("SELECT     IdMuestra, PosicionX, PosicionY, FuerzaX, FuerzaY, IdTerapia, FuerzaAsistiva, VelocidadX, Tiempo, VelocidadY, PuntoDeseadoX, PuntoDeseadoY
FROM         Muestra
WHERE     (IdTerapia = ",n,")
ORDER BY IdMuestra",sep="")

Data.fr <- sqlQuery(conn, b, errors=T)
attach(Data.fr)
a<-max(dim(Data.fr))


ti<-as.character(Tiempo)
s1 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[1])))
s2 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[2])))
s3 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[3])))
Vtiempois<-s1*3600+s2*60+s3
#Ya tenemos el tiempo en segundos
#Vamos a quitar los primeros 5 valores de cada columna porque tienen un error que puede llevar a errores
#Asignamos los valores de cada columna a una variable
Vtiempo<-Vtiempois[4:a]


vx<-VelocidadX
vx<-(vx[4:a])/1000


pdx<-PuntoDeseadoX
pdx<-(pdx[5:a])
pdy<-PuntoDeseadoY
pdy<-(pdy[5:a])
maxleng<-length(pdx)

#Calibramos la posicion del robot
pxo<-(rep(1,a-4))
pxf<-(pdx+pxo)/1000


aceleracionx<-diff(vx)/(diff(Vtiempo))
aceleracionx[is.na(aceleracionx)] <- 0
aceleracionx[is.infinite(aceleracionx)] <- 1

#Dado que el tiempo de muestro es distinto cada vez no nos da los mismo puntos exactos, asique para saber donde
#empieza una vuelta seleccionamos un pequeno area
Iniciox<-pdx[150]
Inicioy<-pdy[150]
filtro<-(1:maxleng)*0
for(i in 1:(maxleng)){ 
	if(Iniciox>(pdx[i]-30) & Inicioy>(pdy[i]-30) & Iniciox<(pdx[i]+30) & Inicioy<pdy[i]+30) {
	filtro[i]=i}
}

#Filtramos para que solo se produzcan varios de los puntos de ese area seguidos

filtrob<-filtro*0

for(i in 1:(maxleng)){
	if (i>110){
	if((filtro[i]!=0)&(filtro[i-1]!=0)&(filtro[i-2]!=0)&(filtro[i-3]!=0)&(filtro[i-4]!=0)&(filtro[i-5]!=0)&(filtro[i-6]!=0)){
	filtrob[i]=i}
	}
}

#Calculamos los lmites de inicio de cada vuelta
a=150
b<-1
limites<-vector()
for(i in 1:(maxleng)){ 
	if(filtrob[i]>a+650) {
		limites[b]=i
		b<-b+1
		a<-i}
}

#Inicializamos los vectores para calcular los puntos mximos mnimo y medio


aceleracionesx1<-vector()
aceleracionesx2<-vector()
mediaacexcompara<-mean(abs(aceleracionx))
mediaacex<-aceleracionx[limites[1]:limites[2]]
maxacex<-aceleracionx[limites[1]:limites[2]]
minacex<-aceleracionx[limites[1]:limites[2]]
minpdxace<-pxf[limites[1]:limites[2]]
maxpdxace<-pxf[limites[1]:limites[2]]
mediapdxace<-pxf[limites[1]:limites[2]]
Vtiempoax1<-Vtiempo[limites[1]:limites[2]]
Vtiempoax2<-Vtiempo[limites[1]:limites[2]]
Vtiempoax3<-Vtiempo[limites[1]:limites[2]]

for(i in 1:(length(limites))){
	if(i<(length(limites)-1)){

			#Calculamos las velocidades

			aceleracionesx1<-aceleracionx[limites[i]:limites[i+1]]
			aceleracionesx2<-aceleracionx[limites[i+1]:limites[i+2]]			
			
			if(mean(abs(aceleracionesx1)) < mean(abs(aceleracionesx2)) & mean(abs(aceleracionesx2))>mean(abs(maxacex))){
			maxacex<-aceleracionesx2
			maxpdxace<-pxf[limites[i+1]:limites[i+2]]
			Vtiempoax1<-Vtiempo[limites[i+1]:limites[i+2]]
			}
			
			if(mean(abs(aceleracionesx1))> mean(abs(aceleracionesx2))& mean(abs(aceleracionesx2))<mean(abs(minacex))){
			minacex<-aceleracionesx2
			minpdxace<-pxf[limites[i+1]:limites[i+2]]
			Vtiempoax2<-Vtiempo[limites[i+1]:limites[i+2]]
			}

			if(abs(1-(abs(mean(abs(aceleracionesx1))/mediaacexcompara))) > abs(1-(abs(mean(abs(aceleracionesx2))/mediaacexcompara)))& abs(1-(abs(mean(abs(aceleracionesx2))/mediaacexcompara)))< abs(1-(abs(mean(abs(mediaacex))/mediaacexcompara)))){
			mediaacex<-aceleracionesx2
			mediapdxace<-pxf[limites[i+1]:limites[i+2]]
			Vtiempoax3<-Vtiempo[limites[i+1]:limites[i+2]]
			}			
}
}

Vtiempoax1<-Vtiempoax1 - Vtiempoax1[1]
Vtiempoax2<-Vtiempoax2 - Vtiempoax2[1]
Vtiempoax3<-Vtiempoax3 - Vtiempoax3[1]

maxtiempo<-max(max(Vtiempoax1),max(Vtiempoax2),max(Vtiempoax3))

Vtiempoax1<-Vtiempoax1*maxtiempo/max(Vtiempoax1)
Vtiempoax2<-Vtiempoax2*maxtiempo/max(Vtiempoax2)
Vtiempoax3<-Vtiempoax3*maxtiempo/max(Vtiempoax3)

#Empezamos a graficar
#Calculamos el mayor valor de de y para el ploteo
maxy<-max(max(maxacex),max(minacex),max(mediaacex),(1.5+max(mediapdxace)))
miny<-min(min(maxacex),min(minacex),min(mediaacex))

if(as.numeric(args[6])==0){
png(paste(args[1],"R\\AceleracionvxTerapia",n,".png",sep=""),width = 1147, height = 756, units = "px", pointsize = 16)

}
if(as.numeric(args[6])==1){
png(paste(args[1],"R\\Muestras1.png",sep=""),width = 1275, height = 450, units = "px", pointsize = 16)

}
if(as.numeric(args[6])==2){
png(paste(args[1],"R\\Muestras2.png",sep=""),width = 1275, height = 450, units = "px", pointsize = 16)

}


par(mar=c(5, 4, 4, 5) + 0.1)
x <- c(1,max(Vtiempoax1)); y <- c(miny,1.4*maxy);
 maxy<-1.4*maxy 
plot(x, y,type="b", pch=21, col="white",xaxt="n", lty=3, xlab="Tiempo(s)", ylab="Aceleracin (m^2/s)")
axis(1,at=c(1:max(Vtiempoax1)))
mtext("Distancia (m)", side=4, line=3, cex.lab=1,las=0)
if(amaxx>0.5){ 
#############################################################
#Filtro para la aceleracin mx

y <- maxacex
y[c(3, 10)] <- NA  # Para que los valores NA sean tratados
## Inicializamos las constantes en los parmetros:
dt <- ct <- matrix(0)
Zt <- Tt <- matrix(1)
a0 <- y[1]            # Variacin del primer valor
P0 <- matrix(100)     # variacin de a0
## Parametros estimados:
fit.fkf <- optim(c(HHt = var(y, na.rm = TRUE) * .5,
GGt = var(y, na.rm = TRUE) * .5),
fn = function(par, ...)
-fkf(HHt = matrix(par[1]), GGt = matrix(par[2]), ...)$logLik,
yt = rbind(y), a0 = a0, P0 = P0, dt = dt, ct = ct,
Zt = Zt, Tt = Tt, check.input = FALSE)
## Filtramos la aceleracion con los parametros estimados:
amaxxfkf<-fkf(a0, P0, dt, ct, Tt, Zt, HHt = matrix(fit.fkf$par[1]),
GGt = matrix(fit.fkf$par[2]), yt = rbind(y))
############################################################

axis(4, at= 1.5 + seq((miny-1.5),(maxy-1.5), by=.5),labels=round(seq(miny-1.5, maxy-1.5, by=.5),digits=2), las=2, tck=-.01)
plotxamax<-amaxxfkf$att[1, ]
lines((Vtiempoax1),plotxamax[1:length(Vtiempoax1)], type="overplotted",pch=1, col="blue")
lines((Vtiempoax1),1.5+maxpdxace[1:length(Vtiempoax1)],type="overplotted", pch=4, col="black")
legend("topleft",legend=c("Aceleracin mxima del paciente en el eje x (m^2/s)","Puntos deseados del paciente en el eje x (m)"),box.lty=1,pch=c(1,4),col=c("blue","black"))
}
if(aminx>0.5){

#############################################################
#Filtro para la aceleracin mx

y <- minacex
y[c(3, 10)] <- NA  # Para que los valores NA sean tratados
## Inicializamos las constantes en los parmetros:
dt <- ct <- matrix(0)
Zt <- Tt <- matrix(1)
a0 <- y[1]            # Variacin del primer valor
P0 <- matrix(100)     # variacin de a0
## Parametros estimados:
fit.fkf <- optim(c(HHt = var(y, na.rm = TRUE) * .5,
GGt = var(y, na.rm = TRUE) * .5),
fn = function(par, ...)
-fkf(HHt = matrix(par[1]), GGt = matrix(par[2]), ...)$logLik,
yt = rbind(y), a0 = a0, P0 = P0, dt = dt, ct = ct,
Zt = Zt, Tt = Tt, check.input = FALSE)
## Filtramos la aceleracion con los parametros estimados:
minacexfkf<-fkf(a0, P0, dt, ct, Tt, Zt, HHt = matrix(fit.fkf$par[1]),
GGt = matrix(fit.fkf$par[2]), yt = rbind(y))
############################################################

axis(4, at= 1.5 + seq((miny-1.5),(maxy-1.5), by=.5),labels=round(seq(miny-1.5, maxy-1.5, by=.5),digits=2), las=2, tck=-.01)
plotminacex<-minacexfkf$att[1, ]
lines((Vtiempoax2),plotminacex[1:length(Vtiempoax2)], type="overplotted",pch=2, col="red")
lines((Vtiempoax2),1.5+minpdxace[1:length(Vtiempoax2)],type="overplotted", pch=4, col="black")
legend("topleft",legend=c("Aceleracin mnima del paciente en el eje x (m^2/s)","Puntos deseados del paciente en el eje x (m)"),box.lty=1,pch=c(2,4),col=c("red","black"))

}
if(amedx>0.5){


#############################################################
#Filtro para la aceleracin mx

y <- mediaacex
y[c(3, 10)] <- NA  # Para que los valores NA sean tratados
## Inicializamos las constantes en los parmetros:
dt <- ct <- matrix(0)
Zt <- Tt <- matrix(1)
a0 <- y[1]            # Variacin del primer valor
P0 <- matrix(100)     # variacin de a0
## Parametros estimados:
fit.fkf <- optim(c(HHt = var(y, na.rm = TRUE) * .5,
GGt = var(y, na.rm = TRUE) * .5),
fn = function(par, ...)
-fkf(HHt = matrix(par[1]), GGt = matrix(par[2]), ...)$logLik,
yt = rbind(y), a0 = a0, P0 = P0, dt = dt, ct = ct,
Zt = Zt, Tt = Tt, check.input = FALSE)
## Filtramos la aceleracion con los parametros estimados:
mediaacexfkf<-fkf(a0, P0, dt, ct, Tt, Zt, HHt = matrix(fit.fkf$par[1]),
GGt = matrix(fit.fkf$par[2]), yt = rbind(y))
############################################################

axis(4, at= 1.5 + seq((miny-1.5),(maxy-1.5), by=.5),labels=round(seq(miny-1.5, maxy-1.5, by=.5),digits=2), las=2, tck=-.01)
plotmediaacex<-mediaacexfkf$att[1, ]
lines((Vtiempoax3),plotmediaacex[1:length(Vtiempoax3)], type="overplotted",pch=3, col="green")
lines((Vtiempoax3),1.5+mediapdxace[1:length(Vtiempoax3)],type="overplotted", pch=4, col="black")
legend("topleft",legend=c("Aceleracin media del paciente en el eje x(m^2/s)","Puntos deseados del paciente en el eje x(m)"),box.lty=1,pch=c(3,4),col=c("green","black"))

}

main<-"Aceleracin del paciente en el eje x"
sub<-paste(" NTerapia: ",n,sep="")
title(main, sub)

dev.off()
rm(sub,main,x,y,maxy,maxtiempo,miny,amaxx,aceleracionx,aminx,amedx,aceleracionesx1,aceleracionesx2,mediaacexcompara,mediaacex,maxacex,minacex,minpdxace,maxpdxace,mediapdxace,Vtiempoax1,Vtiempoax2,Vtiempoax3,limites,filtro,i,a,b,n,filtrob,maxleng,pdx,pdy,pxo,pxf,vx,Iniciox,Inicioy,Vtiempo,Vtiempois,ti,s1,s2,s3,Data.fr,a0,amaxxfkf,ct,dt,fit.fkf,mediaacexfkf,minacexfkf,plotmediaacex,plotxamax,Tt,Zt,P0,plotminacex)
