########################################################################################################################################################################################################
###Autor: Miguel Zatarain
###Fecha: 24/04/2015
###Aceleracion en el eje y
###Script que va a calcular la velocidad en el eje y durante una terapia
############################################################################################################################
args <- commandArgs(TRUE)
require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")
require(FKF) #Para filtrar la aceleracin

amedy<-as.numeric(args[4])
amaxy<-as.numeric(args[2])
aminy<-as.numeric(args[3])
n<-as.numeric(args[5])

b<-paste("SELECT     IdMuestra, PosicionX, PosicionY, FuerzaX, FuerzaY, IdTerapia, FuerzaAsistiva, VelocidadX, Tiempo, VelocidadY, PuntoDeseadoX, PuntoDeseadoY
FROM         Muestra
WHERE     (IdTerapia = ",n,")
ORDER BY IdMuestra",sep="")

Data.fr <- sqlQuery(conn, b, errors=T)
attach(Data.fr)
a<-max(dim(Data.fr))


ti<-as.character(Tiempo)
s1 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[1])))
s2 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[2])))
s3 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[3])))
Vtiempois<-s1*3600+s2*60+s3
#Ya tenemos el tiempo en segundos
#Vamos a quitar los primeros 5 valores de cada columna porque tienen un error que puede llevar a errores
#Asignamos los valores de cada columna a una variable
Vtiempo<-Vtiempois[4:a]


vy<-VelocidadY
vy<-(vy[4:a])/1000

pdx<-PuntoDeseadoX
pdx<-(pdx[5:a])
pdy<-PuntoDeseadoY
pdy<-(pdy[5:a])
maxleng<-length(pdx)

pyo<-rep(600,a-4)
pyf<-(pyo-pdy)/1000


aceleraciony<-diff(vy)/(diff(Vtiempo))
aceleraciony[is.na(aceleraciony)] <- 0
aceleraciony[is.infinite(aceleraciony)] <- 1

#Dado que el tiempo de muestro es distinto cada vez no nos da los mismo puntos exactos, asique para saber donde
#empieza una vuelta seleccionamos un pequeno area
Iniciox<-pdx[150]
Inicioy<-pdy[150]
filtro<-(1:maxleng)*0
for(i in 1:(maxleng)){ 
	if(Iniciox>(pdx[i]-30) & Inicioy>(pdy[i]-30) & Iniciox<(pdx[i]+30) & Inicioy<pdy[i]+30) {
	filtro[i]=i}
}

#Filtramos para que solo se produzcan varios de los puntos de ese area seguidos

filtrob<-filtro*0

for(i in 1:(maxleng)){
	if (i>110){
	if((filtro[i]!=0)&(filtro[i-1]!=0)&(filtro[i-2]!=0)&(filtro[i-3]!=0)&(filtro[i-4]!=0)&(filtro[i-5]!=0)&(filtro[i-6]!=0)){
	filtrob[i]=i}
	}
}

#Calculamos los lmites de inicio de cada vuelta
a=150
b<-1
limites<-vector()
for(i in 1:(maxleng)){ 
	if(filtrob[i]>a+600) {
		limites[b]=i
		b<-b+1
		a<-i}
}

#Inicializamos los vectores para calcular los puntos mximos mnimo y medio


aceleracionesy1<-vector()
aceleracionesy2<-vector()
mediaaceycompara<-mean(abs(aceleraciony))
mediaacey<-aceleraciony[limites[1]:limites[2]]
maxacey<-aceleraciony[limites[1]:limites[2]]
minacey<-aceleraciony[limites[1]:limites[2]]
minpdyace<-pyf[limites[1]:limites[2]]
maxpdyace<-pyf[limites[1]:limites[2]]
mediapdyace<-pyf[limites[1]:limites[2]]
mediaVtiempov<-Vtiempo[limites[1]:limites[2]]
Vtiempoay1<-Vtiempo[limites[1]:limites[2]]
Vtiempoay2<-Vtiempo[limites[1]:limites[2]]
Vtiempoay3<-Vtiempo[limites[1]:limites[2]]

for(i in 1:(length(limites))){
	if(i<(length(limites)-1)){

			#Calculamos las velocidades

			aceleracionesy1<-aceleraciony[limites[i]:limites[i+1]]
			aceleracionesy2<-aceleraciony[limites[i+1]:limites[i+2]]			
			
			if(mean(abs(aceleracionesy1)) < mean(abs(aceleracionesy2)) & mean(abs(aceleracionesy2))>mean(abs(maxacey))){
			maxacey<-aceleracionesy2
			maxpdyace<-pyf[limites[i+1]:limites[i+2]]
			Vtiempoay1<-Vtiempo[limites[i+1]:limites[i+2]]

			}
			
			if(mean(abs(aceleracionesy1))> mean(abs(aceleracionesy2))& mean(abs(aceleracionesy2))<mean(abs(minacey))){
			minacey<-aceleracionesy2
			minpdyace<-pyf[limites[i+1]:limites[i+2]]
			Vtiempoay2<-Vtiempo[limites[i+1]:limites[i+2]]
			}

			if(abs(1-(abs(mean(abs(aceleracionesy1))/mediaaceycompara))) > abs(1-(abs(mean(abs(aceleracionesy2))/mediaaceycompara)))& abs(1-(abs(mean(abs(aceleracionesy2))/mediaaceycompara)))< abs(1-(abs(mean(abs(mediaacey))/mediaaceycompara)))){
			mediaacey<-aceleracionesy2
			mediapdyace<-pyf[limites[i+1]:limites[i+2]]
			Vtiempoay3<-Vtiempo[limites[i+1]:limites[i+2]]
			}			
}
}
Vtiempoay1<-Vtiempoay1 - Vtiempoay1[1]
Vtiempoay2<-Vtiempoay2 - Vtiempoay2[1]
Vtiempoay3<-Vtiempoay3 - Vtiempoay3[1]

maxtiempo<-max(max(Vtiempoay1),max(Vtiempoay2),max(Vtiempoay3))

Vtiempoay1<-Vtiempoay1*maxtiempo/max(Vtiempoay1)
Vtiempoay2<-Vtiempoay2*maxtiempo/max(Vtiempoay2)
Vtiempoay3<-Vtiempoay3*maxtiempo/max(Vtiempoay3)

#Empezamos a graficar
#Calculamos el mayor valor de de y para el ploteo
maxy<-max(max(maxacey),max(minacey),max(mediaacey),(1.5+max(mediapdyace)))
miny<-min(min(maxacey),min(minacey),min(mediaacey))


if(as.numeric(args[6])==0){
png(paste(args[1],"R\\AceleracionvyTerapia",n,".png",sep=""),width = 1147, height = 756, units = "px", pointsize = 16)

}
if(as.numeric(args[6])==1){
png(paste(args[1],"R\\Muestras1.png",sep=""),width = 1275, height = 450, units = "px", pointsize = 16)

}
if(as.numeric(args[6])==2){
png(paste(args[1],"R\\Muestras2.png",sep=""),width = 1275, height = 450, units = "px", pointsize = 16)

}
par(mar=c(5, 4, 4, 5) + 0.1)
x <- c(1,max(Vtiempoay1)); y <- c(miny,1.4*maxy);
maxy<-1.4*maxy 
plot(x, y,type="b", pch=21, col="white",xaxt="n", lty=3, xlab="Tiempo(s)", ylab="Aceleracin (m^2/s)")
axis(1,at=c(1:max(Vtiempoay1)))
mtext("Distancia (m)", side=4, line=3, cex.lab=1,las=0)

if(amaxy>0.5){
#############################################################
#Filtro para la aceleracin mx

y <- maxacey
y[c(3, 10)] <- NA  # Para que los valores NA sean tratados
## Inicializamos las constantes en los parmetros:
dt <- ct <- matrix(0)
Zt <- Tt <- matrix(1)
a0 <- y[1]            # Variacin del primer valor
P0 <- matrix(100)     # variacin de a0
## Parametros estimados:
fit.fkf <- optim(c(HHt = var(y, na.rm = TRUE) * .5,
GGt = var(y, na.rm = TRUE) * .5),
fn = function(par, ...)
-fkf(HHt = matrix(par[1]), GGt = matrix(par[2]), ...)$logLik,
yt = rbind(y), a0 = a0, P0 = P0, dt = dt, ct = ct,
Zt = Zt, Tt = Tt, check.input = FALSE)
## Filtramos la aceleracion con los parametros estimados:
amaxyfkf<-fkf(a0, P0, dt, ct, Tt, Zt, HHt = matrix(fit.fkf$par[1]),
GGt = matrix(fit.fkf$par[2]), yt = rbind(y))
############################################################
axis(4, at= 1.5 + seq((miny-1.5),(maxy-1.5), by=.5),labels=round(seq(miny-1.5, maxy-1.5, by=.5),digits=2), las=2, tck=-.01)
plotyamax<-amaxyfkf$att[1, ]
lines((Vtiempoay1),plotyamax[1:length(Vtiempoay1)], type="overplotted",pch=1, col="blue")
lines((Vtiempoay1),1.5+maxpdyace[1:length(Vtiempoay1)],type="overplotted", pch=4, col="black")
legend("topleft",legend=c("Aceleracin mxima del paciente en el eje y (m^2/s)","Puntos deseados del paciente en el eje y (m)"),box.lty=1,pch=c(1,4),col=c("blue","black"))
}
if(aminy>0.5){

#############################################################
#Filtro para la aceleracin mx

y <- minacey
y[c(3, 10)] <- NA  # Para que los valores NA sean tratados
## Inicializamos las constantes en los parmetros:
dt <- ct <- matrix(0)
Zt <- Tt <- matrix(1)
a0 <- y[1]            # Variacin del primer valor
P0 <- matrix(100)     # variacin de a0
## Parametros estimados:
fit.fkf <- optim(c(HHt = var(y, na.rm = TRUE) * .5,
GGt = var(y, na.rm = TRUE) * .5),
fn = function(par, ...)
-fkf(HHt = matrix(par[1]), GGt = matrix(par[2]), ...)$logLik,
yt = rbind(y), a0 = a0, P0 = P0, dt = dt, ct = ct,
Zt = Zt, Tt = Tt, check.input = FALSE)
## Filtramos la aceleracion con los parametros estimados:
minaceyfkf<-fkf(a0, P0, dt, ct, Tt, Zt, HHt = matrix(fit.fkf$par[1]),
GGt = matrix(fit.fkf$par[2]), yt = rbind(y))
############################################################
axis(4, at= 1.5 + seq((miny-1.5),(maxy-1.5), by=.5),labels=round(seq(miny-1.5, maxy-1.5, by=.5),digits=2), las=2, tck=-.01)
plotminacey<-minaceyfkf$att[1, ]
lines((Vtiempoay2),plotminacey[1:length(Vtiempoay2)], type="overplotted",pch=3, col="red")
lines((Vtiempoay2),1.5+minpdyace[1:length(Vtiempoay2)],type="overplotted", pch=4, col="black")
legend("topleft",legend=c("Aceleracin mnima del paciente en el eje y (m^2/s)","Puntos deseados del paciente en el eje y (m^2/s)"),box.lty=1,pch=c(3,4),col=c("red","black"))
}
if(amedy>0.5){


#############################################################
#Filtro para la aceleracin mx

y <- mediaacey
y[c(3, 10)] <- NA  # Para que los valores NA sean tratados
## Inicializamos las constantes en los parmetros:
dt <- ct <- matrix(0)
Zt <- Tt <- matrix(1)
a0 <- y[1]            # Variacin del primer valor
P0 <- matrix(100)     # variacin de a0
## Parametros estimados:
fit.fkf <- optim(c(HHt = var(y, na.rm = TRUE) * .5,
GGt = var(y, na.rm = TRUE) * .5),
fn = function(par, ...)
-fkf(HHt = matrix(par[1]), GGt = matrix(par[2]), ...)$logLik,
yt = rbind(y), a0 = a0, P0 = P0, dt = dt, ct = ct,
Zt = Zt, Tt = Tt, check.input = FALSE)
## Filtramos la aceleracion con los parametros estimados:
mediaaceyfkf<-fkf(a0, P0, dt, ct, Tt, Zt, HHt = matrix(fit.fkf$par[1]),
GGt = matrix(fit.fkf$par[2]), yt = rbind(y))
############################################################
axis(4, at= 1.5 + seq((miny-1.5),(maxy-1.5), by=.5),labels=round(seq(miny-1.5, maxy-1.5, by=.5),digits=2), las=2, tck=-.01)
plotmediaacey<-mediaaceyfkf$att[1, ]
lines((Vtiempoay3),plotmediaacey[1:length(Vtiempoay3)], type="overplotted",pch=3, col="green")
lines((Vtiempoay3),1.5+mediapdyace[1:length(Vtiempoay3)],type="overplotted", pch=4, col="black")
legend("topleft",legend=c("Aceleracin media del paciente en el eje y (m^2/s)","Puntos deseados del paciente en el eje y (m)"),box.lty=1,pch=c(3,4),col=c("green","black"))

}
main<-"Aceleracin del paciente en el eje y"
sub<-paste(" NTerapia: ",n,sep="")
title(main, sub)
dev.off()
rm(sub,main,x,y,maxy,maxtiempo,miny,amaxy,maxacey,aceleraciony,aminy,amedy,aceleracionesy1,aceleracionesy2,mediaaceycompara,mediaacey,maxacex,minacey,minpdyace,maxpdyace,mediapdyace,Vtiempoay1,Vtiempoay2,Vtiempoay3,limites,filtro,i,a,b,n,filtrob,maxleng,pdx,pdy,pyo,pyf,vy,Iniciox,Inicioy,Vtiempo,Vtiempois,ti,s1,s2,s3,Data.fr,a0,amaxyfkf,ct,dt,fit.fkf,mediaaceyfkf,minaceyfkf,plotmediaacey,plotyamax,Tt,Zt,P0,plotminacey)
