########################################################################################################################################################################################################
###Autor: Miguel Zatarain
###Fecha: 20/04/2015
###Fuerzas
###Script que va a calcular la fuerza en x y en y y su fuerza asistiva
############################################################################################################################################################################################
#Obtenemos los valores de la tabla para seleccionar la terapia la identidad del paciente y el tipo de terapia que queremos
args <- commandArgs(TRUE)

require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")


direccion<-paste(args[1],"R\\Resumen.txt",sep="")
idpac<-as.numeric(args[2])
nmax<-as.numeric(args[5])
nmin<-as.numeric(args[4])
tipoterapia<-as.numeric(args[3])

mydata<-c('nterapia','paciente','terapiatipo','ECM','STD','ve','t_reaccion','errorx','errory','v_pac_parado','v_rob_parado','v_pac_rob','sd_x','sd_y','sd_vx','sd_vy','sd_magnitudvel','sd_angulo','Evolucionx','Evoluciony','marca')

if(file.exists(direccion)){
	existe<-read.table(direccion, sep="\t",col.names=mydata)
	attach(existe)
		if(max(nterapia)>nmin){
		nmmax<-max(nterapia)
		m<-subset(existe, tipoterapia == terapiatipo & nterapia>nmin & nterapia<=nmax & paciente==idpac)
		attach(m)
		Evolutionxact<-Evolucionx
		Evolutionyact<-Evoluciony
		nmin<-max(nterapia)
		vector.terapiaact<-nterapia
		rm(m,existe)
		}
	}else{ Evolutionxact<-0
		nmmax<-nmax
}

rm(mydata)

if(nmin < nmmax){

t<-paste("SELECT     IdTerapia, IdPaciente, TipoTerapia
FROM         TerapiaBM
WHERE     (IdPaciente = ",idpac,") AND (IdTerapia <= ",nmax,") AND (IdTerapia >= ",nmin,") AND (TipoTerapia = ",tipoterapia,")",sep="")
#conectampos con la tabla por primera vez para obtener una pequea tabla y saber que tipo de terapia queremos seguir
tablapequena<- sqlQuery(conn, t, errors=T)
attach(tablapequena)
vector.terapia<-IdTerapia
rm(tablapequena)
q<-paste("SELECT     m.IdMuestra, m.PosicionX, m.PosicionY, m.PuntoDeseadoX, m.PuntoDeseadoY, t.IdTerapia, m.Tiempo, m.FuerzaX, m.FuerzaY, m.FuerzaAsistiva, m.VelocidadX, m.VelocidadY, p.IdPaciente
FROM         Muestra AS m INNER JOIN
                      TerapiaBM AS t ON m.IdTerapia = t.IdTerapia INNER JOIN
                      PacientesBM AS p ON t.IdPaciente = p.IdPaciente
WHERE     (p.IdPaciente = ",idpac,") AND (t.IdTerapia <= ",nmax,") AND (t.IdTerapia >= ",nmin,")
ORDER BY m.IdMuestra",sep="")

#Conectamos con una tabla mucho ms grande para obtener el resto de valores que necesitamos
tablacompleta<- sqlQuery(conn, q, errors=T)
attach(tablacompleta)

#inicializamos el tamao de los vectores que vamos a tener en el bucle
maxnterapias<-length(vector.terapia)
filtro<-(length(vector.terapia):1)*0

#Introducimos las constantes para guardar las medias de las fuerzas en Newtons
Evolutionx<-(1:maxnterapias)*0
Evolutiony<-(1:maxnterapias)*0



#Ganancia del sistema

Ks<-5								#Adimensional, esta ganancia enmascara la dinmica del sistema

#Constantes Algoritmo de impedancia

m<-1								# En Kg
b<-18								# En Kg/s

#vamos a hacer un bucle para leer todas las terapias que ha realizado del tipo seleccionado
for(i in 1:(maxnterapias)) {

	#Reducimos la tabla completa para solo leer los pacientes con las terapias que queremos
	tablareducida<-subset(tablacompleta, IdTerapia == vector.terapia[i])
	attach(tablareducida)
	a<-max(dim(tablareducida))
	#Dado que puede haber valores en los que se ha tomado muy pocos datos y nos van a dar picos en las graficas, solo vamos a recoer aquellos que nos valgan
	if(a >4500){

		#debido a que el tiempo es un caracter vamos a transformarlo a numrico en segundos mediante un bucle
		ti<-as.character(Tiempo)
		s1 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[1])))
		s2 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[2])))
		s3 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[3])))
		Vtiempois<-s1*3600+s2*60+s3
		#Ya tenemos el tiempo en segundos
		#Vamos a quitar los primeros 5 valores de cada columna porque tienen un error que puede llevar a errores
		#Asignamos los valores de cada columna a una variable
		Vtiempo<-Vtiempois[4:a]

		Fx<-FuerzaX
		Fx<-Fx[5:a]

		Fy<-FuerzaY
		Fy<-Fy[5:a]

		k<-FuerzaAsistiva 		# En Kg/s^2
		k<-k[5:a]

		vx<-VelocidadX
		vx<-(vx[4:a])/1000

		vy<-VelocidadY
		vy<-(vy[4:a])/1000


		px<-PosicionX
		px<-px[5:a]
		py<-PosicionY
		py<-py[5:a]
		pdx<-PuntoDeseadoX
		pdx<-pdx[5:a]
		pdy<-PuntoDeseadoY
		pdy<-pdy[5:a]

		#Calibramos la posicion del robot
		pyo<-rep(600,a-4)
		pxo<-rep(1,a-4)
		pyf<-(pyo-pdy)
		pxf<-(pdx+pxo)

		maxleng<-(length(Fx))
		aceleracionx<-diff(vx)/(diff(Vtiempo))
		aceleracionx[is.na(aceleracionx)] <- 0
		aceleracionx[is.infinite(aceleracionx)] <- 1
		Fdx<- m*aceleracionx + b*vx + k*((pxf - px)/1000)									# Calculo de la fuerza deseada segn el algoritmo hptico

		aceleraciony<-diff(vy)/(diff(Vtiempo))
		aceleraciony[is.na(aceleraciony)] <- 0						
		aceleraciony[is.infinite(aceleraciony)] <- 1
		Fdy<- m*aceleraciony + b*vy + k*((pyf - py)/1000)									# Calculo de la fuerza deseada segn el algoritmo hptico

		mFx<-mean(abs(Fx))
		mFy<-mean(abs(Fy))

		mFayudax<-mean(abs(Fdx))
		mFayuday<-mean(abs(Fdy))

		if(tipoterapia>1){
			Evolutionx[i]<-100*(mFx/1000)/((mFx/1000)+(mFayudax))
			Evolutiony[i]<-100*(mFy/1000)/((mFy/1000)+(mFayuday))
		}else{
			Evolutionx[i]<-100*mFx/(mFx+mFayudax)
			Evolutiony[i]<-100*mFy/(mFy+mFayuday)
		}

		filtro[i]<-i
		}
	else{
		filtro[i]<-0	
	}
	detach(tablareducida)
	rm(a,aceleraciony,Fdy,eFy,Fsy,Fcy,aceleracionx,Fdx,eFx,Fsx,Fcx,Fx,Fy,vx,vy,vxf,vyf,pdx,pdy,px,py,pyo,pxo,vyo,vxo,pyf,pxf,tablareducida,ti,s1,s2,s3,Vtiempo,Vtiempois)

}

if(length(Evolutionxact)>1){
		vector.terapia<-c(vector.terapiaact[1:(length(vector.terapiaact)-1)],vector.terapia[filtro])
		Evolutionx<-c(Evolutionxact[1:(length(vector.terapiaact)-1)],Evolutionx[filtro])
		Evolutiony<-c(Evolutionyact[1:(length(vector.terapiaact)-1)],Evolutiony[filtro])
	}else{
		Evolutiony<-Evolutiony[filtro]
		Evolutionx<-Evolutionx[filtro]
		vector.terapia<-vector.terapia[filtro]
	}
}else{
	vector.terapia<-vector.terapiaact
	Evolutionx<-Evolutionxact
	Evolutiony<-Evolutionyact
}



#Empezamos a graficar
#Calculamos el mayor valor de de x para el ploteo
maxy<-max(max(Evolutionx),max(Evolutiony))
miny<-min(min(Evolutionx),min(Evolutiony))

if(as.numeric(args[6])==1){
png(paste(args[1],"R\\Evolucion_Fuerzas_P",idpac,"Terapia",tipoterapia,".png",sep=""),1157, height = 487, units = "px", pointsize = 16)
}
if(as.numeric(args[6])==2){
png(paste(args[1],"R\\Evolucion_Fuerzas_P",idpac,"Terapia",tipoterapia,".png",sep=""),width = 1250, height = 420, units = "px", pointsize = 16)
}
x <- c(1,max(length(vector.terapia))); y <- c(miny,1.2*maxy);
plot(x, y,type="b", pch=21, col="white",xaxt="n", lty=3, xlab="Terapias", ylab="Porcentaje de fuerza (%)")
sub<-paste("Paciente ",idpac,"  Tipo de terapia ",tipoterapia,"  NTerapias: ",vector.terapia[1],"-",vector.terapia[length(vector.terapia)],sep="")
if((length(vector.terapia))>70){
filtroeje<-3
for(i in 1:(max(length(vector.terapia)))) {
if(filtroeje>1){
filtroeje<-filtroeje-1
vector.terapia[i]<-""
}else{
filtroeje<-3
}
}
}
axis(1,at=c(1:max(length(vector.terapia))),labels=(vector.terapia), las=2, cex.axis=0.7, tck=-.02)
lines(c(1:max(length(vector.terapia))),Evolutionx[1:length(vector.terapia)], type="overplotted",pch=1, col="blue")
lines(c(1:max(length(vector.terapia))),Evolutiony[1:length(vector.terapia)],type="overplotted", pch=2, col="red")
main<-"Evolucin de la fuerza"
title(main, sub)
legend("topleft",legend=c("Evolucin de la fuerza del paciente en el eje x","Evolucin de la fuerza del paciente en el eje x"),box.lty=1,pch=c(1,2),col=c("blue","red"))
dev.off()

detach(tablacompleta)
rm(tablacompleta,Ks,conn,m,b,maxnterapias,x,y,maxy,miny,sub,main,q,t,tipoterapia,vector.terapia,nmax,nmin,mFy,mFx,mFayudax,mFayuday,nmmax,vector.terapiaact,Evolutionyact,Evolutionxact,maxleng,k,idpac,i,filtro,Evolutionx,Evolutiony)