#####################################################################################################
###Autor: Miguel Zatarain
###Fecha: 17/04/2015
### FACILIDAD DE MOVIMIENTO
### Script que va a calcular la velocidad para saber con ellas que facilidad de movimiento tenemos
#####################################################################################################
#conectar con el servidor
args <- commandArgs(TRUE)
require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")

#Obtenemos los valores que necesitamos

direccion<-paste(args[1],"R\\Resumen.txt",sep="")
idpac<-as.numeric(args[2])
nmax<-as.numeric(args[5])
nmin<-as.numeric(args[4])
tipoterapia<-as.numeric(args[3])
#Comprobamos si existen datos actualizados

mydata<-c('nterapia','paciente','terapiatipo','ECM','STD','ve','t_reaccion','errorx','errory','v_pac_parado','v_rob_parado','v_pac_rob','sd_x','sd_y','sd_vx','sd_vy','sd_magnitudvel','sd_angulo','Evolucionx','Evoluciony','marca')

if(file.exists(direccion)){
	existe<-read.table(direccion, sep="\t",col.names=mydata)
	attach(existe)
		if(max(nterapia)>nmin){
		nmmax<-max(nterapia)		
		m<-subset(existe, tipoterapia == terapiatipo & nterapia>nmin & nterapia<nmax & paciente==idpac)
		attach(m)
		vact<-ve
		vector.terapiaact<-nterapia
		nmin<-max(nterapia)
		rm(m,existe)
		}
	rm(mydata,existe)
	}else{ vact=0
		nmmax<-nmax
}

if(nmin<= nmmax){

t<-paste("SELECT     IdTerapia, IdPaciente, TipoTerapia
FROM         TerapiaBM
WHERE     (IdPaciente = ",idpac,") AND (IdTerapia <= ",nmax,") AND (IdTerapia > ",nmin,") AND (TipoTerapia = ",tipoterapia,")",sep="")
#conectampos con la tabla por primera vez para obtener una pequea tabla y saber que tipo de terapia queremos seguir
tablapequena<- sqlQuery(conn, t, errors=T)
attach(tablapequena)
vector.terapia<-IdTerapia
rm(tablapequena)
q<-paste("SELECT     m.IdMuestra, m.VelocidadX, m.VelocidadY, t.IdTerapia, p.IdPaciente
FROM         Muestra AS m INNER JOIN
                      TerapiaBM AS t ON m.IdTerapia = t.IdTerapia INNER JOIN
                      PacientesBM AS p ON t.IdPaciente = p.IdPaciente
WHERE     (p.IdPaciente = ",idpac,") AND (t.IdTerapia <= ",nmax,") AND (t.IdTerapia >= ",nmin,")
ORDER BY m.IdMuestra",sep="")
#Conectamos con una tabla mucho ms grande para obtener el resto de valores que necesitamos
tablacompleta<- sqlQuery(conn, q, errors=T)
attach(tablacompleta)
maxnterapias<-length(vector.terapia)
filtro<-(length(vector.terapia):1)*0
v<-(length(vector.terapia):1)*0
for(i in 1:(maxnterapias)) {
	#Reducimos la tabla completa para solo leer los pacientes con las terapias que queremos
	tablareducida<-subset(tablacompleta, IdTerapia == vector.terapia[i])
	attach(tablareducida)
	a<-max(dim(tablareducida))
	#Dado que puede haber valores en los que se ha tomado muy pocos datos y nos van a dar picos en las graficas, solo vamos a recoer aquellos que nos valgan
	if(a >4500){
		#Obtenemos las velocidades y la media de las mismas
		vx<-VelocidadX
		vy<-VelocidadY
		vx<-vx[5:a]
		vy<-vy[5:a]
		vxy<-(1:a)*0
		vxy<-((vx/1000)^2+(vy/1000)^2)^0.5
		v[i]<-mean(vxy)
		filtro[i]=i
	}
	else{
		#Ponemos como cero los valores que no tienen suficientes datos
		filtro[i]=0
	}
	#Liberamos la tabla y borramos todas las variables para evitar problemas
		detach(tablareducida)
}
#Pasamos el filtro para eliminar los datos con pocos valores

if(length(vact>1)){
vector.terapia<-c(vector.terapiaact[1:(length(vector.terapiaact)-1)],vector.terapia[filtro])
v<-c(vact[1:(length(vector.terapiaact)-1)],v[filtro])
}else{
vector.terapia<-vector.terapia[filtro]
v<-v[filtro]

}
}else{
vector.terapia<-vector.terapiaact
v<-vact
}

#Graficamos
if(as.numeric(args[6])==1){
png(paste(args[1],"R\\Facilidad_movimiento_P",idpac,"Terapia", tipoterapia,".png",sep=""),width = 1157, height = 487, units = "px", pointsize = 16)
}
if(as.numeric(args[6])==2){
png(paste(args[1],"R\\Facilidad_movimiento_P",idpac,"Terapia",tipoterapia,".png",sep=""),width = 1250, height = 420, units = "px", pointsize = 16)
}
maxy<-max(v)
miny<-min(v)
x <- c(1,max(length(vector.terapia)))
y <- c(miny,1.2*maxy) 
plot(x, y,type="b", pch=21, col="white",xaxt="n", lty=3, xlab="Terapia", ylab="Velocidad (m/s)")
sub<-paste("Paciente ",idpac,"  Tipo de terapia ",tipoterapia,"  NTerapias: ",vector.terapia[1],"-",vector.terapia[length(vector.terapia)],sep="")
if((length(vector.terapia))>70){
filtroeje<-3
for(i in 1:(max(length(vector.terapia)))) {
if(filtroeje>1){
filtroeje<-filtroeje-1
vector.terapia[i]<-""
}else{
filtroeje<-3
}
}
}
axis(1,at=c(1:max(length(vector.terapia))),labels=(vector.terapia), las=2, cex.axis=0.7, tck=-.02)
lines(c(1,length(vector.terapia)),c(v[1],v[length(vector.terapia)]), type="overplotted",pch=3, col="red")
lines(c(1:max(length(vector.terapia))),v[1:length(vector.terapia)], type="overplotted",pch=1, col="green")
main<-"Facilidad de movimiento"
title(main, sub)
legend("topleft",legend=c("Media de la velocidad del paciente","Recta de regresin"),box.lty=1,pch=c(1,3),col=c("green","red"))
dev.off()

rm(nmmax,conn,x,y,main,sub,maxy,miny,v,vact,vector.terapia,filtro,vector.terapiaact,i,a,vx,vy,vxy,idpac,nmax,nmin,tipoterapia,t,q,tablacompleta,maxnterapias,tablareducida)
