########################################################################################################################################################################################################
###Autor: Miguel Zatarain
###Fecha: 24/04/2015
###MARCADOR
###Script que va a calcular la puntuacion del pacienete en la terapia del raton
############################################################################################################################################################################################
#Obtenemos los valores de la tabla para seleccionar la terapia la identidad del paciente y el tipo de terapia que queremos
args <- commandArgs(TRUE)
require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")
direccion<-paste(args[1],"R\\Resumen.txt",sep="")
idpac<-as.numeric(args[2])
nmax<-as.numeric(args[5])
nmin<-as.numeric(args[4])
tipoterapia<-as.numeric(args[3])
mydata<-c('nterapia','paciente','terapiatipo','ECM','STD','ve','t_reaccion','errorx','errory','v_pac_parado','v_rob_parado','v_pac_rob','sd_x','sd_y','sd_vx','sd_vy','sd_magnitudvel','sd_angulo','Evolucionx','Evoluciony','marca')


if(file.exists(direccion)){
	existe<-read.table(direccion, sep="\t",col.names=mydata)
	attach(existe)

		if(max(nterapia)>nmin){
		nmmax<-max(nterapia)
		m<-subset(existe, tipoterapia == terapiatipo & nterapia>nmin & nterapia<=nmax & paciente==idpac)
		attach(m)
		mediaMaract<-marca
		nmin<-max(nterapia)
		vector.terapiaact<-nterapia
		rm(m,existe)
		}
	}else{ mediaMarxact<-0
		nmmax<-nmax

}

rm(mydata)

if(nmin < nmmax){


t<-paste("SELECT     IdTerapia, IdPaciente, TipoTerapia
FROM         TerapiaBM
WHERE     (IdPaciente = ",idpac,") AND (IdTerapia <= ",nmax,") AND (IdTerapia >= ",nmin,") AND (TipoTerapia = ",tipoterapia,")",sep="")
#conectampos con la tabla por primera vez para obtener una pequea tabla y saber que tipo de terapia queremos seguir
tablapequena<- sqlQuery(conn, t, errors=T)
attach(tablapequena)
vector.terapia<-IdTerapia
rm(tablapequena)
q<-paste("SELECT     m.IdMuestra, t.IdTerapia, m.Tiempo, m.FuerzaX, m.FuerzaY, m.Marcador, p.IdPaciente
FROM         Muestra AS m INNER JOIN
                      TerapiaBM AS t ON m.IdTerapia = t.IdTerapia INNER JOIN
                      PacientesBM AS p ON t.IdPaciente = p.IdPaciente
WHERE     (p.IdPaciente = ",idpac,") AND (t.IdTerapia <= ",nmax,") AND (t.IdTerapia >= ",nmin,") 
ORDER BY m.IdMuestra",sep="")
#Conectamos con una tabla mucho ms grande para obtener el resto de valores que necesitamos
tablacompleta<- sqlQuery(conn, q, errors=T)
attach(tablacompleta)
#inicializamos el tamao de los vectores que vamos a tener en el bucle
maxnterapias<-length(vector.terapia)
mediaMar<-(length(vector.terapia):1)*0
filtro<-(length(vector.terapia):1)*0
#vamos a hacer un bucle para leer todas las terapias que ha realizado del tipo seleccionado
for(i in 1:(maxnterapias)) {
	#Reducimos la tabla completa para solo leer los pacientes con las terapias que queremos
	tablareducida<-subset(tablacompleta, IdTerapia == vector.terapia[i])
	attach(tablareducida)
	a<-max(dim(tablareducida))
	#Dado que puede haber valores en los que se ha tomado muy pocos datos y nos van a dar picos en las graficas, solo vamos a recoer aquellos que nos valgan
	if(a >4500){

		Mar<-Marcador		
		Mar<-Mar[5:a]
		mediaMar[i]=Mar[length(Mar)]

		filtro[i]=i
	}
	else{
		#Ponemos como cero los valores que no tienen suficientes datos
		filtro[i]=0
	}



detach(tablareducida)
}
detach(tablacompleta)



if(length(mediaMaract)>1){
		vector.terapia<-c(vector.terapiaact[1:(length(vector.terapiaact)-1)],vector.terapia[filtro])
		mediaMar<-c(mediaMaract[1:(length(vector.terapiaact)-1)],mediaMar[filtro])
	}else{
		vector.terapia<-vector.terapia[filtro]
		mediaMar<-mediaMar[filtro]
	}
}else{
	vector.terapia<-vector.terapiaact
	mediaMar<-mediaMaract

}



if(as.numeric(args[6])==1){
png(paste(args[1],"R\\Marcador_P",idpac,"Terapia",tipoterapia,".png",sep=""),width = 1157, height = 487, units = "px", pointsize = 16)
}

if(as.numeric(args[6])==2){
png(paste(args[1],"R\\Marcador_P",idpac,"Terapia",tipoterapia,".png",sep=""),width = 1250, height = 420, units = "px", pointsize = 16)
}

x <- c(1,max(length(vector.terapia))) 
y <- c(min(mediaMar),1.2*max(mediaMar))
plot(x, y,type="b", pch=21, col="white",xaxt="n", lty=3, xlab="Terapias", ylab="Puntuacin")
sub<-paste("Paciente ",idpac,"  Tipo de terapia ",tipoterapia,"  NTerapias: ",vector.terapia[1],"-",vector.terapia[length(vector.terapia)],sep="")
if((length(vector.terapia))>70){
filtroeje<-3
for(i in 1:(max(length(vector.terapia)))) {
if(filtroeje>1){
filtroeje<-filtroeje-1
vector.terapia[i]<-""
}else{
filtroeje<-3
}
}
}
axis(1,at=c(1:max(length(vector.terapia))),labels=(vector.terapia), las=2, cex.axis=0.7, tck=-.02)
lines(c(1:max(length(vector.terapia))),mediaMar[1:length(vector.terapia)], type="overplotted",pch=1, col="blue")
main<-"Marcador"
title(main, sub)
legend("topleft",legend=c("Puntos conseguidos"),box.lty=1,pch=c(1),col=c("blue"))
dev.off()

rm(x,y,conn,vector.terapiaact,mediaMaract,nmmax,main,sub,vector.terapia,tipoterapia,tablareducida,tablacompleta,t,q,nmin,Mar,nmax,mediaMar,maxnterapias,main,idpac,i,filtro,a)
