########################################################################################################################################################################################################
###Autor: Miguel Zatarain
###Fecha: 17/04/2015
###NUMERO DE TEMBLORES-
###Script que va a calcular las veces que la distiancia entre un punto y el siguiente fue cero del paciente como del deseado y su comparacin 
############################################################################################################################################################################################
#Obtenemos los valores de la tabla para seleccionar la terapia la identidad del paciente y el tipo de terapia que queremos
args <- commandArgs(TRUE)
require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")


direccion<-paste(args[1],"R\\Resumen.txt",sep="")
idpac<-as.numeric(args[2])
nmax<-as.numeric(args[5])
nmin<-as.numeric(args[4])
tipoterapia<-as.numeric(args[3])

#Comprobamos si existen datos actualizados

mydata<-c('nterapia','paciente','terapiatipo','ECM','STD','ve','t_reaccion','errorx','errory','v_pac_parado','v_rob_parado','v_pac_rob','sd_x','sd_y','sd_vx','sd_vy','sd_magnitudvel','sd_angulo','Evolucionx','Evoluciony','marca')

if(file.exists(direccion)){
	existe<-read.table(direccion, sep="\t",col.names=mydata)
	attach(existe)
		if(max(nterapia)>nmin){
		nmmax<-max(nterapia)
		m<-subset(existe, tipoterapia == terapiatipo & nterapia>nmin & nterapia<=nmax & paciente==idpac)
		attach(m)
		MagPosObjiCeroact<-v_rob_parado
		MagPosCeroCompaact<-v_pac_rob
		MagPosRobotCeroact<-v_pac_parado	
		vector.terapiaact<-nterapia
		nmin<-max(nterapia)
		rm(m,existe)
		}
	}else{ MagPosObjiCeroact<-0
		nmmax<-nmax
}

rm(mydata)

if(nmin <= nmmax){



t<-paste("SELECT     IdTerapia, IdPaciente, TipoTerapia
FROM         TerapiaBM
WHERE     (IdPaciente = ",idpac,") AND (IdTerapia <= ",nmax,") AND (IdTerapia >= ",nmin,") AND (TipoTerapia = ",tipoterapia,")",sep="")
tera<- sqlQuery(conn, t, errors=T)
attach(tera)
vector.terapia<-IdTerapia
rm(tera)
q<-paste("SELECT     m.IdMuestra, m.PosicionX, m.PosicionY, t.IdTerapia, m.PuntoDeseadoX, m.PuntoDeseadoY, p.IdPaciente
FROM         Muestra AS m INNER JOIN
                      TerapiaBM AS t ON m.IdTerapia = t.IdTerapia INNER JOIN
                      PacientesBM AS p ON t.IdPaciente = p.IdPaciente
WHERE     (p.IdPaciente = ",idpac,") AND (t.IdTerapia <= ",nmax,") AND (t.IdTerapia >= ",nmin,")
ORDER BY m.IdMuestra",sep="")
tablagrande<- sqlQuery(conn, q, errors=T)
attach(tablagrande)

maxnterapias<-length(vector.terapia)
#inicializamos vectores
MagPosCeroCompa<-(maxnterapias:1)*0
MagPosRobotCero<-(maxnterapias:1)*0
MagPosObjiCero<-(maxnterapias:1)*0
filtro<-(maxnterapias:1)*0
#Creamos un bucle para ir sacando los valores de cada terapia
for(i in 1:(maxnterapias)) {
	#Seleccionamos la parte de la tabla que nos interesa, vamos cogiendo una por cada numero de terapia
	z<-subset(tablagrande, IdTerapia == vector.terapia[i])
	attach(z)
	#filtramos para que las terapias que hayan recogido pocos valores y nos van a dar sobrepicos no nos afecten
	a<-max(dim(z))
	if(a >4500){
		px<-PosicionX
		px<-px[5:a]
		py<-PosicionY
		py<-py[5:a]
		pdx<-PuntoDeseadoX
		pdx<-pdx[5:a]
		pdy<-PuntoDeseadoY
		pdy<-pdy[5:a]
		#Calibramos la posicion del robot
		pyo<-rep(600,a-4)
		pxo<-rep(1,a-4)
		pyf<-(pyo-pdy)
		pxf<-(pdx+pxo)
		#Ponemos el tamao de los vectores
		PosxRobot<-diff(px)
		PosyRobot<-diff(py)
		MagPosRobot<-(PosxRobot^2+ PosyRobot^2)^0.5
		PosxObji<-diff(pxf)
		PosyObji<-diff(pyf)
		MagPosObji<-(PosxObji^2+PosyObji^2)^0.5 
		#Inicializamos las variables
		MagPosRobotCerox <-0
		MagPosObjiCerox <-0
		#Hacemos un bucle para ver cuantas veces son 0
		for (m in 1:(length (MagPosObji)-3)){
			if(m<(length (MagPosObji))-3){

    			if (TRUE && (MagPosRobot[m+1]== 0) && (MagPosRobot[m]!= 0)){
        			MagPosRobotCerox <- MagPosRobotCerox+1}       
    
    			if (TRUE&&(MagPosObji[m+1]==0) && (MagPosObji[m]!=0)){
        			MagPosObjiCerox <- MagPosObjiCerox+1}
			}
		}

		MagPosRobotCero[i]<-MagPosRobotCerox
		MagPosObjiCero[i]<-MagPosObjiCerox
		MagPosCeroCompa[i]= MagPosRobotCero[i] - MagPosObjiCero[i]
		filtro[i]=i		
		}else{
		#Ponemos como cero los valores que no tienen suficientes datos
		filtro[i]=0
		}
	detach(z)
	rm(pdx,pdy,px,pxf,pxo,py,pyf,pyo,z,m,MagPosRobotCerox,MagPosObjiCerox)
	}

if(length(MagPosObjiCeroact)>1){
		vector.terapia<-c(vector.terapiaact[1:(length(vector.terapiaact)-1)],vector.terapia[filtro])
		MagPosRobotCero<-c(MagPosRobotCeroact[1:(length(vector.terapiaact)-1)],MagPosRobotCero[filtro])
		MagPosObjiCero<-c(MagPosObjiCeroact[1:(length(vector.terapiaact)-1)],MagPosObjiCero[filtro])
		MagPosCeroCompa<-c(MagPosCeroCompaact[1:(length(vector.terapiaact)-1)],MagPosCeroCompa[filtro])
	}else{
		MagPosRobotCero<-MagPosRobotCero[filtro]
		MagPosObjiCero<-MagPosObjiCero[filtro]
		MagPosCeroCompa<-MagPosCeroCompa[filtro]
		vector.terapia<-vector.terapia[filtro]

	}
}else{
	vector.terapia<-vector.terapiaact
	MagPosRobotCero<-MagPosRobotCeroact
	MagPosObjiCero<-MagPosObjiCeroact
	MagPosCeroCompa<-MagPosCeroCompaact
}


#Empezamos a graficar
#Calculamos el mayor valor de de x para el ploteo
maxy<-max(max(MagPosRobotCero),max(MagPosObjiCero),max(MagPosCeroCompa))
miny<-min(min(MagPosRobotCero),min(MagPosObjiCero),min(MagPosCeroCompa))
if(as.numeric(args[6])==1){
png(paste(args[1],"R\\N_Temblores_P",idpac,"Terapia",tipoterapia,".png",sep=""),width = 1157, height = 487, units = "px", pointsize = 16,)
}
if(as.numeric(args[6])==2){
png(paste(args[1],"R\\N_Temblores_P",idpac,"Terapia",tipoterapia,".png",sep=""),width = 1250, height = 420, units = "px", pointsize = 16)
}
x <- c(1,max(length(vector.terapia))); y <- c(miny,1.2*maxy);
plot(x, y,type="b", pch=21, col="white",xaxt="n", lty=3, xlab="Terapia", ylab="Nmero de veces")
sub<-paste("Paciente ",idpac,"  Tipo de terapia ",tipoterapia,"  NTerapias: ",vector.terapia[1],"-",vector.terapia[length(vector.terapia)],sep="")
if((length(vector.terapia))>70){
filtroeje<-3
for(i in 1:(max(length(vector.terapia)))) {
if(filtroeje>1){
filtroeje<-filtroeje-1
vector.terapia[i]<-""
}else{
filtroeje<-3
}
}
}
axis(1,at=c(1:max(length(vector.terapia))),labels=(vector.terapia), las=2, cex.axis=0.7, tck=-.02)
lines(c(1:max(length(vector.terapia))),MagPosRobotCero[1:length(vector.terapia)], type="overplotted",pch=1, col="blue")
lines(c(1:max(length(vector.terapia))),MagPosObjiCero[1:length(vector.terapia)],type="overplotted", pch=2, col="red")
lines(c(1:max(length(vector.terapia))),MagPosCeroCompa[1:length(vector.terapia)],type="overplotted", pch=3, col="green")
main<-"Nmero de temblores"
title(main, sub)
legend("topleft",legend=c("Veces que el paciente est parado","Veces que el objetivo est parado","Veces que el paciente est parado respecto al objetivo"),box.lty=1,pch=c(1,2,3),col=c("blue","red","green"))
dev.off()
rm(sub,main,a,t,x,y,maxy,miny,vector.terapia,tipoterapia,tablagrande,q,PosyRobot,PosyObji,PosxRobot,PosxObji,nmax,nmin,maxnterapias,MagPosCeroCompa,MagPosObji,MagPosObjiCero,MagPosRobot,MagPosRobotCero,idpac,i,filtro)
