########################################################################################################################################################################################################
###Autor: Miguel Zatarain
###Fecha: 17/04/2015
###Simetra direccional de la velocidad, de la magnitud y del ngulo.
###Script que va a calcular la simetra direccional de la velocidad, de la magnitud y del ngulo.
############################################################################################################################################################################################
#Obtenemos los valores de la tabla para seleccionar la terapia la identidad del paciente y el tipo de terapia que queremos
args <- commandArgs(TRUE)
require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")

direccion<-paste(args[1],"R\\Resumen.txt",sep="")
idpac<-as.numeric(args[2])
nmax<-as.numeric(args[5])
nmin<-as.numeric(args[4])
tipoterapia<-as.numeric(args[3])


mydata<-c('nterapia','paciente','terapiatipo','ECM','STD','ve','t_reaccion','errorx','errory','v_pac_parado','v_rob_parado','v_pac_rob','sd_x','sd_y','sd_vx','sd_vy','sd_magnitudvel','sd_angulo','Evolucionx','Evoluciony','marca')

if(file.exists(direccion)){
	existe<-read.table(direccion, sep="\t",col.names=mydata)
	attach(existe)
		if(max(nterapia)>nmin){
		nmmax<-max(nterapia)
		m<-subset(existe, tipoterapia == terapiatipo & nterapia>nmin & nterapia<=nmax & paciente==idpac)
		attach(m)
		dsxact<-sd_vx
		dsyact<-sd_vy
		dsaact<-sd_angulo
		dsmact<-sd_magnitudvel
		vector.terapiaact<-nterapia
		nmin<-max(nterapia)
		rm(m,existe)
		}
	}else{ dsxact<-0
		nmmax<-nmax
}

rm(mydata)

if(nmin <= nmmax){



t<-paste("SELECT     IdTerapia, IdPaciente, TipoTerapia
FROM         TerapiaBM
WHERE     (IdPaciente = ",idpac,") AND (IdTerapia <= ",nmax,") AND (IdTerapia >= ",nmin,") AND (TipoTerapia = ",tipoterapia,")",sep="")
#conectampos con la tabla por primera vez para obtener una pequea tabla y saber que tipo de terapia queremos seguir
tablapequena<- sqlQuery(conn, t, errors=T)
attach(tablapequena)
vector.terapia<-IdTerapia
rm(tablapequena)
q<-paste("SELECT     m.IdMuestra, m.PosicionX, m.PosicionY, t.IdTerapia, m.PuntoDeseadoX, m.Tiempo, m.PuntoDeseadoY, p.IdPaciente
FROM         Muestra AS m INNER JOIN
                      TerapiaBM AS t ON m.IdTerapia = t.IdTerapia INNER JOIN
                      PacientesBM AS p ON t.IdPaciente = p.IdPaciente
WHERE     (p.IdPaciente = ",idpac,") AND (t.IdTerapia <= ",nmax,") AND (t.IdTerapia >= ",nmin,")
ORDER BY m.IdMuestra",sep="")
#Conectamos con una tabla mucho ms grande para obtener el resto de valores que necesitamos
tablacompleta<- sqlQuery(conn, q, errors=T)
attach(tablacompleta)
#inicializamos el tamao de los vectores que vamos a tener en el bucle
maxnterapias<-length(vector.terapia)
dsx<-(length(vector.terapia):1)*0
dsy<-(length(vector.terapia):1)*0
dsa<-(length(vector.terapia):1)*0
dsm<-(length(vector.terapia):1)*0
filtro<-(length(vector.terapia):1)*0
#vamos a hacer un bucle para leer todas las terapias que ha realizado del tipo seleccionado
for(i in 1:(maxnterapias)) {
	#Reducimos la tabla completa para solo leer los pacientes con las terapias que queremos
	tablareducida<-subset(tablacompleta, IdTerapia == vector.terapia[i])
	attach(tablareducida)
	a<-max(dim(tablareducida))
	#Dado que puede haber valores en los que se ha tomado muy pocos datos y nos van a dar picos en las graficas, solo vamos a recoer aquellos que nos valgan
	if(a >4500){
		#debido a que el tiempo es un caracter vamos a transformarlo a numrico en segundos mediante un bucle
		ti<-as.character(Tiempo)
		s1 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[1])))
		s2 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[2])))
		s3 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[3])))
		Vtiempois<-s1*3600+s2*60+s3
		#Ya tenemos el tiempo en segundos
		#Vamos a quitar los primeros 3 valores de cada columna porque tienen un error que puede llevar a errores
		#Asignamos los valores de cada columna a una variable
		Vtiempoi<-Vtiempois[4:a]
		px<-PosicionX
		px<-px[5:a]
		py<-PosicionY
		py<-py[5:a]
		pdx<-PuntoDeseadoX
		pdx<-pdx[5:a]
		pdy<-PuntoDeseadoY
		pdy<-pdy[5:a]
		#Calibramos la posicion del robot
		pyo<-rep(600,a-4)
		pxo<-rep(1,a-4)
		pyf<-(pyo-pdy)
		pxf<-(pdx+pxo)
		maxleng<-(length(px))

		#Inicializamos los vectores

		VelxRobot<-(maxleng:1)*0
		VelyRobot<-(maxleng:1)*0
		MagVelRobot<-(maxleng:1)*0
		VelxObji<-(maxleng:1)*0
		VelyObji<-(maxleng:1)*0
		MagVelObji<-(maxleng:1)*0
		AnguloVelRobot<-(maxleng:1)*0
		AnguloVelObji<-(maxleng:1)*0

		tiempor<-diff(Vtiempoi)
		filtrob<-which(tiempor>=0)
		px<-px[filtrob]
		py<-py[filtrob]
		tiempor<-tiempor[filtrob]
		pxff<-pxf[filtrob]
		pyff<-pyf[filtrob]
		VelxRobot <- diff(px)/(tiempor*1000)
		VelyRobot <- diff(py)/(tiempor*1000)
		MagVelRobot<-(VelxRobot^2+ VelyRobot^2)^0.5
		VelxObji <- diff(pxff)/(tiempor*1000)
		VelyObji <- diff(pyff)/(tiempor*1000)
		MagVelObji<-(VelxObji^2+ VelyObji^2)^0.5  
		AnguloVelRobot=asin(VelyRobot/MagVelRobot) 
		AnguloVelObji=asin(VelyObji/MagVelObji)		

		#Calculamos ahora las desviaciones del robot
		#Contador
		m<-(length(VelxRobot))
		#Calculamos desviacion en velocidad en x
		dummyx <-diff(VelxObji)*diff(VelxRobot)
		dx <- (1:m)*0
		jx= which(dummyx>=0)
		dx[jx]= 1
		dx[is.na(dx)] <- 0
		dsx[i]<-sum(dx)*100/m
		#Calculamos desviacion en velocidad en y
		dummyy <-diff(VelyObji)*diff(VelyRobot)
		dy<- (1:m)*0
		jy = which(dummyy>=0)
		dy[jy]  = 1
		dy[is.na(dy)] <- 0
		dsy[i]<-sum(dy)*100/m
		#Calculamos desviacion en la magnitud de la velocidad
		dummym <-diff(MagVelObji)*diff(MagVelRobot)
		dm     <- (1:m)*0
		jm     = which(dummym>=0)
		dm[jm]  = 1
		dm[is.na(dm)] <- 0
		dsm[i]<-sum(dm)*100/m
		#Calculamos desviacion en la diferencia del angulo
		dummya <-diff(AnguloVelObji)*diff(AnguloVelRobot)
		da     <- (1:m)*0
		ja     = which(dummya>=0)
		da[ja]  = 1
		da[is.na(da)] <- 0
		dsa[i]<-(sum(da)*100/m)
		#Guardamos con i los valores con los que estamos trabajando, es decir para los que tienen suficientes datos
		filtro[i]=i
	}
	else{
		#Ponemos como cero los valores que no tienen suficientes datos
		filtro[i]=0
	}
	#Liberamos la tabla y borramos todas las variables para evitar problemas
	detach(tablareducida)
	rm(a,filtrob,maxleng,pdx,pdy,px,py,pyo,pxo,pyf,pxf,jx,dx,dummyx,dummyy,jy,dy,jm,dm,dummym,dummya,ja,da,m,tablareducida,AnguloVelObji,AnguloVelRobot,MagVelObji,VelyObji,VelxObji,VelxRobot,VelyRobot,tiempo,ti,s1,s2,s3,Vtiempoi,Vtiempois,MagVelRobot,n,tablareducida)
}


if(length(dsxact)>1){
		vector.terapia<-c(vector.terapiaact[1:(length(vector.terapiaact)-1)],vector.terapia[filtro])
		dsx<-c(dsxact[1:(length(vector.terapiaact)-1)],dsx[filtro])
		dsy<-c(dsyact[1:(length(vector.terapiaact)-1)],dsy[filtro])
		dsa<-c(dsaact[1:(length(vector.terapiaact)-1)],dsa[filtro])
		dsm<-c(dsmact[1:(length(vector.terapiaact)-1)],dsm[filtro])

	}else{
		dsx<-dsx[filtro]
		dsy<-dsy[filtro]
		dsm<-dsm[filtro]
		dsa<-dsa[filtro]
		vector.terapia<-vector.terapia[filtro]
	}
}else{
	vector.terapia<-vector.terapiaact
	dsx<-dsxact
	dsy<-dsyact
	dsa<-dsaact
	dsm<-dsmact

}





#Aplicamos el filtro a las variables
#Calculamos los puntos mximos y mnimos para las grficas
maxy<-max(max(dsx),max(dsy),max(dsm),max(dsa))
miny<-min(min(dsx),min(dsy),min(dsm),min(dsa))
x <- c(1,max(length(vector.terapia)))
y <- c(miny,1.4*maxy) 
#Graficamos
if(as.numeric(args[6])==1){
png(paste(args[1],"R\\Sim_dir_vel_mag_ang_P",idpac,"Terapia",tipoterapia,".png",sep=""),width = 1157, height = 487, units = "px", pointsize = 16,)
}
if(as.numeric(args[6])==2){
png(paste(args[1],"R\\Sim_dir_vel_mag_ang_P",idpac,"Terapia",tipoterapia,".png",sep=""),width = 1250, height = 420, units = "px", pointsize = 16)
}
plot(x, y,type="b", pch=21, col="white",xaxt="n", lty=3, xlab="Terapia", ylab="Porcentaje de simetra (%)")
sub<-paste("Paciente ",idpac,"  Tipo de terapia ",tipoterapia,"  NTerapias: ",vector.terapia[1],"-",vector.terapia[length(vector.terapia)],sep="")
if((length(vector.terapia))>70){
filtroeje<-3
for(i in 1:(max(length(vector.terapia)))) {
if(filtroeje>1){
filtroeje<-filtroeje-1
vector.terapia[i]<-""
}else{
filtroeje<-3
}
}
}
axis(1,at=c(1:max(length(vector.terapia))),labels=(vector.terapia), las=2, cex.axis=0.7, tck=-.02)
lines(c(1:max(length(vector.terapia))),dsx[1:length(vector.terapia)], type="overplotted",pch=1, col="blue")
lines(c(1:max(length(vector.terapia))),dsy[1:length(vector.terapia)],type="overplotted", pch=2, col="red")
lines(c(1:max(length(vector.terapia))),dsm[1:length(vector.terapia)], type="overplotted",pch=3, col="green")
lines(c(1:max(length(vector.terapia))),dsa[1:length(vector.terapia)],type="overplotted", pch=4, col="black")
legend("topleft",legend=c("Simetra direccional velocidad x Robot-Objetivo","Simetra direccional velocidad y Robot-Objetivo","Simetra direccional magnitud velocidad Robot-Objetivo","Simetra direccional ngulo velocidad Robot-Objetivo"),box.lty=1,pch=c(1,2,3,4),col=c("blue","red","green","black"))
main<-"Simetra direccional"
title(main, sub)
#Borramos todas las variables para evitar problemas
dev.off()
detach(tablacompleta)
rm(nmax,nmin,idpac,tipoterapia,q,tablacompleta,maxnterapias,maxy,miny,i,x,y,t)
rm(vector.terapia,dsaact,dsmact,dsxact,dsyact,vector.terapiaact,conn,dsx,dsy,dsa,dsm,filtro,main,sub,pxff,pyff,tiempor)