#####################################################################################################
###Autor: Miguel Zatarain
###Fecha: 17/04/2015
###SIMETRA DIRECCIONAL EN X Y EN Y
###Script que va a calcular la simetra direccional para calcular el porcentaje de simetra entre los puntos que recorre el paciente y los del robot
#####################################################################################################
#Obtenemos los valores de la tabla para seleccionar la terapia la identidad del paciente y el tipo de terapia que queremos
args <- commandArgs(TRUE)
require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")

direccion<-paste(args[1],"R\\Resumen.txt",sep="")
idpac<-as.numeric(args[2])
nmax<-as.numeric(args[5])
nmin<-as.numeric(args[4])
tipoterapia<-as.numeric(args[3])


mydata<-c('nterapia','paciente','terapiatipo','ECM','STD','ve','t_reaccion','errorx','errory','v_pac_parado','v_rob_parado','v_pac_rob','sd_x','sd_y','sd_vx','sd_vy','sd_magnitudvel','sd_angulo','Evolucionx','Evoluciony','marca')

if(file.exists(direccion)){
	existe<-read.table(direccion, sep="\t",col.names=mydata)
	attach(existe)
		if(max(nterapia)>nmin){
		nmmax<-max(nterapia)
		m<-subset(existe, tipoterapia == terapiatipo & nterapia>nmin & nterapia<=nmax & paciente==idpac)
		attach(m)
		dsxact<-sd_x
		dsyact<-sd_y
		vector.terapiaact<-nterapia
		nmin<-max(nterapia)
		rm(m,existe)
		}
	}else{ dsxact<-0
		nmmax<-nmax
}

rm(mydata)

if(nmin <= nmmax){



t<-paste("SELECT     IdTerapia, IdPaciente, TipoTerapia
FROM         TerapiaBM
WHERE     (IdPaciente = ",idpac,") AND (IdTerapia <= ",nmax,") AND (IdTerapia >= ",nmin,") AND (TipoTerapia = ",tipoterapia,")",sep="")
terapia<- sqlQuery(conn, t, errors=T)
attach(terapia)
vector.terapia<-IdTerapia
rm(terapia)
#Obtenemos los valores de la posiciones en funcin a la identidad del paciente, y la identidad de terapia
q<-paste("SELECT     m.IdMuestra, m.PosicionX, m.PosicionY, t.IdTerapia, m.PuntoDeseadoX, m.PuntoDeseadoY, p.IdPaciente
FROM         Muestra AS m INNER JOIN
                      TerapiaBM AS t ON m.IdTerapia = t.IdTerapia INNER JOIN
                      PacientesBM AS p ON t.IdPaciente = p.IdPaciente
WHERE     (p.IdPaciente = ",idpac,") AND (t.IdTerapia <= ",nmax,") AND (t.IdTerapia >= ",nmin,")
ORDER BY m.IdMuestra",sep="")
sd<- sqlQuery(conn, q, errors=T)
attach(sd)
maxnterapias<-length(vector.terapia)
#Creamos un bucle para calcular la simetria direccional
dsx<-(maxnterapias:1)*0
dsy<-(maxnterapias:1)*0

filtro<-(length(vector.terapia):1)*0
for(i in 1:(maxnterapias)) {
	z<-subset(sd, IdTerapia == vector.terapia[i])
	attach(z)
	a<-max(dim(z))
	if(a >4500){
		px<-PosicionX
		b<-length(px)
		px<-px[5:b]
		py<-PosicionY
		py<-py[5:b]
		pdx<-PuntoDeseadoX
		pdx<-pdx[5:b]
		pdy<-PuntoDeseadoY
		pdy<-pdy[5:b]

		#Calibramos la posicion del robot
		pyo<-rep(600,a-4)
		pxo<-rep(1,a-4)
		pyf<-(pyo-pdy)
		pxf<-(pdx+pxo)


		m<-(length(px))
		dummyx <-diff(px)*diff(pxf)
		dx     <- (1:m)*0
		jx     = which(dummyx >= 0)
		dx[jx]  = 1
		dx[is.na(dx)] <- 0
		dsx[i]<-sum(dx)*100/m

		
		dummyy <-diff(pyf)*diff(py)
		dy     <- (1:m)*0
		jy     = which(dummyy>=0)
		dy[jy]  = 1
		dy[is.na(dy)] <- 0
		dsy[i]<-sum(dy)*100/m

		filtro[i]=i
		}
	else{
		#Ponemos como cero los valores que no tienen suficientes datos
		filtro[i]=0
		}
	detach(z)
	rm(pdx,pdy,px,pxo,pyo,py,pyf,pxf,z,jx,dx,dummyx,dummyy,jy,dy,m,a,b)
	}


if(length(dsxact)>1){
		vector.terapia<-c(vector.terapiaact[1:(length(vector.terapiaact)-1)],vector.terapia[filtro])
		dsx<-c(dsxact[1:(length(vector.terapiaact)-1)],dsx[filtro])
		dsy<-c(dsyact[1:(length(vector.terapiaact)-1)],dsy[filtro])
	}else{
		dsy<-dsy[filtro]
		dsx<-dsx[filtro]
		vector.terapia<-vector.terapia[filtro]
	}
}else{
	vector.terapia<-vector.terapiaact
	dsx<-dsxact
	dsy<-dsyact
}


#Graficamos

maxy<-max(max(dsy),max(dsx))
miny<-min(min(dsy),min(dsx))

if(as.numeric(args[6])==1){
png(paste(args[1],"R\\Sim_dir_xy_P",idpac,"Terapia",tipoterapia,".png",sep=""),width = 1157, height = 487, units = "px", pointsize = 16,)
}
if(as.numeric(args[6])==2){
png(paste(args[1],"R\\Sim_dir_xy_P",idpac,"Terapia",tipoterapia,".png",sep=""),width = 1250, height = 420, units = "px", pointsize = 16)
}
x <- c(1,max(length(vector.terapia))); y <- c(miny,1.3*maxy); 
# plot x vs. y
plot(x, y,type="b", pch=21, col="white",xaxt="n", lty=3, xlab="Terapia", ylab="Porcentaje de simetra (%)")
sub<-paste("Paciente ",idpac,"  Tipo de terapia ",tipoterapia,"  NTerapias: ",vector.terapia[1],"-",vector.terapia[length(vector.terapia)],sep="")
if((length(vector.terapia))>70){
filtroeje<-3
for(i in 1:(max(length(vector.terapia)))) {
if(filtroeje>1){
filtroeje<-filtroeje-1
vector.terapia[i]<-""
}else{
filtroeje<-3
}
}
}
axis(1,at=c(1:max(length(vector.terapia))),labels=(vector.terapia), las=2, cex.axis=0.7, tck=-.02)
lines(c(1:max(length(vector.terapia))),dsx[1:length(vector.terapia)], type="overplotted",pch=1, col="blue")
lines(c(1:max(length(vector.terapia))),dsy[1:length(vector.terapia)],type="overplotted", pch=2, col="red")
legend("topleft",legend=c("Simetra direccional x","Simetra direccional y"),box.lty=1,pch=c(1,2),col=c("blue","red"))
main<-"Simetra direccional en x y en y"
title(main, sub)
dev.off()
rm(sd,conn,maxnterapias,nmmax,dsxact,dsyact,vector.terapiaact,q,t,vector.terapia,x,y,j,i,miny,maxy,filtro,dsx,dsy,sub,main,vector.terapia,idpac,nmax,nmin,tipoterapia)