################################################################################################################################################################################################
###Autor: Miguel Zatarain
###Fecha: 17/04/2015
###	TIEMPO DE REACCIN
###Script que se encarga de calcular el tiempo de repuesta que tarda en realizar el robot en adquirir el sentido de la posicin deseada
##########################################################################################################################################################################
#conectar con el servidor
args <- commandArgs(TRUE)

require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")


#Obtenemos los valores de la tabla
direccion<-paste(args[1],"R\\Resumen.txt",sep="")
idpac<-as.numeric(args[2])
nmax<-as.numeric(args[5])
nmin<-as.numeric(args[4])
tipoterapia<-as.numeric(args[3])

#Comprobamos si existen datos actualizados

mydata<-c('nterapia','paciente','terapiatipo','ECM','STD','ve','t_reaccion','error_x','error_y','v_pac_parado','v_rob_parado','v_pac_rob','sd_x','sd_y','sd_vx','sd_vy','sd_magnitudvel','sd_angulo','Evolucionx','Evoluciony','marca')

if(file.exists(direccion)){
	existe<-read.table(direccion, sep="\t",col.names=mydata)
	attach(existe)
		if(max(nterapia)>nmin){
		nmmax<-max(nterapia)
		m<-subset(existe, tipoterapia == terapiatipo & nterapia>nmin & nterapia<=nmax & paciente==idpac)
		attach(m)
		mediatiempoact<-t_reaccion
		vector.terapiaact<-nterapia
		nmin<-max(nterapia)
		rm(m,existe)
		}
	}else{ mediatiempoact<-0
		nmmax<-nmax
}

rm(mydata)

if(nmin <= nmmax){

	t<-paste("SELECT     IdTerapia, IdPaciente, TipoTerapia
	FROM         TerapiaBM
	WHERE     (IdPaciente = ",idpac,") AND (IdTerapia <= ",nmax,") AND (IdTerapia >= ",nmin,") AND (TipoTerapia = ",tipoterapia,")",sep="")
	#conectampos con la tabla por primera vez para obtener una pequea tabla y saber que tipo de terapia queremos seguir
	tablapequena<- sqlQuery(conn, t, errors=T)
	attach(tablapequena)
	vector.terapia<-IdTerapia
	rm(tablapequena)
	q<-paste("SELECT     m.IdMuestra, m.PosicionX, m.PosicionY, t.IdTerapia, m.PuntoDeseadoX, m.Tiempo, m.PuntoDeseadoY, p.IdPaciente
	FROM         Muestra AS m INNER JOIN
    	                  TerapiaBM AS t ON m.IdTerapia = t.IdTerapia INNER JOIN
    	                  PacientesBM AS p ON t.IdPaciente = p.IdPaciente
	WHERE     (p.IdPaciente = ",idpac,") AND (t.IdTerapia <= ",nmax,") AND (t.IdTerapia >= ",nmin,")
	ORDER BY m.IdMuestra",sep="")
	#Conectamos con una tabla mucho ms grande para obtener el resto de valores que necesitamos
	tablacompleta<- sqlQuery(conn, q, errors=T)
	attach(tablacompleta)
	#inicializamos el tamao de los vectores que vamos a tener en el bucle
	maxnterapias<-length(vector.terapia)
	filtro<-(length(vector.terapia):1)*0
	#vamos a hacer un bucle para leer todas las terapias que ha realizado del tipo seleccionado
	mediatiempo<-(length(vector.terapia):1)*0
	for(z in 1:(maxnterapias)) {
		#Reducimos la tabla completa para solo leer los pacientes con las terapias que queremos
		tablareducida<-subset(tablacompleta, IdTerapia == vector.terapia[z])
		attach(tablareducida)
		a<-max(dim(tablareducida))
		#Dado que puede haber valores en los que se ha tomado muy pocos datos y nos van a dar picos en las graficas, solo vamos a recoer aquellos que nos valgan
		if(a >4500){

			#Calculamos la maxima dimension y asignamos las posiciones
			#debido a que el tiempo es un caracter vamos a transformarlo a numrico en segundos mediante un bucle
			ti<-as.character(Tiempo)
			s1 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[1])))
			s2 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[2])))
			s3 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[3])))
			Vtiempois<-s1*3600+s2*60+s3

			px<-PosicionX
			px<-px[5:a]
			py<-PosicionY
			py<-py[5:a]
			pdx<-PuntoDeseadoX
			pdx<-pdx[5:a]
			pdy<-PuntoDeseadoY
			pdy<-pdy[5:a]
			Vector.tiempo<-Vtiempois
			Vector.tiempo<-Vector.tiempo[6:a-1]
			#Calibramos la posicion del robot
			pyo<-rep(600,a-4)
			pxo<-rep(1,a-4)
			pyf<-(pyo-pdy)
			pxf<-(pdx+pxo)

			#Diferencia entre los puntos para sabes si el sentido es positivo o negativo
			dpyf<-diff(pyf)
			dpxf<-diff(pxf)
			dpx<-diff(px)
			dpy<-diff(py)

			dpyt<-dpyf*dpy
			dpxt<-dpxf*dpx

			#Vamos a calcular que todos los tiempos comprendidos entre el cambio de sentido total y el real sean los mismos
			#Nuestro objetivo  es que durante el cambio de sentido es decir desde que pdx cambie de sentido hasta que px cambie de sentido haya unos y en el resto de la matriz 0s e igual para py
			m<-(length(dpyt))
			dx <- (1:m)*0
			dy <- (1:m)*0
			jx= which(dpxt<0)
			jy= which(dpyt<0)
			dx[jx]= 1
			dx[is.na(dx)] <- 0
			dy[jy]= 1
			dy[is.na(dx)] <- 0
			dtotal<-dx+dy
			dtotala<-dtotal*0
			dtotalb<-dtotal*0
			jtotal= which(dtotal>0)
			dtotal[jtotal]= 1
			dtotal[1]=0
			dtotal[is.na(dx)] <- 0

			#Hacemos este filtro para eliminar los valores que son parasitos como un uno en mitad de muchos ceros o un cero en mitad de muchos unos
			for(i in 1:(length(dtotal))) {
				if(i>2){
					if((dtotal[i-1]<dtotal[i-2])&(dtotal[i-1]<dtotal[i])){
						dtotal[i-1]=1}
				}

				if(i>2){
					if((dtotal[i-1]>dtotal[i-2])&(dtotal[i-1]>dtotal[i])){
						dtotal[i-1]=0}
				}

				if(i>3){
					if((dtotal[i-2]==1)&(dtotal[i-3]==0)){
						dtotala[i-2]=1}
				}
				if(i>3){
					if((dtotal[i-3]==1)&(dtotal[i-2]==0)){
						dtotalb[i-2]=1}
				}
			}
			#Aplicamops los filtros
			filtroa<-which(dtotala>0)
			filtrob<-which(dtotalb>0)
			tiempoa<-Vector.tiempo[filtroa]
			tiempob<-Vector.tiempo[filtrob]
			tiempo<-tiempob-tiempoa
			mediatiempo[z]<-mean(tiempo[1:((length(tiempo))-1)])
			filtro[z]=z
		}else{
			#Ponemos como cero los valores que no tienen suficientes datos
			filtro[z]=0
		}
		detach(tablareducida)
	}
	if(length(mediatiempoact)>1){
		vector.terapia<-c(vector.terapiaact[1:(length(vector.terapiaact)-1)],vector.terapia[filtro])
		mediatiempo<-c(mediatiempoact[1:(length(vector.terapiaact)-1)],mediatiempo[filtro])
	}else{
	vector.terapia<-vector.terapia[filtro]
	mediatiempo<-mediatiempo[filtro]
	}
}else{
	vector.terapia<-vector.terapiaact
	mediatiempo<-mediatiempoact
}

#Calculamos los puntos mximos y mnimos para las grficas
maxy<-max(mediatiempo)
x <- c(1,max(length(vector.terapia)))
y <- c(0,1.3*maxy) 
#Graficamos
if(as.numeric(args[6])==1){
png(paste(args[1],"R\\Tiempo_Reaccion_P",idpac,"Terapia",tipoterapia,".png",sep=""),width = 1157, height = 487, units = "px", pointsize = 16,)
}
if(as.numeric(args[6])==2){
png(paste(args[1],"R\\Tiempo_Reaccion_P",idpac,"Terapia",tipoterapia,".png",sep=""),width = 1250, height = 420, units = "px", pointsize = 16)
}
plot(x, y,type="b", pch=21, col="white",xaxt="n", lty=3, xlab="Terapia", ylab="Tiempo de reaccin(s)")
sub<-paste("Paciente ",idpac,"  Tipo de terapia ",tipoterapia,"  NTerapias: ",vector.terapia[1],"-",vector.terapia[length(vector.terapia)],sep="")
if((length(vector.terapia))>70){
filtroeje<-3
for(i in 1:(max(length(vector.terapia)))) {
if(filtroeje>1){
filtroeje<-filtroeje-1
vector.terapia[i]<-""
}else{
filtroeje<-3
}
}
}
axis(1,at=c(1:max(length(vector.terapia))),labels=(vector.terapia), las=2, cex.axis=0.7, tck=-.02)
lines(c(1:max(length(vector.terapia))),mediatiempo[1:length(vector.terapia)], type="overplotted",pch=1, col="blue")
main<-"Tiempo de Reaccin"
title(main, sub)
dev.off()
rm(main,Vector.tiempo,conn,nmmax,t,q,sub,x,y,maxnterapias,maxy,mediatiempo,mediatiempoact,vector.terapia,vector.terapiaact,tiempo,tiempob,tiempoa,filtro,filtroa,filtrob,i,z,dtotal,dtotala,dtotalb,jtotal,jx,jy,dx,dy,m,a,px,py,pxf,pyf,pxo,pyo,pdx,pdy,dpyf,dpxf,dpy,dpx,dpyt,dpxt,Vtiempois,s1,s2,s3,ti,tipoterapia,nmax,nmin,idpac,tablareducida,tablacompleta)