################################################################################################################################################################################################
###Autor: Miguel Zatarain
###Fecha: 11/03/2015
###MEDIA Y DESVIACIN
###Script que se encarga de calcular la media y la desviacin
##########################################################################################################################################################################
#conectar con el servidor
args <- commandArgs(TRUE)
require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")

#Obtenemos los valores de la tabla

direccion<-paste(args[1],"R\\Resumen.txt",sep="")
idpac<-as.numeric(args[2])
nmax<-as.numeric(args[5])
nmin<-as.numeric(args[4])
tipoterapia<-as.numeric(args[3])

#Comprobamos si existen datos actualizados

mydata<-c('nterapia','paciente','terapiatipo','ECM','STD','ve','t_reaccion','errorx','errory','v_pac_parado','v_rob_parado','v_pac_rob','sd_x','sd_y','sd_vx','sd_vy','sd_magnitudvel','sd_angulo','Evolucionx','Evoluciony','marca')

if(file.exists(direccion)){
	existe<-read.table(direccion, sep="\t",col.names=mydata)
	attach(existe)
		if(max(nterapia)>nmin){
		nmmax<-max(nterapia)
		m<-subset(existe, tipoterapia == terapiatipo & nterapia>nmin & nterapia<nmax & paciente==idpac)
		attach(m)
		ECMact<-ECM
		STDact<-STD
		vector.terapiaact<-nterapia
		nmin<-max(nterapia)
		rm(m,existe)
		}
	}else{ ECMact=0
	nmmax<-nmax
	}

rm(mydata)


if(nmin <= nmmax){

t<-paste("SELECT     IdTerapia, IdPaciente, TipoTerapia
FROM         TerapiaBM
WHERE     (IdPaciente = ",idpac,") AND (IdTerapia <= ",nmax,") AND (IdTerapia >= ",nmin,") AND (TipoTerapia = ",tipoterapia,")",sep="")
terapia<- sqlQuery(conn, t, errors=T)
attach(terapia)
vector.terapia<-IdTerapia
rm(terapia)
q<-paste("SELECT     m.IdMuestra, m.PosicionX, m.PosicionY, t.IdTerapia, m.PuntoDeseadoX, m.PuntoDeseadoY, p.IdPaciente
FROM         Muestra AS m INNER JOIN
                      TerapiaBM AS t ON m.IdTerapia = t.IdTerapia INNER JOIN
                      PacientesBM AS p ON t.IdPaciente = p.IdPaciente
WHERE     (p.IdPaciente = ",idpac,") AND (t.IdTerapia <= ",nmax,") AND (t.IdTerapia >= ",nmin,")",sep="")
ecmsd<- sqlQuery(conn, q, errors=T)
attach(ecmsd)
#Inicializamos los vectores
maxnterapias<-length(vector.terapia)
ECM<-(maxnterapias:1)*0
STD<-(maxnterapias:1)*0
filtro<-(maxnterapias:1)*0
#Vamos a crear un bucle para hacer la media de cada terapia
for(i in 1:(maxnterapias)) {
	#Seleccionamos la parte de la tabla que nos interesa, vamos cogiendo una por cada numero de terapia
	z<-subset(ecmsd, IdTerapia == vector.terapia[i])
	attach(z)
	a<-max(dim(z))
	#filtramos para que las terapias que hayan recogido pocos valores y nos van a dar sobrepicos no nos afecten
	if(a >4500){
		#Asignamos posiciones y recirtamos los primeros valores que son erroneos
		px<-PosicionX
		px<-px[5:a]
		py<-PosicionY
		py<-py[5:a]
		pdx<-PuntoDeseadoX
		pdx<-pdx[5:a]
		pdy<-PuntoDeseadoY
		pdy<-pdy[5:a]
		#Calibramos la posicion del robot
		pyo<-rep(600,a-4)
		pxo<-rep(1,a-4)
		pyf<-(pyo-pdy)
		pxf<-(pdx+pxo)
		#Calculamos media y desviacion
		ECM[i] <- mean(((px - pxf)^2 + (py- pyf)^2)^0.5)
		STD[i] <- sd(((px - pxf)^2 + (py- pyf)^2)^0.5)
		#Creamos un filtro para que nos guarde las posiciones de las terapias con suficientes datos
		filtro[i]=i		
		}else{
		#Ponemos como cero los valores que no tienen suficientes datos
		filtro[i]=0
		}
	#borramos los valores para evitar problemas
	detach(z)
	rm(pdx,pdy,px,pxf,pxo,py,pyf,pyo,z,a)
	}
#filtramos nuestras 3 variables

if(length(ECMact>1)){
vector.terapia<-c(vector.terapiaact[1:(length(vector.terapiaact)-1)],vector.terapia[filtro])
ECM<-c(ECMact[1:(length(vector.terapiaact)-1)],ECM[filtro])
STD<-c(STDact[1:(length(vector.terapiaact)-1)],STD[filtro])
}else{
vector.terapia<-vector.terapia[filtro]
ECM<-ECM[filtro]
STD<-STD[filtro]
}
}else{
vector.terapia<-vector.terapiaact
ECM<-ECMact
STD<-STDact
}
#Calculamos el valor maximo y mnimo para hallar los lmites de las grficas
maxy<-max(max(STD),max(ECM))
miny<-min(min(STD),min(ECM))
#Graficamos
if(as.numeric(args[6])==1){
png(paste(args[1],"R\\Media_desviacion_P",idpac,"Terapia",tipoterapia,".png",sep=""),width = 1157, height = 487, units = "px", pointsize = 16)
}
if(as.numeric(args[6])==2){
png(paste(args[1],"R\\Media_desviacion_P",idpac,"Terapia",tipoterapia,".png",sep=""),width = 1250, height = 420, units = "px", pointsize = 16)
}
x <- c(1,max(length(vector.terapia))); y <- c(miny,1.2*maxy);
plot(x, y,type="b", pch=21, col="white",xaxt="n", lty=3, xlab="Terapia", ylab="Distancia(mm)")
sub<-paste("Paciente ",idpac,"  Tipo de terapia ",tipoterapia,"  NTerapias: ",vector.terapia[1],"-",vector.terapia[length(vector.terapia)],sep="")
if((length(vector.terapia))>70){
filtroeje<-3
for(i in 1:(max(length(vector.terapia)))) {
if(filtroeje>1){
filtroeje<-filtroeje-1
vector.terapia[i]<-""
}else{
filtroeje<-3
}
}
}
axis(1,at=c(1:max(length(vector.terapia))),labels=(vector.terapia), las=2, cex.axis=0.7, tck=-.02)
lines(c(1:max(length(vector.terapia))),ECM[1:length(vector.terapia)], type="overplotted",pch=1, col="blue")
lines(c(1:max(length(vector.terapia))),STD[1:length(vector.terapia)],type="overplotted", pch=2, col="red")
legend("topleft",legend=c("Distancia media de las posiciones realizadas a posiciones deseadas","Desviacin Estandar de las posiciones realizadas a posiciones deseadas"),box.lty=1,pch=c(1,2),col=c("blue","red"))
main<-"Media y desviacin"
title(main, sub)
dev.off()
rm(x,y,conn,nmmax,ECM,STD,maxy,miny,vector.terapia,filtro,ecmsd,i,t,idpac,main,ECMact,sub,STDact,maxnterapias,nmax,nmin,q,tipoterapia,vector.terapiaact)
