########################################################################################################################################################################################################
###Autor: Miguel Zatarain
###Fecha: 24/04/2015
###Aceleracion en el eje y
###Script que va a calcular la velocidad en el eje y durante una terapia
############################################################################################################################

#limpiamos memoria ram
gc()
#conectar con el servidor
args <- commandArgs(TRUE)
require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")
print(args[1])
mydata<-c('nterapia','paciente','terapiatipo','ECM','STD','ve','t_reaccion','errorx','errory','v_pac_parado','v_rob_parado','v_pac_rob','sd_x','sd_y','sd_vx','sd_vy','sd_magnitudvel','sd_angulo','Evolucionx','Evoluciony','marca')
contador<-0
contador2<-0
direccion<-paste(args[1],"Resumen.txt",sep="")
salirdelbucle<-0
if(file.exists(direccion)){
	existe<-read.table(direccion, sep="\t",col.names=mydata)
	attach(existe)
	nmin<-max(nterapia)
	rm(existe)
	}else{
	file.create(direccion)
	nmin<-0
}
rm(mydata)

if(contador2<1){
	t<-paste("SELECT     IdTerapia, IdPaciente, TipoTerapia
	FROM         TerapiaBM
	WHERE     (IdTerapia >= ",nmin,")",sep="")
	
	terapiagrande<- sqlQuery(conn, t, errors=T)
	attach(terapiagrande)
	vector.terapiagrande<-IdTerapia
	detach(terapiagrande)
	rm(terapiagrande,t)
	gc()
	contador2<-2
	}

if(((max(vector.terapiagrande))-nmin)<200){
	nmax<-max(vector.terapiagrande)
	}else{
	nmax<-nmin+200
	}
	contador<-2

	if(contador>1){
		for(ww in nmin:nmax){

			t<-paste("SELECT     IdTerapia, IdPaciente, TipoTerapia
			FROM         TerapiaBM
			WHERE      (IdTerapia >= ",nmin,") AND (IdTerapia < ",nmax,")",sep="")

		contador3<-0
		if(contador3<1){
		terapia<- sqlQuery(conn, t, errors=T)
		attach(terapia)
		Paciente<-IdPaciente
		tipoterapia<-TipoTerapia
		vector.terapia<-IdTerapia
		detach(terapia)
		rm(terapia)
		gc()
		}
		contador3<-5		
		q<-paste("SELECT     m.IdMuestra, m.VelocidadX, m.VelocidadY, m.FuerzaX, m.FuerzaY, m.FuerzaAsistiva, t.IdTerapia, p.IdPaciente, m.PuntoDeseadoX, m.PuntoDeseadoY, m.PosicionX, m.Tiempo, m.Marcador, m.PosicionY
		FROM         Muestra AS m INNER JOIN
                      TerapiaBM AS t ON m.IdTerapia = t.IdTerapia INNER JOIN
                      PacientesBM AS p ON t.IdPaciente = p.IdPaciente
		WHERE     (t.IdTerapia > ",nmin,") AND (t.IdTerapia <= ",nmax,")
		ORDER BY m.IdMuestra",sep="")

		tabla<- sqlQuery(conn, q, errors=T)
		attach(tabla)

		#Inicializamos los vectores
		maxnterapias<-length(vector.terapia)
		ECM<-(maxnterapias:1)*0
		STD<-(maxnterapias:1)*0
		v<-(maxnterapias:1)*0
		filtro<-(maxnterapias:1)*0
		mediatiempo<-(maxnterapias:1)*0
		errorx<-(maxnterapias:1)*0
		errory<-(maxnterapias:1)*0
		MagPosCeroCompa<-(maxnterapias:1)*0
		MagPosRobotCero<-(maxnterapias:1)*0
		MagPosObjiCero<-(maxnterapias:1)*0
		dsx<-(maxnterapias:1)*0
		dsy<-(maxnterapias:1)*0
		dsvx<-(maxnterapias:1)*0
		dsvy<-(maxnterapias:1)*0
		dsa<-(maxnterapias:1)*0
		dsm<-(maxnterapias:1)*0
		Evolutionx<-(1:maxnterapias)*0
		Evolutiony<-(1:maxnterapias)*0
		mediaMar<-(1:maxnterapias)*0
		aaa<-(1:maxnterapias)*0
		bbb<-(1:maxnterapias)*0

		#Vamos a crear un bucle para hacer la media de cada terapia
		for(i in 1:maxnterapias) {
			#Seleccionamos la parte de la tabla que nos interesa, vamos cogiendo una por cada numero de terapia
			z<-subset(tabla, IdTerapia == vector.terapia[i])
			attach(z)
			a<-max(dim(z))
			#filtramos para que las terapias que hayan recogido pocos valores y nos van a dar sobrepicos no nos afecten
			if(a >4500){
		

				#Calculamos la maxima dimension y asignamos las posiciones
				#debido a que el tiempo es un caracter vamos a transformarlo a numrico en segundos mediante un bucle
				ti<-as.character(Tiempo)
				s1 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[1])))
				s2 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[2])))
				s3 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[3])))
				Vtiempois<-s1*3600+s2*60+s3
				Vector.tiempo<-Vtiempois[6:a-1]
				#####################################################################################
				##ACTUALIZAR MEDIA Y DESVIACIN
				#Asignamos posiciones y recirtamos los primeros valores que son erroneos
				px<-PosicionX
				px<-px[5:a]
				py<-PosicionY
				py<-py[5:a]
				pdx<-PuntoDeseadoX
				pdx<-pdx[5:a]
				pdy<-PuntoDeseadoY
				pdy<-pdy[5:a]
				#Calibramos la posicion del robot
				pyo<-rep(600,a-4)
				pxo<-rep(1,a-4)
				pyf<-(pyo-pdy)
				pxf<-(pdx+pxo)
				#Calculamos media y desviacion
				ECM[i] <- mean(((px - pxf)^2 + (py- pyf)^2)^0.5)
				STD[i] <- sd(((px - pxf)^2 + (py- pyf)^2)^0.5)
				
				###################################################################################
				##ACTUALIZAR VELOCIDAD
				#Obtenemos las velocidades y la media de las mismas
				vx<-VelocidadX
				vy<-VelocidadY
				vx<-vx[5:a]
				vx<-vx/1000
				vy<-vy[5:a]
				vy<-vy/1000
				vxy<-(1:a)*0
				vxy<-((vx)^2+(vy)^2)^0.5
				v[i]<-mean(vxy)
				rm(vxy)
				
				###################################################################################
				##ACTUALIZAR EVOLUCION FUERZA
				Fx<-FuerzaX
				Fx<-Fx[5:a]

				Fy<-FuerzaY
				Fy<-Fy[5:a]

				k<-FuerzaAsistiva 		# En Kg/s^2
				k<-k[5:a]
				
			maxleng<-(length(Fx))
			aceleracionx<-diff(vx)/(diff(Vector.tiempo))
			aceleracionx[is.na(aceleracionx)] <- 0
			aceleracionx[is.infinite(aceleracionx)] <- 1
			Fdx<- aceleracionx + 18*vx + k*((pxf - px)/1000)									# Calculo de la fuerza deseada segn el algoritmo hptico

			aceleraciony<-diff(vy)/(diff(Vector.tiempo))
			aceleraciony[is.na(aceleraciony)] <- 0						
			aceleraciony[is.infinite(aceleraciony)] <- 1
			Fdy<- aceleraciony + 18*vy + k*((pyf - py)/1000)	

			mFx<-mean(abs(Fx))
			mFy<-mean(abs(Fy))

			mFayudax<-mean(abs(Fdx))
			mFayuday<-mean(abs(Fdy))

			if(tipoterapia[i]>1){
				aaa[i]<-2
				Evolutionx[i]<-100*(mFx/1000)/((mFx/1000)+(mFayudax))
				Evolutiony[i]<-100*(mFy/1000)/((mFy/1000)+(mFayuday))
			}else{
				bbb[i]<-1
				Evolutionx[i]<-100*mFx/(mFx+mFayudax)
				Evolutiony[i]<-100*mFy/(mFy+mFayuday)
			}
			#rm(Fx,mFx,mFy,mFayudax,mFayuday,Fy,Fdx,Fdy,aceleraciony,k,vx,vy,aceleraciony,aceleracionx)
				###################################################################################
				##ACTUALIZAR TIEMPO DE REACCION
				#Diferencia entre los puntos para sabes si el sentido es positivo o negativo
				dpyf<-diff(pyf)
				dpxf<-diff(pxf)
				dpx<-diff(px)
				dpy<-diff(py)

				dpyt<-dpyf*dpy
				dpxt<-dpxf*dpx
	
				#Vamos a calcular que todos los tiempos comprendidos entre el cambio de sentido total y el real sean los mismos
				#Nuestro objetivo  es que durante el cambio de sentido es decir desde que pdx cambie de sentido hasta que px cambie de sentido haya unos y en el resto de la matriz 0s e igual para py
				m<-(length(dpyt))
				dx <- (1:m)*0
				dy <- (1:m)*0
				jx= which(dpxt<0)
				jy= which(dpyt<0)
				dx[jx]= 1
				dx[is.na(dx)] <- 0
				dy[jy]= 1
				dy[is.na(dx)] <- 0
				dtotal<-dx+dy
				dtotala<-dtotal*0
				dtotalb<-dtotal*0
				jtotal= which(dtotal>0)
				dtotal[jtotal]= 1
				dtotal[1]=0
				dtotal[is.na(dx)] <- 0

				#Hacemos este filtro para eliminar los valores que son parasitos como un uno en mitad de muchos ceros o un cero en mitad de muchos unos
				for(w in 1:(length(dtotal))) {
					if(w>2){
						if((dtotal[w-1]<dtotal[w-2])&(dtotal[w-1]<dtotal[w])){
						dtotal[w-1]=1}
					}

					if(w>2){
						if((dtotal[w-1]>dtotal[w-2])&(dtotal[w-1]>dtotal[w])){
						dtotal[w-1]=0}
					}

					if(w>3){
						if((dtotal[w-2]==1)&(dtotal[w-3]==0)){
						dtotala[w-2]=1}
					}
					if(w>3){
						if((dtotal[w-3]==1)&(dtotal[w-2]==0)){
						dtotalb[w-2]=1}
					}
				}
				#Aplicamops los filtros
				filtroa<-which(dtotala>0)
				filtrob<-which(dtotalb>0)
				tiempoa<-Vector.tiempo[filtroa]
				tiempob<-Vector.tiempo[filtrob]
				tiempo<-tiempob-tiempoa			

				if(length(tiempo)<2){ 
					tiempo<-c(0.5,0.5)
				}

				mediatiempo[i]<-mean(abs(tiempo[1:((length(tiempo))-1)]))

				rm(m,dx,dy,jx,jy,dtotal,dtotala,dtotalb,jtotal,w,filtroa,filtrob,tiempoa,tiempob,tiempo)
				###################################################################################
				##ACTUALIZAR VELOCIDAD
				filtrom<-(5:a)*0
				for(m in 1:(length(py))){
					if((abs(pxf[m])!=abs(px[m])) & (abs(pyf[m])!=abs(py[m]))&(pxf[m]!=0) & (pyf[m]!=0)){
						filtrom[m]<-m
					}else{
						filtrom[m]<-0
					}		
				}
				pxe<-px[filtrom]
				pye<-py[filtrom]
				pxfe<-pxf[filtrom]
				pyfe<-pyf[filtrom]
				#Calculamos los errores
				errorx[i]<-100*mean(abs(((1000+pxfe)-(1000+pxe))/(pxfe+pxe)))
				errory[i]<-100*mean(abs(((1000+pyfe)-(1000+pye))/(pyfe+pye)))
				rm(filtrom,pxe,pye,pxfe,pyfe,m)
				###################################################################################
				##ACTUALIZAR TEMBLOREs
				MagPosRobot<-(dpx^2+ dpy^2)^0.5
				MagPosObji<-(dpxf^2+dpyf^2)^0.5 
				#Inicializamos las variables
				MagPosRobotCerox <-0
				MagPosObjiCerox <-0
				#Hacemos un bucle para ver cuantas veces son 0
				for (zz in 1:(length (MagPosObji)-3)){
					if(zz<(length (MagPosObji))-3){

    						if (TRUE && (MagPosRobot[zz+1]== 0) && (MagPosRobot[zz]!= 0)){
        						MagPosRobotCerox <- MagPosRobotCerox+1}       
    
    						if (TRUE&&(MagPosObji[zz+1]==0) && (MagPosObji[zz]!=0)){
        					MagPosObjiCerox <- MagPosObjiCerox+1}
					}
				}

				MagPosRobotCero[i]<-MagPosRobotCerox
				MagPosObjiCero[i]<-MagPosObjiCerox
				MagPosCeroCompa[i]<- MagPosRobotCero[i] - MagPosObjiCero[i]
				rm(MagPosRobot,MagPosObji,MagPosRobotCerox,MagPosObjiCerox,zz)
				###################################################################################
				##ACTUALIZAR SIMETRA X,Y
				m<-(length(px))
				dx     <- (1:m)*0
				jx     = which(dpxt >= 0)
				dx[jx]  = 1
				dx[is.na(dx)] <- 0
				dsx[i]<-sum(dx)*100/m

				dy     <- (1:m)*0
				jy     = which(dpyt>=0)
				dy[jy]  = 1
				dy[is.na(dy)] <- 0
				dsy[i]<-sum(dy)*100/m
				rm(m,dx,jx,dpxt,dy,jy,dpyt)
				###################################################################################
				##ACTUALIZAR SIMETRA X,Y,VELOCIDADX,VELOCIDADY,MAGNITUD VELOCIDAD, ANGULO
				maxleng<-(length(px))			
				VelxRobot<-(maxleng:1)*0
				VelyRobot<-(maxleng:1)*0
				MagVelRobot<-(maxleng:1)*0
				VelxObji<-(maxleng:1)*0
				VelyObji<-(maxleng:1)*0
				MagVelObji<-(maxleng:1)*0
				AnguloVelRobot<-(maxleng:1)*0
				AnguloVelObji<-(maxleng:1)*0

				tiempor<-diff(Vtiempois)
				filtrob<-which(tiempor>=0)
				pxx<-px[filtrob]
				pyy<-py[filtrob]
				tiempor<-tiempor[filtrob]
				pxff<-pxf[filtrob]
				pyff<-pyf[filtrob]
				VelxRobot <- diff(pxx)/(tiempor*1000)
				VelyRobot <- diff(pyy)/(tiempor*1000)
				MagVelRobot<-(VelxRobot^2+ VelyRobot^2)^0.5
				VelxObji <- diff(pxff)/(tiempor*1000)
				VelyObji <- diff(pyff)/(tiempor*1000)
				MagVelObji<-(VelxObji^2+ VelyObji^2)^0.5  
				AnguloVelRobot=asin(VelyRobot/MagVelRobot) 
				AnguloVelObji=asin(VelyObji/MagVelObji)		

				#Calculamos ahora las desviaciones del robot
				#Contador
				m<-(length(VelxRobot))
				#Calculamos desviacion en velocidad en x
				dummyvx <-diff(VelxObji)*diff(VelxRobot)
				dvx <- (1:m)*0
				jvx= which(dummyvx>=0)
				dvx[jvx]= 1
				dvx[is.na(dvx)] <- 0
				dsvx[i]<-sum(dvx)*100/m
				#Calculamos desviacion en velocidad en y
				dummyvy <-diff(VelyObji)*diff(VelyRobot)
				dvy<- (1:m)*0
				jvy = which(dummyvy>=0)
				dvy[jvy]  = 1
				dvy[is.na(dvy)] <- 0
				dsvy[i]<-sum(dvy)*100/m		
				#Calculamos desviacion en la magnitud de la velocidad
				dummym <-diff(MagVelObji)*diff(MagVelRobot)
				dm     <- (1:m)*0
				jm     = which(dummym>=0)
				dm[jm]  = 1
				dm[is.na(dm)] <- 0
				dsm[i]<-sum(dm)*100/m
				#Calculamos desviacion en la diferencia del angulo
				dummya <-diff(AnguloVelObji)*diff(AnguloVelRobot)
				da     <- (1:m)*0
				ja     = which(dummya>=0)
				da[ja]  = 1
				da[is.na(da)] <- 0
				dsa[i]<-(sum(da)*100/m)
				rm(m,da,ja,dummya,dm,jm,dummym,dvx,jvx,dummyvx,dvy,jvy,dummyvy,AnguloVelObji,AnguloVelRobot,MagVelObji,VelyObji,VelxObji,MagVelRobot,VelyRobot,VelxRobot,pyff,pxff,tiempor,pxx,pyy,filtrob,maxleng)


			###################################################################################
			##ACTUALIZAR MARCADOR 

			Mar<-Marcador		
			Mar<-Mar[5:a]
			mediaMar[i]=Mar[length(Mar)]

				#Creamos un filtro para que nos guarde las posiciones de las terapias con suficientes datos
				filtro[i]=i		
			}else{
			#Ponemos como cero los valores que no tienen suficientes datos
			filtro[i]=0
			}
		#borramos los valores para evitar problemas
		detach(z)
		rm(pdx,pdy,vxy,vx,vy,px,pxf,pxo,py,pyf,pyo,z,a,V)
	

		}
	detach(tabla)
	rm(tabla)

	#filtramos nuestras 3 variables
	vector.terapia<-vector.terapia[filtro]
	ECM<-ECM[filtro]
	STD<-STD[filtro]
	Paciente<-Paciente[filtro]
	tipoterapia<-tipoterapia[filtro]
	v<-v[filtro]
	mediatiempo<-mediatiempo[filtro]
	errorx<-errorx[filtro]
	errory<-errory[filtro]
	MagPosCeroCompa<-MagPosCeroCompa[filtro]
	MagPosRobotCero<-MagPosRobotCero[filtro]
	MagPosObjiCero<-MagPosObjiCero[filtro]
	dsx<-dsx[filtro]
	dsy<-dsy[filtro]
	dsvx<-dsvx[filtro]
	dsvy<-dsvy[filtro]
	dsa<-dsa[filtro]
	dsm<-dsm[filtro]
	Evolutionx<-Evolutionx[filtro]
	Evolutiony<-Evolutiony[filtro]
	mediaMar<-mediaMar[filtro]
	for(i in 1:(length(ECM))) {
		datos<-c(vector.terapia[i],Paciente[i],tipoterapia[i],ECM[i],STD[i],v[i],mediatiempo[i],errorx[i],errory[i],MagPosRobotCero[i],MagPosObjiCero[i],MagPosCeroCompa[i],dsx[i],dsy[i],dsvx[i],dsvy[i],dsm[i],dsa[i],Evolutionx[i],Evolutiony[i],mediaMar[i])
		if(is.na(Paciente[length(i)])==FALSE){
		#Evita que se forme una fila de NA NA NA NA al intentar meter una columna de mas si alguien por error pulsa el boton mas veces
		write(datos, file = direccion,sep = "\t",ncolumns=21,append=TRUE)
			}else{
		break	
		}
	}
		if(((max(vector.terapiagrande))-nmin)<200){
		break
		rm(dsx,dsy,dsvx,dsvy,dsa,dsm,MagPosObjiCero,MagPosRobotCero,MagPosCeroCompa,i,contador,findeciclo2,findeciclo,nmax,nmin,datos,vector.terapia,vector.terapiagrande,ECM,STD,Paciente,tipoterapia,v,mediatiempo,errox,errory)
		}
		nmin<-nmin+200
		if(((max(vector.terapiagrande))-nmin)<200){		
		nmax<-max(vector.terapiagrande)
		}else{
		nmax<-nmin+200}
	}
}
rm(dsx,dsy,dsvx,dsvy,dsa,q,t,dsm,MagPosObjiCero,MagPosRobotCero,MagPosCeroCompa,i,contador,findeciclo2,findeciclo,nmax,nmin,datos,vector.terapia,vector.terapiagrande,ECM,STD,Paciente,tipoterapia,v,mediatiempo,errox,errory)