########################################################################################################################################################################################################
###Autor: Miguel Zatarain
###Fecha: 28/04/2015
###Fuerza en el eje y
###Script que va a calcular la fuerza que realiza el paciente y con la que asiste el robot en el eje x durante una terapia
############################################################################################################################
args <- commandArgs(TRUE)
require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")

require(FKF) #Para filtrar la fuerza vamos a utilizar el filitro de kalman


fmedy<-as.numeric(args[4])
fmaxy<-as.numeric(args[2])
fminy<-as.numeric(args[3])
n<-as.numeric(args[5])


b<-paste("SELECT     IdMuestra, PosicionY, FuerzaY, IdTerapia, FuerzaAsistiva, VelocidadY, Tiempo, PuntoDeseadoX, PuntoDeseadoY
FROM         Muestra
WHERE     (IdTerapia = ",n,")
ORDER BY IdMuestra",sep="")

Data.fr <- sqlQuery(conn, b, errors=T)
attach(Data.fr)
a<-max(dim(Data.fr))
m<-1								# En Kg
b<-18								# En Kg/s

#debido a que el tiempo es un caracter vamos a transformarlo a numrico en segundos mediante un bucle
ti<-as.character(Tiempo)
s1 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[1])))
s2 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[2])))
s3 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[3])))
Vtiempois<-s1*3600+s2*60+s3
#Ya tenemos el tiempo en segundos
#Vamos a quitar los primeros 5 valores de cada columna porque tienen un error que puede llevar a errores
#Asignamos los valores de cada columna a una variable
Vtiempo<-Vtiempois[4:a]
print("Hola");
Fy<-FuerzaY
Fy<-(Fy[5:a])/1000

k<-FuerzaAsistiva 		# En Kg/s^2
k<-k[5:a]
vy<-VelocidadY
vy<-(vy[4:a])/1000

py<-PosicionY
py<-(py[5:a])/1000


pdx<-PuntoDeseadoX
pdx<-(pdx[5:a])
pdy<-PuntoDeseadoY
pdy<-(pdy[5:a])

pyo<-rep(600,a-4)
pyf<-(pyo-pdy)/1000

maxleng<-length(pdx)


maxleng<-(length(Fy))


aceleraciony<-diff(vy)/(diff(Vtiempo))
aceleraciony[is.na(aceleraciony)] <- 0
aceleraciony[is.infinite(aceleraciony)] <- 1
print(aceleraciony)
Fdy<- m*aceleraciony + b*vy + k*((pyf - py))	

#Dado que el tiempo de muestro es distinto cada vez no nos da los mismo puntos exactos, asique para saber donde
#empieza una vuelta seleccionamos un pequeno area
Iniciox<-pdx[150]
Inicioy<-pdy[150]
filtro<-(1:maxleng)*0
for(i in 1:(maxleng)){ 
	if(Iniciox>(pdx[i]-30) & Inicioy>(pdy[i]-30) & Iniciox<(pdx[i]+30) & Inicioy<pdy[i]+30) {
	filtro[i]=i}
}
print(args[3]);
#Filtramos para que solo se produzcan varios de los puntos de ese area seguidos

filtrob<-filtro*0

for(i in 1:(maxleng)){
	if (i>110){
	if((filtro[i]!=0)&(filtro[i-1]!=0)&(filtro[i-2]!=0)&(filtro[i-3]!=0)&(filtro[i-4]!=0)&(filtro[i-5]!=0)&(filtro[i-6]!=0)){
	filtrob[i]=i}
	}
}

#Calculamos los lmites de inicio de cada vuelta
a=150
b<-1
limites<-vector()
for(i in 1:(maxleng)){ 
	if(filtrob[i]>a+650) {
		limites[b]=i
		b<-b+1
		a<-i}
}

#Inicializamos los vectores para calcular los puntos mximos mnimo y medio



Fuerzasy1<-vector()
Fuerzasy2<-vector()
mediafueycompara<-mean(abs(Fy))
mediafuey<-Fy[limites[1]:limites[2]]
maxfuey<-Fy[limites[1]:limites[2]]
minfuey<-Fy[limites[1]:limites[2]]
minpdyfue<-pyf[limites[1]:limites[2]]
maxpdyfue<-pyf[limites[1]:limites[2]]
mediapdyfue<-pyf[limites[1]:limites[2]]
Vtiempofy1<-Vtiempo[limites[1]:limites[2]]
Vtiempofy2<-Vtiempo[limites[1]:limites[2]]
Vtiempofy3<-Vtiempo[limites[1]:limites[2]]
Fdsy1<-vector()
Fdsy2<-vector()
mediafuedy<-Fdy[limites[1]:limites[2]]
maxfuedy<-Fdy[limites[1]:limites[2]]
minfuedy<-Fdy[limites[1]:limites[2]]



for(i in 1:(length(limites))){
	if(i<length(limites)-1){

			#Calculamos las velocidades
		
			Fuerzasy1<-Fy[limites[i]:limites[i+1]]
			Fuerzasy2<-Fy[limites[i+1]:limites[i+2]]
			Fdsy1<-Fdy[limites[i]:limites[i+1]]
			Fdsy2<-Fdy[limites[i+1]:limites[i+2]]			
			

			if(mean(abs(Fuerzasy1)) < mean(abs(Fuerzasy2)) & mean(abs(Fuerzasy2))>mean(abs(maxfuey))){
			maxfuey<-Fuerzasy2
			maxfuedy<-Fdsy2
			maxpdyfue<-pyf[limites[i+1]:limites[i+2]]
			Vtiempofy1<-Vtiempo[limites[i+1]:limites[i+2]]
			}
			
			if(mean(abs(Fuerzasy1))> mean(abs(Fuerzasy2))& mean(abs(Fuerzasy2))<mean(abs(minfuey))){
			minfuey<-Fuerzasy2
			minfuedy<-Fdsy2
			minpdyfue<-pyf[limites[i+1]:limites[i+2]]
			Vtiempofy2<-Vtiempo[limites[i+1]:limites[i+2]]
			}

			if(abs(1-(abs(mean(abs(Fuerzasy1))/mediafueycompara))) > abs(1-(abs(mean(abs(Fuerzasy2))/mediafueycompara)))& abs(1-(abs(mean(abs(Fuerzasy2))/mediafueycompara)))< abs(1-(abs(mean(abs(mediafuey))/mediafueycompara)))){
			mediafuey<-Fuerzasy2
			mediafuedy<-Fdsy2
			mediapdyfue<-pyf[limites[i+1]:limites[i+2]]
			Vtiempofy3<-Vtiempo[limites[i+1]:limites[i+2]]
			}			
}
}

mediapdyfue<-mediapdyfue*10
maxpdyfue<-maxpdyfue*10
minpdyfue<-minpdyfue*10


Vtiempofy1<-Vtiempofy1 - Vtiempofy1[1]
Vtiempofy2<-Vtiempofy2 - Vtiempofy2[1]
Vtiempofy3<-Vtiempofy3 - Vtiempofy3[1]

maxtiempo<-max(max(Vtiempofy1),max(Vtiempofy2),max(Vtiempofy3))

Vtiempofy1<-Vtiempofy1*maxtiempo/max(Vtiempofy1)
Vtiempofy2<-Vtiempofy2*maxtiempo/max(Vtiempofy2)
Vtiempofy3<-Vtiempofy3*maxtiempo/max(Vtiempofy3)

#Empezamos a graficar
#Calculamos el mayor valor de de x para el ploteo
maxy<-max(max(maxfuey),max(minfuey),max(mediafuey),8+max(mediapdyfue),max(maxfuedy),max(minfuedy),max(mediafuedy))
miny<-min(min(maxfuey),min(minfuey),min(mediafuey),min(mediapdyfue),min(maxfuedy),min(minfuedy),min(mediafuedy))


if(as.numeric(args[6])==0){
png(paste(args[1],"R\\FuerzasvyTerapia",n,".png",sep=""),width = 1147, height = 756, units = "px", pointsize = 16)

}
if(as.numeric(args[6])==1){
png(paste(args[1],"R\\Muestras1.png",sep=""),width = 1275, height = 450, units = "px", pointsize = 16)

}
if(as.numeric(args[6])==2){
png(paste(args[1],"R\\Muestras2.png",sep=""),width = 1275, height = 450, units = "px", pointsize = 16)

}

par(mar=c(5, 4, 4, 5) + 0.1)
x <- c(1,max(Vtiempofy1)); y <- c(miny,1.4*maxy);
maxy<-1.4*maxy 
 
plot(x, y,type="b", pch=21, col="white",xaxt="n", lty=3, xlab="Tiempo(s)", ylab="Fuerzas en y(N)")
axis(1,at=c(1:max(Vtiempofy1 )))
mtext("Distancia (dm)", side=4, line=3, cex.lab=1,las=0)

if(fmaxy>0.5){
####################################################
#Filtro para la fuerza

y <- maxfuey
y[c(3, 10)] <- NA  # Para que los valores NA sean tratados
## Inicializamos las constantes en los parmetros:
dt <- ct <- matrix(0)
Zt <- Tt <- matrix(1)
a0 <- y[1]            # Variacin del primer valor
P0 <- matrix(10)     # variacin de a0
## Parametros estimados:
fit.fkf <- optim(c(HHt = var(y, na.rm = TRUE) * .5,
GGt = var(y, na.rm = TRUE) * .5),
fn = function(par, ...)
-fkf(HHt = matrix(par[1]), GGt = matrix(par[2]), ...)$logLik,
yt = rbind(y), a0 = a0, P0 = P0, dt = dt, ct = ct,
Zt = Zt, Tt = Tt, check.input = FALSE)
## Filtramos la aceleracion con los parametros estimados:
Fyf<-fkf(a0, P0, dt, ct, Tt, Zt, HHt = matrix(fit.fkf$par[1]),
GGt = matrix(fit.fkf$par[2]), yt = rbind(y))
############################################################
maxfueyf<-Fyf$att[1, ]

axis(4, at= 10 + seq((miny-10),(maxy-10), by=3),labels=round(seq(miny-10, maxy-10, by=3),digits=2), las=2, tck=-.01)

lines((Vtiempofy1),maxfueyf[1:length(Vtiempofy1)], type="overplotted",pch=1, col="deepskyblue")
lines((Vtiempofy1),maxfuedy[1:length(Vtiempofy1)], type="overplotted",pch=2, col="dodgerblue4")
lines((Vtiempofy1),10+maxpdyfue[1:length(Vtiempofy1)],type="overplotted", pch=4, col="black")
#lines((Vtiempofy1),(maxfueyf+maxfuedy)[1:length(Vtiempofy1)],type="overplotted", pch=4, col="red")

legend("topleft",legend=c("Fuerza mxima del paciente en el eje y(N)","Fuerza asistiva en el eje y(N)","Puntos deseados del paciente en el eje y(dm)"),box.lty=1,pch=c(1,2,4),col=c("deepskyblue","dodgerblue4","black"))
print("Holamax");
}
if(fminy>0.5){

####################################################
#Filtro para la fuerza

y <- minfuey
y[c(3, 10)] <- NA  # Para que los valores NA sean tratados
## Inicializamos las constantes en los parmetros:
dt <- ct <- matrix(0)
Zt <- Tt <- matrix(1)
a0 <- y[1]            # Variacin del primer valor
P0 <- matrix(10)     # variacin de a0
## Parametros estimados:
fit.fkf <- optim(c(HHt = var(y, na.rm = TRUE) * .5,
GGt = var(y, na.rm = TRUE) * .5),
fn = function(par, ...)
-fkf(HHt = matrix(par[1]), GGt = matrix(par[2]), ...)$logLik,
yt = rbind(y), a0 = a0, P0 = P0, dt = dt, ct = ct,
Zt = Zt, Tt = Tt, check.input = FALSE)
## Filtramos la aceleracion con los parametros estimados:
Fminyf<-fkf(a0, P0, dt, ct, Tt, Zt, HHt = matrix(fit.fkf$par[1]),
GGt = matrix(fit.fkf$par[2]), yt = rbind(y))
############################################################
minfueyf<-Fminyf$att[1, ]
axis(4, at= 10 + seq((miny-10),(maxy-10), by=3),labels=round(seq(miny-10, maxy-10, by=3),digits=2), las=2, tck=-.01)

lines((Vtiempofy2),minfueyf[1:length(Vtiempofy2)],type="overplotted", pch=3, col="firebrick1")
lines((Vtiempofy2),minfuedy[1:length(Vtiempofy2)],type="overplotted", pch=5, col="firebrick4")
lines((Vtiempofy2),10+minpdyfue[1:length(Vtiempofy2)],type="overplotted", pch=4, col="black")

legend("topleft",legend=c("Fuerza mnima del paciente en el eje y(N)","Fuerza asistiva en el eje y(N)","Puntos deseados del paciente en el eje y(dm)"),box.lty=1,pch=c(3,5,4),col=c("firebrick1","firebrick4","black"))

}
if(fmedy>0.5){

####################################################
#Filtro para la fuerza

y <- mediafuey
y[c(3, 10)] <- NA  # Para que los valores NA sean tratados
## Inicializamos las constantes en los parmetros:
dt <- ct <- matrix(0)
Zt <- Tt <- matrix(1)
a0 <- y[1]            # Variacin del primer valor
P0 <- matrix(10)     # variacin de a0
## Parametros estimados:
fit.fkf <- optim(c(HHt = var(y, na.rm = TRUE) * .5,
GGt = var(y, na.rm = TRUE) * .5),
fn = function(par, ...)
-fkf(HHt = matrix(par[1]), GGt = matrix(par[2]), ...)$logLik,
yt = rbind(y), a0 = a0, P0 = P0, dt = dt, ct = ct,
Zt = Zt, Tt = Tt, check.input = FALSE)
## Filtramos la aceleracion con los parametros estimados:
Fmediayf<-fkf(a0, P0, dt, ct, Tt, Zt, HHt = matrix(fit.fkf$par[1]),
GGt = matrix(fit.fkf$par[2]), yt = rbind(y))
############################################################
mediafueyf<-Fmediayf$att[1, ]
axis(4, at= 10 + seq((miny-10),(maxy-10), by=3),labels=round(seq(miny-10, maxy-10, by=3),digits=2), las=2, tck=-.01)

lines((Vtiempofy3),mediafueyf[1:length(Vtiempofy3)],type="overplotted", pch=6, col="darkolivegreen1")
lines((Vtiempofy3),mediafuedy[1:length(Vtiempofy3)],type="overplotted", pch=7, col="darkgreen")
lines((Vtiempofy3),10+mediapdyfue[1:length(Vtiempofy3)],type="overplotted", pch=4, col="black")

legend("topleft",legend=c("Fuerza media del paciente en el eje y(N)","Fuerza asistiva en el eje y(N)","Puntos deseados del paciente en el eje y(dm)"),box.lty=1,pch=c(6,7,4),col=c("darkolivegreen1","darkgreen","black"))

}

main<-"Fuerza del paciente en el eje y"
sub<-paste(" NTerapia: ",n,sep="")
title(main, sub)


dev.off()

rm(n,fmedy,filtrob,limites,fmaxy,fminy,Data.fr,a,m,b,ti,s1,s2,s3,Vtiempois,Vtiempo,Fy,k,vy,vyo,vyf,pdx,pdy,maxleng,aceleraciony,Fdy,Iniciox,Inicioy,filtro,i,Fuerzasy1,Fuerzasy2,mediafueycompara,mediafuey,maxfuey,minfuey,minpdyfue,maxpdyfue,mediapdyfue,Vtiempofy1,Vtiempofy2,Vtiempofy3,Fdsy1,Fdsy2,mediafuedy,maxfuedy,minfuedy,maxtiempo,maxy,miny,x,y,dt,ct,Zt,Tt,a0,P0,Fyf,maxfueyf,Fminyf,minfueyf,Fmediayf,mediafueyf,main,sub,py,pyf,pyo)
rm(fit.fkf)

