################################################################################################################################################################################################
###Autor: Miguel Zatarain
###Fecha: 17/04/2015
###	TRAYECTORIA
###Script que se encarga de calcular la trayectoria realizada y la trayectoria deseada
##########################################################################################################################################################################
#conectamos con el servidor
args <- commandArgs(TRUE)
require(RODBC)

conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")
#obtenemos los valores de la tabla
n<-args[2]
#Entramos en la base de datos para saber que tipo de terapia es y que paciente la utiliza
t<-paste("SELECT     IdTerapia, IdPaciente, TipoTerapia, Dificultad
FROM         TerapiaBM
WHERE     (IdTerapia = ",n,")",sep="")
terapia<- sqlQuery(conn, t, errors=T)
attach(terapia)

#Guatdamos los valores del tipo de terapia y del paciente y borramos los otros datos
tipoterapia<-TipoTerapia
idpac<-IdPaciente
dificultad<-Dificultad
rm(terapia,t)

#conectamos de nuevo con la base de datos para obtener las posiciones del paciente y las deseadas
b<-paste("SELECT     PosicionX, PosicionY, IdTerapia, PuntoDeseadoX, PuntoDeseadoY FROM         Muestra WHERE     (IdTerapia = ",n,")",sep="")
Data.fr <- sqlQuery(conn, b, errors=T)
attach(Data.fr)

#Calculamos la maxima dimension y asignamos las posiciones
a<-max(dim(Data.fr))
px<-PosicionX
px<-px[5:a]
py<-PosicionY
py<-py[5:a]
pdx<-PuntoDeseadoX
pdx<-pdx[5:a]
pdy<-PuntoDeseadoY
pdy<-pdy[5:a]

#Calibramos la posicion del robot
pyo<-rep(600,a-4)
pxo<-rep(1,a-4)
pyf<-(pyo-pdy)
pxf<-(pdx+pxo)


#Hacemos las graficas
if(as.numeric(args[3])==0){
png(paste(args[1],"\\R\\Terapia",n,".png",sep=""),width =600, height = 600, units = "px", pointsize = 16)

}
if(as.numeric(args[3])==1){
png(paste(args[1],"R\\Terapiamuestra1.png",sep=""),width =600, height = 600, units = "px", pointsize = 16)

}
if(as.numeric(args[3])==2){
png(paste(args[1],"R\\Terapiamuestra2.png",sep=""),width =600, height = 600, units = "px", pointsize = 16)

}

plot(c(1,880),c(1,650),col="white",lwd=2,type="l",xlab="Eje x", ylab="Eje y")
points(px,py,col="blue",lwd=2,type="l")
points(pxf,pyf,col="red",lwd=2,type="l")

main<-"Trayectoria del paciente respecto a la deseada"
sub<-""
title(main, sub)
main<-"Trayectoria del paciente respecto a la deseada"
sub<-paste("Paciente ",idpac,"  Tipo de terapia ",tipoterapia,"  NTerapia: ",n," Dificultad: ",dificultad,sep="")
title(main, sub)

legend("topleft",legend=c("trayectoria realizada (mm)","trayectoria deseada (mm)"),box.lty=1,pch=c(1),col=c("blue","red"))
dev.off()

#Borramos las variables para evitarnos problemas
rm(a,b,idpac,tipoterapia,conn ,Data.fr,letrero,letrero2,main,n,pdx,pdy,px,pxf,pxo,py,pyf,pyo,sub)
