########################################################################################################################################################################################################
###Autor: Miguel Zatarain
###Fecha: 24/04/2015
###Velocidad en el eje x
###Script que va a calcular la velocidad en el eje x durante una terapia
############################################################################################################################
args <- commandArgs(TRUE)
require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")

vmedx<-as.numeric(args[4])
vmaxx<-as.numeric(args[2])
vminx<-as.numeric(args[3])
n<-as.numeric(args[5])

b<-paste("SELECT     IdMuestra, PosicionX, PosicionY, FuerzaX, FuerzaY, IdTerapia, FuerzaAsistiva, VelocidadX, Tiempo, VelocidadY, PuntoDeseadoX, PuntoDeseadoY
FROM         Muestra
WHERE     (IdTerapia = ",n,")
ORDER BY IdMuestra",sep="")

Data.fr <- sqlQuery(conn, b, errors=T)
attach(Data.fr)
a<-max(dim(Data.fr))
 

ti<-as.character(Tiempo)
s1 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[1])))
s2 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[2])))
s3 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[3])))
Vtiempois<-s1*3600+s2*60+s3
#Ya tenemos el tiempo en segundos
#Vamos a quitar los primeros 5 valores de cada columna porque tienen un error que puede llevar a errores
#Asignamos los valores de cada columna a una variable
Vtiempo<-Vtiempois[4:a]

vx<-VelocidadX
vx<-(vx[4:a])/1000



pdx<-PuntoDeseadoX
pdx<-(pdx[5:a])
pdy<-PuntoDeseadoY
pdy<-(pdy[5:a])
maxleng<-length(pdx)
#Calibramos la posicion del robot
pxo<-(rep(1,a-4))
pxf<-(pdx+pxo)/1000

Iniciox<-pdx[600]
Inicioy<-pdy[600]
filtro<-(1:maxleng)*0
for(i in 1:(maxleng)){ 
	if(Iniciox>(pdx[i]-10) & Inicioy>(pdy[i]-10) & Iniciox<(pdx[i]+10) & Inicioy<pdy[i]+10) {
		filtro[i]=i}
}
a=200
b<-1
limites<-vector()
for(i in 1:(maxleng)){ 
	if(filtro[i]>a+650) {
		limites[b]=i
		b<-b+1
		a<-i}
}

Velocidadesx1<-vector()
Velocidadesx2<-vector()
mediavelxcompara<-mean(abs(vx))
mediavelx<-vx[limites[1]:limites[2]]
maxvelx<-vx[limites[1]:limites[2]]
minvelx<-vx[limites[1]:limites[2]]
minpdxvel<-pxf[limites[1]:limites[2]]
maxpdxvel<-pxf[limites[1]:limites[2]]
mediapdxvel<-pxf[limites[1]:limites[2]]
Vtiempovx1<-Vtiempo[limites[1]:limites[2]]
Vtiempovx2<-Vtiempo[limites[1]:limites[2]]
Vtiempovx3<-Vtiempo[limites[1]:limites[2]]

for(i in 1:(length(limites))){
	if(i<length(limites)-1){

			#Calculamos las velocidades
		
			Velocidadesx1<-vx[limites[i]:limites[i+1]]
			Velocidadesx2<-vx[limites[i+1]:limites[i+2]]			

			if(mean(abs(Velocidadesx1)) < mean(abs(Velocidadesx2)) & mean(abs(Velocidadesx2))>mean(abs(maxvelx))){
			maxvelx<-Velocidadesx2
			maxpdxvel<-pxf[limites[i+1]:limites[i+2]]
			Vtiempovx1<-Vtiempo[limites[i+1]:limites[i+2]]
			}
			
			if(mean(abs(Velocidadesx1))> mean(abs(Velocidadesx2))& mean(abs(Velocidadesx2))<mean(abs(minvelx))){
			minvelx<-Velocidadesx2
			minpdxvel<-pxf[limites[i+1]:limites[i+2]]
			Vtiempovx2<-Vtiempo[limites[i+1]:limites[i+2]]
			}

			if(abs(1-(abs(mean(abs(Velocidadesx1))/mediavelxcompara))) > abs(1-(abs(mean(abs(Velocidadesx2))/mediavelxcompara)))& abs(1-(abs(mean(abs(Velocidadesx2))/mediavelxcompara)))< abs(1-(abs(mean(abs(mediavelx))/mediavelxcompara)))){
			mediavelx<-Velocidadesx2
			mediapdxvel<-pxf[limites[i+1]:limites[i+2]]
			Vtiempovx3<-Vtiempo[limites[i+1]:limites[i+2]]
			}			
}
}

Vtiempovx1<-Vtiempovx1 - Vtiempovx1[1]
Vtiempovx2<-Vtiempovx2 - Vtiempovx2[1]
Vtiempovx3<-Vtiempovx3 - Vtiempovx3[1]

#maxtiempo<-max(max(Vtiempovx1),max(Vtiempovx2),max(Vtiempovx3))

maxtiempo<-max(Vtiempovx1)

Vtiempovx1<-Vtiempovx1*maxtiempo/max(Vtiempovx1)
Vtiempovx2<-Vtiempovx2*maxtiempo/max(Vtiempovx2)
Vtiempovx3<-Vtiempovx3*maxtiempo/max(Vtiempovx3)

#Empezamos a graficar
#Calculamos el mayor valor de de x para el ploteo
maxy<-max(max(maxvelx),max(minvelx),max(mediavelx),(1.5+max(mediapdxvel)))
miny<-min(min(maxvelx),min(minvelx),min(mediavelx))



if(as.numeric(args[6])==0){
png(paste(args[1],"R\\VelocidadvxTerapia",n,".png",sep=""),width = 1147, height = 756, units = "px", pointsize = 16)

}
if(as.numeric(args[6])==1){
png(paste(args[1],"R\\Muestras1.png",sep=""),width = 1275, height = 450, units = "px", pointsize = 16)

}
if(as.numeric(args[6])==2){
png(paste(args[1],"R\\Muestras2.png",sep=""),width = 1275, height = 450, units = "px", pointsize = 16)

}

par(mar=c(5, 4, 4, 5) + 0.1)
x <- c(1,max(Vtiempovx1)); y <- c(miny,1.4*maxy);
maxy<-1.4*maxy
plot(x, y,type="b", pch=21, col="white",xaxt="n", lty=3, xlab="Tiempo(s)", ylab="Velocidad (m/s)")
axis(1,at=c(1:max(Vtiempovx1)))
mtext("Distancia (m)", side=4, line=3, cex.lab=1,las=0)
if(vmaxx>0.5){
axis(4, at= 1.5 + seq((miny-1.5),(maxy-1.5), by=.5),labels=round(seq(miny-1.5, maxy-1.5, by=.5),digits=2), las=2, tck=-.01)

lines((Vtiempovx1),maxvelx[1:length(Vtiempovx1)], type="overplotted",pch=1, col="blue")
lines((Vtiempovx3),1.5+maxpdxvel[1:length(Vtiempovx3)],type="overplotted", pch=4, col="black")

legend("topleft",legend=c("Velocidad mxima del paciente en el eje x(m/s)","Puntos deseados del paciente en el eje x(m)"),box.lty=1,pch=c(1,4),col=c("blue","black"))
}
if(vminx>0.5){
axis(4, at= 1.5 + seq((miny-1.5),(maxy-1.5), by=.5),labels=round(seq(miny-1.5, maxy-1.5, by=.5),digits=2), las=2, tck=-.01)
lines((Vtiempovx2),minvelx[1:length(Vtiempovx2)],type="overplotted", pch=2, col="red")
lines((Vtiempovx3),1.5+minpdxvel[1:length(Vtiempovx3)],type="overplotted", pch=4, col="black")

legend("topleft",legend=c("Velocidad mnima del paciente en el eje x(m/s)","Puntos deseados del paciente en el eje x(m)"),box.lty=1,pch=c(2,4),col=c("red","black"))
}
if(vmedx>0.5){
axis(4, at= 1.5 + seq((miny-1.5),(maxy-1.5), by=.5),labels=round(seq(miny-1.5, maxy-1.5, by=.5),digits=2), las=2, tck=-.01)
lines((Vtiempovx3),mediavelx[1:length(Vtiempovx3)],type="overplotted", pch=3, col="green")
lines((Vtiempovx3),1.5+mediapdxvel[1:length(Vtiempovx3)],type="overplotted", pch=4, col="black")

legend("topleft",legend=c("Velocidad media del paciente en el eje x(m/s)","Puntos deseados del paciente en el eje x(m)"),box.lty=1,pch=c(3,4),col=c("green","black"))
}
main<-"Velocidad del paciente en el eje x"
sub<-paste(" NTerapia: ",n,sep="")
title(main, sub)
dev.off()



