########################################################################################################################################################################################################
###Autor: Miguel Zatarain
###Fecha: 24/04/2015
###Velocidad en el eje y
###Script que va a calcular la velocidad en el eje y durante una terapia
############################################################################################################################
args <- commandArgs(TRUE)
require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")

vmedy<-as.numeric(args[4])
vmaxy<-as.numeric(args[2])
vminy<-as.numeric(args[3])
n<-as.numeric(args[5])

b<-paste("SELECT     IdMuestra, IdTerapia, Tiempo, VelocidadY, PuntoDeseadoX, PuntoDeseadoY
FROM         Muestra
WHERE     (IdTerapia = ",n,")
ORDER BY IdMuestra",sep="")

Data.fr <- sqlQuery(conn, b, errors=T)
attach(Data.fr)
a<-max(dim(Data.fr))


ti<-as.character(Tiempo)
s1 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[1])))
s2 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[2])))
s3 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[3])))
Vtiempois<-s1*3600+s2*60+s3
#Ya tenemos el tiempo en segundos
#Vamos a quitar los primeros 5 valores de cada columna porque tienen un error que puede llevar a errores
#Asignamos los valores de cada columna a una variable
Vtiempo<-Vtiempois[4:a]

vy<-VelocidadY
vy<-(vy[4:a])/1000



pdx<-PuntoDeseadoX
pdx<-(pdx[5:a])
pdy<-PuntoDeseadoY
pdy<-(pdy[5:a])
maxleng<-length(pdx)

#Calibramos la posicion del robot
pyo<-rep(600,a-4)
pyf<-(pyo-pdy)/1000



#Dado que el tiempo de muestro es distinto cada vez no nos da los mismo puntos exactos, asique para saber donde
#empieza una vuelta seleccionamos un pequeno area
Iniciox<-pdx[150]
Inicioy<-pdy[150]
filtro<-(1:maxleng)*0
for(i in 1:(maxleng)){ 
	if(Iniciox>(pdx[i]-30) & Inicioy>(pdy[i]-30) & Iniciox<(pdx[i]+30) & Inicioy<pdy[i]+30) {
	filtro[i]=i}
}

#Filtramos para que solo se produzcan varios de los puntos de ese area seguidos

filtrob<-filtro*0

for(i in 1:(maxleng)){
	if (i>110){
	if((filtro[i]!=0)&(filtro[i-1]!=0)&(filtro[i-2]!=0)&(filtro[i-3]!=0)&(filtro[i-4]!=0)&(filtro[i-5]!=0)&(filtro[i-6]!=0)){
	filtrob[i]=i}
	}
}

#Calculamos los lmites de inicio de cada vuelta
a=150
b<-1
limites<-vector()
for(i in 1:(maxleng)){ 
	if(filtrob[i]>a+650) {
		limites[b]=i
		b<-b+1
		a<-i}
}

#Inicializamos los vectores para calcular los puntos mximos mnimo y medio

Velocidadesy1<-vector()
Velocidadesy2<-vector()
mediavelycompara<-mean(abs(vy))
mediavely<-vy[limites[1]:limites[2]]
maxvely<-vy[limites[1]:limites[2]]
minvely<-vy[limites[1]:limites[2]]
minpdyvel<-pyf[limites[1]:limites[2]]
maxpdyvel<-pyf[limites[1]:limites[2]]
mediapdyvel<-pyf[limites[1]:limites[2]]
Vtiempovy1<-Vtiempo[limites[1]:limites[2]]
Vtiempovy2<-Vtiempo[limites[1]:limites[2]]
Vtiempovy3<-Vtiempo[limites[1]:limites[2]]

for(i in 1:(length(limites))){
	if(i<length(limites)-1){

			#Calculamos las velocidades
		
			Velocidadesy1<-vy[limites[i]:limites[i+1]]
			Velocidadesy2<-vy[limites[i+1]:limites[i+2]]			
			if(mean(abs(Velocidadesy1)) < mean(abs(Velocidadesy2)) & mean(abs(Velocidadesy2))>mean(abs(maxvely))){
			maxvely<-Velocidadesy2
			maxpdyvel<-pyf[limites[i+1]:limites[i+2]]
			Vtiempovy1<-Vtiempo[limites[i+1]:limites[i+2]]
			}
			
			if(mean(abs(Velocidadesy1))> mean(abs(Velocidadesy2))& mean(abs(Velocidadesy2))<mean(abs(minvely))){
			minvely<-Velocidadesy2
			minpdyvel<-pyf[limites[i+1]:limites[i+2]]
			Vtiempovy2<-Vtiempo[limites[i+1]:limites[i+2]]
			}

			if(abs(1-(abs(mean(abs(Velocidadesy1))/mediavelycompara))) > abs(1-(abs(mean(abs(Velocidadesy2))/mediavelycompara)))& abs(1-(abs(mean(abs(Velocidadesy2))/mediavelycompara)))< abs(1-(abs(mean(abs(mediavely))/mediavelycompara)))){
			mediavely<-Velocidadesy2
			mediapdyvel<-pyf[limites[i+1]:limites[i+2]]
			Vtiempovy3<-Vtiempo[limites[i+1]:limites[i+2]]
			}			
}
}

Vtiempovy1<-Vtiempovy1 - Vtiempovy1[1]
Vtiempovy2<-Vtiempovy2 - Vtiempovy2[1]
Vtiempovy3<-Vtiempovy3 - Vtiempovy3[1]

maxtiempo<-max(max(Vtiempovy1),max(Vtiempovy2),max(Vtiempovy3))

Vtiempovy1<-Vtiempovy1*maxtiempo/max(Vtiempovy1)
Vtiempovy2<-Vtiempovy2*maxtiempo/max(Vtiempovy2)
Vtiempovy3<-Vtiempovy3*maxtiempo/max(Vtiempovy3)

#Empezamos a graficar
#Calculamos el mayor valor de de y para el ploteo
maxy<-max(max(maxvely),max(minvely),max(mediavely),(1.5+max(mediapdyvel)))
miny<-min(min(maxvely),min(minvely),min(mediavely))


if(as.numeric(args[6])==0){
png(paste(args[1],"R\\VelocidadvyTerapia",n,".png",sep=""),width = 1147, height = 756, units = "px", pointsize = 16)

}
if(as.numeric(args[6])==1){
png(paste(args[1],"R\\Muestras1.png",sep=""),width = 1275, height = 450, units = "px", pointsize = 16)

}
if(as.numeric(args[6])==2){
png(paste(args[1],"R\\Muestras2.png",sep=""),width = 1275, height = 450, units = "px", pointsize = 16)

}

par(mar=c(5, 4, 4, 5) + 0.1)
x <- c(1,max(Vtiempovy1)); y <- c(miny,1.4*maxy);
maxy<-1.4*maxy
plot(x, y,type="b", pch=21, col="white",xaxt="n", lty=3, xlab="Tiempo(s)", ylab="Velocidad(m/s)")
axis(1,at=c(1:max(Vtiempovy1)))
mtext("Distancia (m)", side=4, line=3, cex.lab=1,las=0)

if(vmaxy>0.5){
axis(4, at= 1.5 + seq((miny-1.5),(maxy-1.5), by=.5),labels=round(seq(miny-1.5, maxy-1.5, by=.5),digits=2), las=2, tck=-.01)
lines((Vtiempovy1),maxvely[1:length(Vtiempovy1)], type="overplotted",pch=1, col="blue")
lines((Vtiempovy1),1.5+maxpdyvel[1:length(Vtiempovy1)],type="overplotted", pch=4, col="black")
legend("topleft",legend=c("Velocidad mxima del paciente en el eje y(m/s)","Puntos deseados del paciente en el eje y(m)"),box.lty=1,pch=c(1,4),col=c("blue","black"))

}
if(vminy>0.5){
axis(4, at= 1.5 + seq((miny-1.5),(maxy-1.5), by=.5),labels=round(seq(miny-1.5, maxy-1.5, by=.5),digits=2), las=2, tck=-.01)

lines((Vtiempovy2),minvely[1:length(Vtiempovy2)],type="overplotted", pch=2, col="red")
lines((Vtiempovy2),1.5+minpdyvel[1:length(Vtiempovy2)],type="overplotted", pch=4, col="black")
legend("topleft",legend=c("Velocidad mnima del paciente en el eje y(m/s)","Puntos deseados del paciente en el eje y(m)"),box.lty=1,pch=c(2,4),col=c("red","black"))

}
if(vmedy>0.5){
axis(4, at= 1.5 + seq((miny-1.5),(maxy-1.5), by=.5),labels=round(seq(miny-1.5, maxy-1.5, by=.5),digits=2), las=2, tck=-.01)

lines((Vtiempovy3),mediavely[1:length(Vtiempovy3)],type="overplotted", pch=3, col="green")
lines((Vtiempovy3),1.5+mediapdyvel[1:length(Vtiempovy3)],type="overplotted", pch=4, col="black")
legend("topleft",legend=c("Velocidad media del paciente en el eje y(m/s)","Puntos deseados del paciente en el eje y(m)"),box.lty=1,pch=c(3,4),col=c("green","black"))

}
#lines((Vtiempovy3),mediapdyvel[1:length(Vtiempovy3)],type="overplotted", pch=4, col="black")
main<-"Velocidad del paciente en el eje y"
sub<-paste(" NTerapia: ",n,sep="")
title(main, sub)
dev.off()

rm(sub,main,x,y,maxy,maxtiempo,miny,vmaxy,vminy,vmedy,Velocidadesy1,Velocidadesy2,mediavelycompara,mediavely,maxvely,minvely,minpdyvel,maxpdyvel,mediapdyvel,Vtiempovy1,Vtiempovy2,Vtiempovy3,limites,filtro,i,a,b,n,filtrob,maxleng,pdx,pdy,pyo,pyf,vy,Iniciox,Inicioy,Vtiempo,Vtiempois,ti,s1,s2,s3,b,Data.fr)

