########################################################################################################################################################################################################
###Autor: Miguel Zatarain
###Fecha: 04/05/2015
###Velocidad en el eje x
###Script que va a calcular la velocidad en el eje x durante una terapia en funcion del tiempo
############################################################################################################################
#Obtenemos los valores de la tabla para seleccionar la terapia la identidad del paciente y el tipo de terapia que queremos
args <- commandArgs(TRUE)
require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")
#Valores de tiempo y numero de terapia
tminx<-as.numeric(args[2])
tmaxx<-as.numeric(args[3])
n<-as.numeric(args[4])


#Accedemos a la tabla para obtener los valores
b<-paste("SELECT     IdMuestra, PosicionX, IdTerapia, VelocidadX, Tiempo, PuntoDeseadoX
FROM         Muestra
WHERE     (IdTerapia = ",n,")
ORDER BY IdMuestra",sep="")


Data.fr <- sqlQuery(conn, b, errors=T)
attach(Data.fr)
a<-max(dim(Data.fr))   #miramos la longitud de a
 
#Calculamos el tiempo
ti<-as.character(Tiempo)
s1 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[1])))
s2 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[2])))
s3 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[3])))
Vtiempois<-s1*3600+s2*60+s3
#Ya tenemos el tiempo en segundos
#Vamos a quitar los primeros 5 valores de cada columna porque tienen un error que puede llevar a errores
#Asignamos los valores de cada columna a una variable
Vtiempo<-Vtiempois[4:a]

#pasamos las variables de la tabla a variables internas

vx<-VelocidadX
vx<-(vx[5:a])/1000
px<-PosicionX
px<-(px[5:a])/1000

pdx<-PuntoDeseadoX
pdx<-(pdx[5:a])

maxleng<-length(pdx)
#Calibramos la posicion del robot
pxo<-(rep(1,a-4))
pxf<-(pdx+pxo)/1000

#hacemos un filtro para coger solo los valotes en el tiempo que tenemos
filtro<-(maxleng:1)*0

for(i in 1:maxleng){
	if((Vtiempo[i]< tmaxx) & (Vtiempo[i]>tminx)){
		filtro[i]<-i
		print("a3");

	}else{
	filtro[i]<-0}
}
#A veces en los valores iniciales da un error de na, asique lo correguimos


vx<-vx[filtro]
tiempo<-Vtiempo[filtro]
pxf<-pxf[filtro]
px<-px[filtro]


#graficamos

if(as.numeric(args[5])==0){
png(paste(args[1],"R\\VelocidadxTerapia",n,".png",sep=""),width = 1147, height = 756, units = "px", pointsize = 16)

}
if(as.numeric(args[5])==1){
png(paste(args[1],"R\\Muestras1.png",sep=""),width = 1700, height = 600, units = "px", pointsize = 16)

}
if(as.numeric(args[5])==2){
png(paste(args[1],"R\\Muestras2.png",sep=""),width = 1700, height = 600, units = "px", pointsize = 16)

}

maxy<-max(max(px),max(pxf))
miny<-min(min(px),min(pxf))
par(mfrow=c(2,1))
x <- c(min(tiempo),max(tiempo)); y <- c(miny,1.4*maxy);
plot(x, y,type="b", pch=21, col="white", lty=3, xlab="Tiempo(s)", ylab="Desplazamiento(m)")
lines((tiempo),pxf[1:length(tiempo)],type="overplotted", pch=2, col="red")
lines((tiempo),px[1:length(tiempo)],type="overplotted", pch=1, col="green")
main<-"Desplazamiento del paciente en el eje x "
sub<-paste("")
title(main, sub)
legend("topleft",legend=c("Puntos realizados por el paciente en el eje x (m)","Puntos deseados del paciente en el eje x(m)"),box.lty=1,pch=c(1,2),col=c("green","red"))



maxy<-max(vx)
miny<-min(vx)
x <- c(min(tiempo),max(tiempo)); y <- c(miny,1.4*maxy);
plot(x, y,type="b", pch=21, col="white", lty=3, xlab="Tiempo(s)", ylab="Velocidad (m/s)")
lines((tiempo),vx[1:length(tiempo)], type="overplotted",pch=1, col="blue",xlab="Tiempo(s)", ylab="Velocidad en el eje x(m/s)")
main<-"Velocidad del paciente en el eje x"
sub<-paste(" NTerapia: ",n,sep="")
title(main, sub)
legend("topleft",legend=c("Velocidad del paciente en el eje x (m/s)"),box.lty=1,pch=c(1),col=c("blue"))

dev.off()

#rm(sub,maxy,miny,main,x,y,pdx,vx,conn,tiempo,i,maxleng,filtro,Vtiempo,tmaxx,tminx,pxf,pxo,Vtiempois,ti,s1,s2,s3,Data.fr,a,b,n)

