########################################################################################################################################################################################################
###Autor: Miguel Zatarain
###Fecha: 04/05/2015
###Velocidad en el eje y
###Script que va a calcular la velocidad en el eje y durante una terapia en funcin del tiempo
############################################################################################################################
#Obtenemos los valores de la tabla para seleccionar la terapia la identidad del paciente y el tipo de terapia que queremos
args <- commandArgs(TRUE)
require(RODBC)
conn <- odbcDriverConnect("driver=SQL Server;database=BeataMaria;server=ZARU\\SQLEXPRESS;uid=sistac;pwd=sistac")

#Valores de tiempo y numero de terapia

tminy<-as.numeric(args[2])
tmaxy<-as.numeric(args[3])
n<-as.numeric(args[4])

#Accedemos a la tabla para obtener los valores
b<-paste("SELECT     IdMuestra, PosicionY, IdTerapia, VelocidadY, Tiempo, PuntoDeseadoY
FROM         Muestra
WHERE     (IdTerapia = ",n,")
ORDER BY IdMuestra",sep="")

Data.fr <- sqlQuery(conn, b, errors=T)
attach(Data.fr)
a<-max(dim(Data.fr))   #miramos la longitud de a
 
#Calculamos el tiempo
ti<-as.character(Tiempo)
s1 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[1])))
s2 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[2])))
s3 <- as.numeric(sapply(strsplit(ti, split=':', fixed=TRUE), function(x) (x[3])))
Vtiempois<-s1*3600+s2*60+s3
#Ya tenemos el tiempo en segundos
#Vamos a quitar los primeros 5 valores de cada columna porque tienen un error que puede llevar a errores
#Asignamos los valores de cada columna a una variable
Vtiempo<-Vtiempois[4:a]

#pasamos las variables de la tabla a variables internas

vy<-VelocidadY
vy<-(vy[5:a])/1000
py<-PosicionY
py<-(py[5:a])/1000
pdy<-PuntoDeseadoY
pdy<-(pdy[5:a])

maxleng<-length(pdy)
#Calibramos la posicion del robot
pyo<-rep(600,a-4)
pyf<-(pyo-pdy)/1000

#hacemos un filtro para coger solo los valotes en el tiempo que tenemos
filtro<-(maxleng:1)*0

for(i in 1:maxleng){
	if((Vtiempo[i]< tmaxy) & (Vtiempo[i]>tminy)){
		filtro[i]<-i
	}
}

#A veces en los valores iniciales da un error de na, asique lo correguimos

vy<-vy[filtro]
tiempo<-Vtiempo[filtro]
pyf<-pyf[filtro]
py<-py[filtro]

#graficamos

if(as.numeric(args[5])==0){
png(paste(args[1],"R\\VelocidadyTerapia",n,".png",sep=""),width = 1147, height = 756, units = "px", pointsize = 16)

}
if(as.numeric(args[5])==1){
png(paste(args[1],"R\\Muestras1.png",sep=""),width = 1700, height = 600, units = "px", pointsize = 16)

}
if(as.numeric(args[5])==2){
png(paste(args[1],"R\\Muestras2.png",sep=""),width = 1700, height = 600, units = "px", pointsize = 16)

}


maxy<-max(max(py),max(pyf))
miny<-min(min(py),min(pyf))
par(mfrow=c(2,1))
x <- c(min(tiempo),max(tiempo)); y <- c(miny,1.4*maxy);
plot(x, y,type="b", pch=21, col="white", lty=3, xlab="Tiempo(s)", ylab="Desplazamiento(m)")
lines((tiempo),pyf[1:length(tiempo)],type="overplotted", pch=2, col="red")
lines((tiempo),py[1:length(tiempo)],type="overplotted", pch=1, col="green")
main<-"Desplazamiento del paciente en el eje y "
sub<-paste("")
title(main, sub)
legend("topleft",legend=c("Puntos realizados por el paciente en el eje y","Puntos deseados del paciente en el eje y"),box.lty=1,pch=c(1,2),col=c("green","red"))


maxy<-max(vy)
miny<-min(vy)
x <- c(min(tiempo),max(tiempo)); y <- c(miny,1.4*maxy);
plot(x, y,type="b", pch=21, col="white", lty=3, xlab="Tiempo(s)", ylab="Velocidad(m/s)")
lines((tiempo),vy[1:length(tiempo)], type="overplotted",pch=1, col="blue",xlab="Tiempo(s)", ylab="Velocidad(m/s)")
main<-"Velocidad del paciente en el eje y"
sub<-paste(" NTerapia: ",n,sep="")
title(main, sub)
legend("topleft",legend=c("Velocidad del paciente en el eje y"),box.lty=1,pch=c(1),col=c("blue"))
dev.off()

rm(sub,py,conn,maxy,miny,main,x,y,pdy,vy,tiempo,i,maxleng,filtro,Vtiempo,tmaxy,tminy,pyf,pyo,Vtiempois,ti,s1,s2,s3,Data.fr,a,b,n)

